#line 439 "filter/decl.m4"


#if defined(__GNUC__) && __GNUC__ >= 6
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmisleading-indentation"
#endif

#include "nest/bird.h"
#include "filter/filter.h"
#include "filter/f-inst.h"

/* Instruction codes to string */
static const char * const f_instruction_name_str[] = {
#line 227 "filter/f-inst.c"
 /* Code enum to string for FI_ADD */
#line 227
  [FI_ADD] = "FI_ADD",
#line 232 "filter/f-inst.c"
 /* Code enum to string for FI_SUBTRACT */
#line 232
  [FI_SUBTRACT] = "FI_SUBTRACT",
#line 237 "filter/f-inst.c"
 /* Code enum to string for FI_MULTIPLY */
#line 237
  [FI_MULTIPLY] = "FI_MULTIPLY",
#line 243 "filter/f-inst.c"
 /* Code enum to string for FI_DIVIDE */
#line 243
  [FI_DIVIDE] = "FI_DIVIDE",
#line 253 "filter/f-inst.c"
 /* Code enum to string for FI_AND */
#line 253
  [FI_AND] = "FI_AND",
#line 264 "filter/f-inst.c"
 /* Code enum to string for FI_OR */
#line 264
  [FI_OR] = "FI_OR",
#line 274 "filter/f-inst.c"
 /* Code enum to string for FI_PAIR_CONSTRUCT */
#line 274
  [FI_PAIR_CONSTRUCT] = "FI_PAIR_CONSTRUCT",
#line 314 "filter/f-inst.c"
 /* Code enum to string for FI_EC_CONSTRUCT */
#line 314
  [FI_EC_CONSTRUCT] = "FI_EC_CONSTRUCT",
#line 321 "filter/f-inst.c"
 /* Code enum to string for FI_LC_CONSTRUCT */
#line 321
  [FI_LC_CONSTRUCT] = "FI_LC_CONSTRUCT",
#line 371 "filter/f-inst.c"
 /* Code enum to string for FI_PATHMASK_CONSTRUCT */
#line 371
  [FI_PATHMASK_CONSTRUCT] = "FI_PATHMASK_CONSTRUCT",
#line 377 "filter/f-inst.c"
 /* Code enum to string for FI_NEQ */
#line 377
  [FI_NEQ] = "FI_NEQ",
#line 383 "filter/f-inst.c"
 /* Code enum to string for FI_EQ */
#line 383
  [FI_EQ] = "FI_EQ",
#line 394 "filter/f-inst.c"
 /* Code enum to string for FI_LT */
#line 394
  [FI_LT] = "FI_LT",
#line 405 "filter/f-inst.c"
 /* Code enum to string for FI_LTE */
#line 405
  [FI_LTE] = "FI_LTE",
#line 410 "filter/f-inst.c"
 /* Code enum to string for FI_NOT */
#line 410
  [FI_NOT] = "FI_NOT",
#line 419 "filter/f-inst.c"
 /* Code enum to string for FI_MATCH */
#line 419
  [FI_MATCH] = "FI_MATCH",
#line 428 "filter/f-inst.c"
 /* Code enum to string for FI_NOT_MATCH */
#line 428
  [FI_NOT_MATCH] = "FI_NOT_MATCH",
#line 433 "filter/f-inst.c"
 /* Code enum to string for FI_DEFINED */
#line 433
  [FI_DEFINED] = "FI_DEFINED",
#line 445 "filter/f-inst.c"
 /* Code enum to string for FI_TYPE */
#line 445
  [FI_TYPE] = "FI_TYPE",
#line 451 "filter/f-inst.c"
 /* Code enum to string for FI_IS_V4 */
#line 451
  [FI_IS_V4] = "FI_IS_V4",
#line 460 "filter/f-inst.c"
 /* Code enum to string for FI_VAR_SET */
#line 460
  [FI_VAR_SET] = "FI_VAR_SET",
#line 467 "filter/f-inst.c"
 /* Code enum to string for FI_VAR_GET */
#line 467
  [FI_VAR_GET] = "FI_VAR_GET",
#line 480 "filter/f-inst.c"
 /* Code enum to string for FI_CONSTANT */
#line 480
  [FI_CONSTANT] = "FI_CONSTANT",
#line 488 "filter/f-inst.c"
 /* Code enum to string for FI_CONDITION */
#line 488
  [FI_CONDITION] = "FI_CONDITION",
#line 497 "filter/f-inst.c"
 /* Code enum to string for FI_PRINT */
#line 497
  [FI_PRINT] = "FI_PRINT",
#line 504 "filter/f-inst.c"
 /* Code enum to string for FI_FLUSH */
#line 504
  [FI_FLUSH] = "FI_FLUSH",
#line 518 "filter/f-inst.c"
 /* Code enum to string for FI_DIE */
#line 518
  [FI_DIE] = "FI_DIE",
#line 544 "filter/f-inst.c"
 /* Code enum to string for FI_RTA_GET */
#line 544
  [FI_RTA_GET] = "FI_RTA_GET",
#line 646 "filter/f-inst.c"
 /* Code enum to string for FI_RTA_SET */
#line 646
  [FI_RTA_SET] = "FI_RTA_SET",
#line 721 "filter/f-inst.c"
 /* Code enum to string for FI_EA_GET */
#line 721
  [FI_EA_GET] = "FI_EA_GET",
#line 785 "filter/f-inst.c"
 /* Code enum to string for FI_EA_SET */
#line 785
  [FI_EA_SET] = "FI_EA_SET",
#line 807 "filter/f-inst.c"
 /* Code enum to string for FI_EA_UNSET */
#line 807
  [FI_EA_UNSET] = "FI_EA_UNSET",
#line 812 "filter/f-inst.c"
 /* Code enum to string for FI_PREF_GET */
#line 812
  [FI_PREF_GET] = "FI_PREF_GET",
#line 821 "filter/f-inst.c"
 /* Code enum to string for FI_PREF_SET */
#line 821
  [FI_PREF_SET] = "FI_PREF_SET",
#line 833 "filter/f-inst.c"
 /* Code enum to string for FI_LENGTH */
#line 833
  [FI_LENGTH] = "FI_LENGTH",
#line 868 "filter/f-inst.c"
 /* Code enum to string for FI_NET_SRC */
#line 868
  [FI_NET_SRC] = "FI_NET_SRC",
#line 903 "filter/f-inst.c"
 /* Code enum to string for FI_NET_DST */
#line 903
  [FI_NET_DST] = "FI_NET_DST",
#line 913 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_MAXLEN */
#line 913
  [FI_ROA_MAXLEN] = "FI_ROA_MAXLEN",
#line 940 "filter/f-inst.c"
 /* Code enum to string for FI_ASN */
#line 940
  [FI_ASN] = "FI_ASN",
#line 945 "filter/f-inst.c"
 /* Code enum to string for FI_IP */
#line 945
  [FI_IP] = "FI_IP",
#line 952 "filter/f-inst.c"
 /* Code enum to string for FI_ROUTE_DISTINGUISHER */
#line 952
  [FI_ROUTE_DISTINGUISHER] = "FI_ROUTE_DISTINGUISHER",
#line 959 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_FIRST */
#line 959
  [FI_AS_PATH_FIRST] = "FI_AS_PATH_FIRST",
#line 966 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_LAST */
#line 966
  [FI_AS_PATH_LAST] = "FI_AS_PATH_LAST",
#line 971 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_LAST_NAG */
#line 971
  [FI_AS_PATH_LAST_NAG] = "FI_AS_PATH_LAST_NAG",
#line 976 "filter/f-inst.c"
 /* Code enum to string for FI_PAIR_DATA */
#line 976
  [FI_PAIR_DATA] = "FI_PAIR_DATA",
#line 981 "filter/f-inst.c"
 /* Code enum to string for FI_LC_DATA1 */
#line 981
  [FI_LC_DATA1] = "FI_LC_DATA1",
#line 986 "filter/f-inst.c"
 /* Code enum to string for FI_LC_DATA2 */
#line 986
  [FI_LC_DATA2] = "FI_LC_DATA2",
#line 1020 "filter/f-inst.c"
 /* Code enum to string for FI_MIN */
#line 1020
  [FI_MIN] = "FI_MIN",
#line 1054 "filter/f-inst.c"
 /* Code enum to string for FI_MAX */
#line 1054
  [FI_MAX] = "FI_MAX",
#line 1080 "filter/f-inst.c"
 /* Code enum to string for FI_RETURN */
#line 1080
  [FI_RETURN] = "FI_RETURN",
#line 1110 "filter/f-inst.c"
 /* Code enum to string for FI_CALL */
#line 1110
  [FI_CALL] = "FI_CALL",
#line 1115 "filter/f-inst.c"
 /* Code enum to string for FI_DROP_RESULT */
#line 1115
  [FI_DROP_RESULT] = "FI_DROP_RESULT",
#line 1138 "filter/f-inst.c"
 /* Code enum to string for FI_SWITCH */
#line 1138
  [FI_SWITCH] = "FI_SWITCH",
#line 1146 "filter/f-inst.c"
 /* Code enum to string for FI_IP_MASK */
#line 1146
  [FI_IP_MASK] = "FI_IP_MASK",
#line 1152 "filter/f-inst.c"
 /* Code enum to string for FI_PATH_PREPEND */
#line 1152
  [FI_PATH_PREPEND] = "FI_PATH_PREPEND",
#line 1209 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_ADD */
#line 1209
  [FI_CLIST_ADD] = "FI_CLIST_ADD",
#line 1271 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_DEL */
#line 1271
  [FI_CLIST_DEL] = "FI_CLIST_DEL",
#line 1319 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_FILTER */
#line 1319
  [FI_CLIST_FILTER] = "FI_CLIST_FILTER",
#line 1349 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_CHECK_IMPLICIT */
#line 1349
  [FI_ROA_CHECK_IMPLICIT] = "FI_ROA_CHECK_IMPLICIT",
#line 1371 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_CHECK_EXPLICIT */
#line 1371
  [FI_ROA_CHECK_EXPLICIT] = "FI_ROA_CHECK_EXPLICIT",
#line 1376 "filter/f-inst.c"
 /* Code enum to string for FI_FORMAT */
#line 1376
  [FI_FORMAT] = "FI_FORMAT",
#line 668 "filter/decl.m4"
 /* Code enum to string for FI_ASSERT */
#line 668
  [FI_ASSERT] = "FI_ASSERT",
#line 452 "filter/decl.m4"

};

const char *
f_instruction_name_(enum f_instruction_code fi)
{
  if (fi < (sizeof(f_instruction_name_str) / sizeof(f_instruction_name_str[0])))
    return f_instruction_name_str[fi];
  else
    bug("Got unknown instruction code: %d", fi);
}

static inline struct f_inst *
fi_new(enum f_instruction_code fi_code)
{
  struct f_inst *what = cfg_allocz(sizeof(struct f_inst));
  what->lineno = ifs->lino;
  what->size = 1;
  what->fi_code = fi_code;
  return what;
}

static inline struct f_inst *
fi_constant(struct f_inst *what, struct f_val val)
{
  what->fi_code = FI_CONSTANT;
  what->i_FI_CONSTANT.val = val;
  return what;
}

static int
f_const_promotion(struct f_inst *arg, enum f_type want)
{
  if (arg->fi_code != FI_CONSTANT)
    return 0;

  struct f_val *c = &arg->i_FI_CONSTANT.val;

  if ((c->type == T_IP) && ipa_is_ip4(c->val.ip) && (want == T_QUAD)) {
    *c = (struct f_val) {
      .type = T_QUAD,
      .val.i = ipa_to_u32(c->val.ip),
    };
    return 1;
  }

  return 0;
}

#define v1 whati->f1->i_FI_CONSTANT.val
#define v2 whati->f2->i_FI_CONSTANT.val
#define v3 whati->f3->i_FI_CONSTANT.val
#define vv(i) items[i]->i_FI_CONSTANT.val
#define runtime(fmt, ...) cf_error("filter preevaluation, line %d: " fmt, ifs->lino, ##__VA_ARGS__)
#define fpool cfg_mem
#define falloc(size) cfg_alloc(size)
/* Instruction constructors */
#line 227 "filter/f-inst.c"
 /* Constructor for FI_ADD */
#line 227
struct f_inst *f_new_inst_FI_ADD(enum f_instruction_code fi_code
#line 223 "filter/f-inst.c"
  , struct f_inst * f1
#line 224 "filter/f-inst.c"
  , struct f_inst * f2
#line 227 "filter/f-inst.c"
)
#line 227
  {
#line 227
    /* Allocate the structure */
#line 227
    struct f_inst *what = fi_new(fi_code);
#line 227
    uint constargs = 1;
#line 227

#line 227
    /* Initialize all the members */
#line 227
  #define whati (&(what->i_FI_ADD))
#line 227
  #line 223 "filter/f-inst.c"
whati->f1 = f1;
#line 223
for (const struct f_inst *child = f1; child; child = child->next) {
#line 223
  what->size += child->size;
#line 223

#line 223
  if (child->fi_code != FI_CONSTANT)
#line 223
    constargs = 0;
#line 223

#line 223
}
#line 223 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 223
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 223
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 224 "filter/f-inst.c"
whati->f2 = f2;
#line 224
for (const struct f_inst *child = f2; child; child = child->next) {
#line 224
  what->size += child->size;
#line 224

#line 224
  if (child->fi_code != FI_CONSTANT)
#line 224
    constargs = 0;
#line 224

#line 224
}
#line 224 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 224
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 224
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 225 "filter/f-inst.c"
what->type = T_INT;

#line 227 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 227
    if (!constargs)
#line 227
      return what;
#line 227

#line 227
    /* Try to pre-calculate the result */
#line 227
    #line 222 "filter/f-inst.c"
 {
    
#line 223 "filter/f-inst.c"
 
#line 223 "filter/f-inst.c"
 
#line 223 "filter/f-inst.c"
;
    
#line 224 "filter/f-inst.c"
 
#line 224 "filter/f-inst.c"
 
#line 224 "filter/f-inst.c"
;
     
#line 225 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i + v2.val.i } );
  }
  
  #undef whati
#line 227 "filter/f-inst.c"
  }
#line 227

#line 227

#line 232 "filter/f-inst.c"
 /* Constructor for FI_SUBTRACT */
#line 232
struct f_inst *f_new_inst_FI_SUBTRACT(enum f_instruction_code fi_code
#line 228 "filter/f-inst.c"
  , struct f_inst * f1
#line 229 "filter/f-inst.c"
  , struct f_inst * f2
#line 232 "filter/f-inst.c"
)
#line 232
  {
#line 232
    /* Allocate the structure */
#line 232
    struct f_inst *what = fi_new(fi_code);
#line 232
    uint constargs = 1;
#line 232

#line 232
    /* Initialize all the members */
#line 232
  #define whati (&(what->i_FI_SUBTRACT))
#line 232
  #line 228 "filter/f-inst.c"
whati->f1 = f1;
#line 228
for (const struct f_inst *child = f1; child; child = child->next) {
#line 228
  what->size += child->size;
#line 228

#line 228
  if (child->fi_code != FI_CONSTANT)
#line 228
    constargs = 0;
#line 228

#line 228
}
#line 228 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 228
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 228
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 229 "filter/f-inst.c"
whati->f2 = f2;
#line 229
for (const struct f_inst *child = f2; child; child = child->next) {
#line 229
  what->size += child->size;
#line 229

#line 229
  if (child->fi_code != FI_CONSTANT)
#line 229
    constargs = 0;
#line 229

#line 229
}
#line 229 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 229
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 229
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 230 "filter/f-inst.c"
what->type = T_INT;

#line 232 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 232
    if (!constargs)
#line 232
      return what;
#line 232

#line 232
    /* Try to pre-calculate the result */
#line 232
    #line 227 "filter/f-inst.c"
 {
    
#line 228 "filter/f-inst.c"
 
#line 228 "filter/f-inst.c"
 
#line 228 "filter/f-inst.c"
;
    
#line 229 "filter/f-inst.c"
 
#line 229 "filter/f-inst.c"
 
#line 229 "filter/f-inst.c"
;
     
#line 230 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i - v2.val.i } );
  }
  
  #undef whati
#line 232 "filter/f-inst.c"
  }
#line 232

#line 232

#line 237 "filter/f-inst.c"
 /* Constructor for FI_MULTIPLY */
#line 237
struct f_inst *f_new_inst_FI_MULTIPLY(enum f_instruction_code fi_code
#line 233 "filter/f-inst.c"
  , struct f_inst * f1
#line 234 "filter/f-inst.c"
  , struct f_inst * f2
#line 237 "filter/f-inst.c"
)
#line 237
  {
#line 237
    /* Allocate the structure */
#line 237
    struct f_inst *what = fi_new(fi_code);
#line 237
    uint constargs = 1;
#line 237

#line 237
    /* Initialize all the members */
#line 237
  #define whati (&(what->i_FI_MULTIPLY))
#line 237
  #line 233 "filter/f-inst.c"
whati->f1 = f1;
#line 233
for (const struct f_inst *child = f1; child; child = child->next) {
#line 233
  what->size += child->size;
#line 233

#line 233
  if (child->fi_code != FI_CONSTANT)
#line 233
    constargs = 0;
#line 233

#line 233
}
#line 233 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 233
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 233
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 234 "filter/f-inst.c"
whati->f2 = f2;
#line 234
for (const struct f_inst *child = f2; child; child = child->next) {
#line 234
  what->size += child->size;
#line 234

#line 234
  if (child->fi_code != FI_CONSTANT)
#line 234
    constargs = 0;
#line 234

#line 234
}
#line 234 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 234
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 234
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 235 "filter/f-inst.c"
what->type = T_INT;

#line 237 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 237
    if (!constargs)
#line 237
      return what;
#line 237

#line 237
    /* Try to pre-calculate the result */
#line 237
    #line 232 "filter/f-inst.c"
 {
    
#line 233 "filter/f-inst.c"
 
#line 233 "filter/f-inst.c"
 
#line 233 "filter/f-inst.c"
;
    
#line 234 "filter/f-inst.c"
 
#line 234 "filter/f-inst.c"
 
#line 234 "filter/f-inst.c"
;
     
#line 235 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i * v2.val.i } );
  }
  
  #undef whati
#line 237 "filter/f-inst.c"
  }
#line 237

#line 237

#line 243 "filter/f-inst.c"
 /* Constructor for FI_DIVIDE */
#line 243
struct f_inst *f_new_inst_FI_DIVIDE(enum f_instruction_code fi_code
#line 238 "filter/f-inst.c"
  , struct f_inst * f1
#line 239 "filter/f-inst.c"
  , struct f_inst * f2
#line 243 "filter/f-inst.c"
)
#line 243
  {
#line 243
    /* Allocate the structure */
#line 243
    struct f_inst *what = fi_new(fi_code);
#line 243
    uint constargs = 1;
#line 243

#line 243
    /* Initialize all the members */
#line 243
  #define whati (&(what->i_FI_DIVIDE))
#line 243
  #line 238 "filter/f-inst.c"
whati->f1 = f1;
#line 238
for (const struct f_inst *child = f1; child; child = child->next) {
#line 238
  what->size += child->size;
#line 238

#line 238
  if (child->fi_code != FI_CONSTANT)
#line 238
    constargs = 0;
#line 238

#line 238
}
#line 238 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 238
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 238
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 239 "filter/f-inst.c"
whati->f2 = f2;
#line 239
for (const struct f_inst *child = f2; child; child = child->next) {
#line 239
  what->size += child->size;
#line 239

#line 239
  if (child->fi_code != FI_CONSTANT)
#line 239
    constargs = 0;
#line 239

#line 239
}
#line 239 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 239
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 239
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 241 "filter/f-inst.c"
what->type = T_INT;

#line 243 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 243
    if (!constargs)
#line 243
      return what;
#line 243

#line 243
    /* Try to pre-calculate the result */
#line 243
    #line 237 "filter/f-inst.c"
 {
    
#line 238 "filter/f-inst.c"
 
#line 238 "filter/f-inst.c"
 
#line 238 "filter/f-inst.c"
;
    
#line 239 "filter/f-inst.c"
 
#line 239 "filter/f-inst.c"
 
#line 239 "filter/f-inst.c"
;
    if (v2.val.i == 0) runtime( "Mother told me not to divide by 0" );
     
#line 241 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i / v2.val.i } );
  }
  
  #undef whati
#line 243 "filter/f-inst.c"
  }
#line 243

#line 243

#line 253 "filter/f-inst.c"
 /* Constructor for FI_AND */
#line 253
struct f_inst *f_new_inst_FI_AND(enum f_instruction_code fi_code
#line 244 "filter/f-inst.c"
  , struct f_inst * f1
#line 249 "filter/f-inst.c"
  , struct f_inst * f2
#line 253 "filter/f-inst.c"
)
#line 253
  {
#line 253
    /* Allocate the structure */
#line 253
    struct f_inst *what = fi_new(fi_code);
#line 253
    uint constargs = 1;
#line 253

#line 253
    /* Initialize all the members */
#line 253
  #define whati (&(what->i_FI_AND))
#line 253
  #line 244 "filter/f-inst.c"
whati->f1 = f1;
#line 244
for (const struct f_inst *child = f1; child; child = child->next) {
#line 244
  what->size += child->size;
#line 244

#line 244
  if (child->fi_code != FI_CONSTANT)
#line 244
    constargs = 0;
#line 244

#line 244
}
#line 244 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 244
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 244
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 245 "filter/f-inst.c"
if (f2->type && (f2->type != (T_BOOL)) && !f_const_promotion(f2, (T_BOOL)))
#line 245
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 245
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f2->type));
#line 246 "filter/f-inst.c"
what->type = T_BOOL;
#line 249 "filter/f-inst.c"
whati->f2 = f2;

#line 253 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 253
    if (!constargs)
#line 253
      return what;
#line 253

#line 253
    /* Try to pre-calculate the result */
#line 253
    #line 243 "filter/f-inst.c"
 {
    
#line 244 "filter/f-inst.c"
 
#line 244 "filter/f-inst.c"
 
#line 244 "filter/f-inst.c"
;
    
#line 245 "filter/f-inst.c"
;
     
#line 246 "filter/f-inst.c"
;

    if (v1.val.i)
      
#line 249 "filter/f-inst.c"
return whati->f2
#line 249
;
    else
      return fi_constant(what, v1);
  }
  
  #undef whati
#line 253 "filter/f-inst.c"
  }
#line 253

#line 253

#line 264 "filter/f-inst.c"
 /* Constructor for FI_OR */
#line 264
struct f_inst *f_new_inst_FI_OR(enum f_instruction_code fi_code
#line 254 "filter/f-inst.c"
  , struct f_inst * f1
#line 259 "filter/f-inst.c"
  , struct f_inst * f2
#line 264 "filter/f-inst.c"
)
#line 264
  {
#line 264
    /* Allocate the structure */
#line 264
    struct f_inst *what = fi_new(fi_code);
#line 264
    uint constargs = 1;
#line 264

#line 264
    /* Initialize all the members */
#line 264
  #define whati (&(what->i_FI_OR))
#line 264
  #line 254 "filter/f-inst.c"
whati->f1 = f1;
#line 254
for (const struct f_inst *child = f1; child; child = child->next) {
#line 254
  what->size += child->size;
#line 254

#line 254
  if (child->fi_code != FI_CONSTANT)
#line 254
    constargs = 0;
#line 254

#line 254
}
#line 254 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 254
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 254
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 255 "filter/f-inst.c"
if (f2->type && (f2->type != (T_BOOL)) && !f_const_promotion(f2, (T_BOOL)))
#line 255
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 255
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f2->type));
#line 256 "filter/f-inst.c"
what->type = T_BOOL;
#line 259 "filter/f-inst.c"
whati->f2 = f2;

#line 264 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 264
    if (!constargs)
#line 264
      return what;
#line 264

#line 264
    /* Try to pre-calculate the result */
#line 264
    #line 253 "filter/f-inst.c"
 {
    
#line 254 "filter/f-inst.c"
 
#line 254 "filter/f-inst.c"
 
#line 254 "filter/f-inst.c"
;
    
#line 255 "filter/f-inst.c"
;
     
#line 256 "filter/f-inst.c"
;

    if (!v1.val.i)
      
#line 259 "filter/f-inst.c"
return whati->f2
#line 259
;
    else
      return fi_constant(what, v1);
  }

  
  #undef whati
#line 264 "filter/f-inst.c"
  }
#line 264

#line 264

#line 274 "filter/f-inst.c"
 /* Constructor for FI_PAIR_CONSTRUCT */
#line 274
struct f_inst *f_new_inst_FI_PAIR_CONSTRUCT(enum f_instruction_code fi_code
#line 265 "filter/f-inst.c"
  , struct f_inst * f1
#line 266 "filter/f-inst.c"
  , struct f_inst * f2
#line 274 "filter/f-inst.c"
)
#line 274
  {
#line 274
    /* Allocate the structure */
#line 274
    struct f_inst *what = fi_new(fi_code);
#line 274
    uint constargs = 1;
#line 274

#line 274
    /* Initialize all the members */
#line 274
  #define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 274
  #line 265 "filter/f-inst.c"
whati->f1 = f1;
#line 265
for (const struct f_inst *child = f1; child; child = child->next) {
#line 265
  what->size += child->size;
#line 265

#line 265
  if (child->fi_code != FI_CONSTANT)
#line 265
    constargs = 0;
#line 265

#line 265
}
#line 265 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 265
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 265
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 266 "filter/f-inst.c"
whati->f2 = f2;
#line 266
for (const struct f_inst *child = f2; child; child = child->next) {
#line 266
  what->size += child->size;
#line 266

#line 266
  if (child->fi_code != FI_CONSTANT)
#line 266
    constargs = 0;
#line 266

#line 266
}
#line 266 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 266
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 266
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 271 "filter/f-inst.c"
what->type = T_PAIR;

#line 274 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 274
    if (!constargs)
#line 274
      return what;
#line 274

#line 274
    /* Try to pre-calculate the result */
#line 274
    #line 264 "filter/f-inst.c"
 {
    
#line 265 "filter/f-inst.c"
 
#line 265 "filter/f-inst.c"
 
#line 265 "filter/f-inst.c"
;
    
#line 266 "filter/f-inst.c"
 
#line 266 "filter/f-inst.c"
 
#line 266 "filter/f-inst.c"
;
    uint u1 = v1.val.i;
    uint u2 = v2.val.i;
    if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
      runtime( "Can't operate with value out of bounds in pair constructor" );
     
#line 271 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_PAIR, .val.i = (u1 << 16) | u2 } );
  }

  
  #undef whati
#line 274 "filter/f-inst.c"
  }
#line 274

#line 274

#line 314 "filter/f-inst.c"
 /* Constructor for FI_EC_CONSTRUCT */
#line 314
struct f_inst *f_new_inst_FI_EC_CONSTRUCT(enum f_instruction_code fi_code
#line 275 "filter/f-inst.c"
  , struct f_inst * f1
#line 276 "filter/f-inst.c"
  , struct f_inst * f2
#line 278 "filter/f-inst.c"
  , enum ec_subtype ecs
#line 314 "filter/f-inst.c"
)
#line 314
  {
#line 314
    /* Allocate the structure */
#line 314
    struct f_inst *what = fi_new(fi_code);
#line 314
    uint constargs = 1;
#line 314

#line 314
    /* Initialize all the members */
#line 314
  #define whati (&(what->i_FI_EC_CONSTRUCT))
#line 314
  #line 275 "filter/f-inst.c"
whati->f1 = f1;
#line 275
for (const struct f_inst *child = f1; child; child = child->next) {
#line 275
  what->size += child->size;
#line 275

#line 275
  if (child->fi_code != FI_CONSTANT)
#line 275
    constargs = 0;
#line 275

#line 275
}
#line 276 "filter/f-inst.c"
whati->f2 = f2;
#line 276
for (const struct f_inst *child = f2; child; child = child->next) {
#line 276
  what->size += child->size;
#line 276

#line 276
  if (child->fi_code != FI_CONSTANT)
#line 276
    constargs = 0;
#line 276

#line 276
}
#line 276 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 276
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 276
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 278 "filter/f-inst.c"
whati->ecs = ecs;
#line 299 "filter/f-inst.c"
what->type = T_EC;

#line 314 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 314
    if (!constargs)
#line 314
      return what;
#line 314

#line 314
    /* Try to pre-calculate the result */
#line 314
    #line 274 "filter/f-inst.c"
 {
    
#line 275 "filter/f-inst.c"
;
    
#line 276 "filter/f-inst.c"
 
#line 276 "filter/f-inst.c"
 
#line 276 "filter/f-inst.c"
;

    #line 278 "filter/f-inst.c"
;

    int ipv4_used;
    u32 key, val;

    if (v1.type == T_INT) {
      ipv4_used = 0; key = v1.val.i;
    }
    else if (v1.type == T_QUAD) {
      ipv4_used = 1; key = v1.val.i;
    }
    /* IP->Quad implicit conversion */
    else if (val_is_ip4(&v1)) {
      ipv4_used = 1; key = ipa_to_u32(v1.val.ip);
    }
    else
      runtime("Argument 1 of EC constructor must be integer or IPv4 address, got 0x%02x", v1.type);

    val = v2.val.i;

    if (ecs == EC_GENERIC)
       
#line 299 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_generic(key, val) } );
    else if (ipv4_used)
      if (val <= 0xFFFF)
	 return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_ip4(ecs, key, val) } );
      else
	runtime("4-byte value %u can't be used with IP-address key in extended community", val);
    else if (key < 0x10000)
       return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_as2(ecs, key, val) } );
    else
      if (val <= 0xFFFF)
	 return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_as4(ecs, key, val) } );
      else
	runtime("4-byte value %u can't be used with 4-byte ASN in extended community", val);
  }

  
  #undef whati
#line 314 "filter/f-inst.c"
  }
#line 314

#line 314

#line 321 "filter/f-inst.c"
 /* Constructor for FI_LC_CONSTRUCT */
#line 321
struct f_inst *f_new_inst_FI_LC_CONSTRUCT(enum f_instruction_code fi_code
#line 315 "filter/f-inst.c"
  , struct f_inst * f1
#line 316 "filter/f-inst.c"
  , struct f_inst * f2
#line 317 "filter/f-inst.c"
  , struct f_inst * f3
#line 321 "filter/f-inst.c"
)
#line 321
  {
#line 321
    /* Allocate the structure */
#line 321
    struct f_inst *what = fi_new(fi_code);
#line 321
    uint constargs = 1;
#line 321

#line 321
    /* Initialize all the members */
#line 321
  #define whati (&(what->i_FI_LC_CONSTRUCT))
#line 321
  #line 315 "filter/f-inst.c"
whati->f1 = f1;
#line 315
for (const struct f_inst *child = f1; child; child = child->next) {
#line 315
  what->size += child->size;
#line 315

#line 315
  if (child->fi_code != FI_CONSTANT)
#line 315
    constargs = 0;
#line 315

#line 315
}
#line 315 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 315
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 315
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 316 "filter/f-inst.c"
whati->f2 = f2;
#line 316
for (const struct f_inst *child = f2; child; child = child->next) {
#line 316
  what->size += child->size;
#line 316

#line 316
  if (child->fi_code != FI_CONSTANT)
#line 316
    constargs = 0;
#line 316

#line 316
}
#line 316 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 316
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 316
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 317 "filter/f-inst.c"
whati->f3 = f3;
#line 317
for (const struct f_inst *child = f3; child; child = child->next) {
#line 317
  what->size += child->size;
#line 317

#line 317
  if (child->fi_code != FI_CONSTANT)
#line 317
    constargs = 0;
#line 317

#line 317
}
#line 317 "filter/f-inst.c"
if (f3->type && (f3->type != (T_INT)) && !f_const_promotion(f3, (T_INT)))
#line 317
  cf_error("Argument 3 of %s must be of type %s, got type %s",
#line 317
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f3->type));
#line 318 "filter/f-inst.c"
what->type = T_LC;

#line 321 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 321
    if (!constargs)
#line 321
      return what;
#line 321

#line 321
    /* Try to pre-calculate the result */
#line 321
    #line 314 "filter/f-inst.c"
 {
    
#line 315 "filter/f-inst.c"
 
#line 315 "filter/f-inst.c"
 
#line 315 "filter/f-inst.c"
;
    
#line 316 "filter/f-inst.c"
 
#line 316 "filter/f-inst.c"
 
#line 316 "filter/f-inst.c"
;
    
#line 317 "filter/f-inst.c"
 
#line 317 "filter/f-inst.c"
 
#line 317 "filter/f-inst.c"
;
     
#line 318 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_LC, .val.lc = (lcomm) { v1.val.i, v2.val.i, v3.val.i } } );
  }

  
  #undef whati
#line 321 "filter/f-inst.c"
  }
#line 321

#line 321

#line 371 "filter/f-inst.c"
 /* Constructor for FI_PATHMASK_CONSTRUCT */
#line 371
struct f_inst *f_new_inst_FI_PATHMASK_CONSTRUCT(enum f_instruction_code fi_code
#line 322 "filter/f-inst.c"
  , struct f_inst * fvar
#line 371 "filter/f-inst.c"
)
#line 371
  {
#line 371
    /* Allocate the structure */
#line 371
    struct f_inst *what = fi_new(fi_code);
#line 371
    uint constargs = 1;
#line 371

#line 371
    /* Initialize all the members */
#line 371
  #define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 371
  #line 322 "filter/f-inst.c"
whati->varcount = 0;
#line 322
whati->fvar = fvar;
#line 322
for (const struct f_inst *child = fvar; child; child = child->next, whati->varcount++) {
#line 322
  what->size += child->size;
#line 322

#line 322
  if (child->fi_code != FI_CONSTANT)
#line 322
    constargs = 0;
#line 322

#line 322
}
#line 322

#line 322
  const struct f_inst **items = NULL;
#line 322
  if (constargs && whati->varcount) {
#line 322
    items = alloca(whati->varcount * sizeof(struct f_inst *));
#line 322
    const struct f_inst *child = fvar;
#line 322
    for (uint i=0; child; i++)
#line 322
      child = (items[i] = child)->next;
#line 322
  }
#line 322

#line 366 "filter/f-inst.c"
what->type = T_PATH_MASK;

#line 371 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 371
    if (!constargs)
#line 371
      return what;
#line 371

#line 371
    /* Try to pre-calculate the result */
#line 371
    #line 321 "filter/f-inst.c"
 {
    
#line 322 "filter/f-inst.c"

#line 322

#line 322
;

    struct f_path_mask *pm = falloc(sizeof(struct f_path_mask) + whati->varcount * sizeof(struct f_path_mask_item));
    pm->len = whati->varcount;

    for (uint i=0; i<whati->varcount; i++) {
      switch (vv(i).type) {
	case T_PATH_MASK_ITEM:
	  if (vv(i).val.pmi.kind == PM_LOOP)
	  {
	    if (i == 0)
	      runtime("Path mask iterator '+' cannot be first");

	    /* We want PM_LOOP as prefix operator */
	    pm->item[i] = pm->item[i - 1];
	    pm->item[i - 1] = vv(i).val.pmi;
	    break;
	  }

	  pm->item[i] = vv(i).val.pmi;
	  break;

	case T_INT:
	  pm->item[i] = (struct f_path_mask_item) {
	    .asn = vv(i).val.i,
	    .kind = PM_ASN,
	  };
	  break;

	case T_SET:
	  if (vv(i).val.t->from.type != T_INT)
	    runtime("Only integer sets allowed in path mask");

	  pm->item[i] = (struct f_path_mask_item) {
	    .set = vv(i).val.t,
	    .kind = PM_ASN_SET,
	  };
	  break;

	default:
	  runtime( "Error resolving path mask template: value not an integer" );
      }
    }

     
#line 366 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_PATH_MASK, .val.path_mask = pm } );
  }

/* Relational operators */

  
  #undef whati
#line 371 "filter/f-inst.c"
  }
#line 371

#line 371

#line 377 "filter/f-inst.c"
 /* Constructor for FI_NEQ */
#line 377
struct f_inst *f_new_inst_FI_NEQ(enum f_instruction_code fi_code
#line 372 "filter/f-inst.c"
  , struct f_inst * f1
#line 373 "filter/f-inst.c"
  , struct f_inst * f2
#line 377 "filter/f-inst.c"
)
#line 377
  {
#line 377
    /* Allocate the structure */
#line 377
    struct f_inst *what = fi_new(fi_code);
#line 377
    uint constargs = 1;
#line 377

#line 377
    /* Initialize all the members */
#line 377
  #define whati (&(what->i_FI_NEQ))
#line 377
  #line 372 "filter/f-inst.c"
whati->f1 = f1;
#line 372
for (const struct f_inst *child = f1; child; child = child->next) {
#line 372
  what->size += child->size;
#line 372

#line 372
  if (child->fi_code != FI_CONSTANT)
#line 372
    constargs = 0;
#line 372

#line 372
}
#line 373 "filter/f-inst.c"
whati->f2 = f2;
#line 373
for (const struct f_inst *child = f2; child; child = child->next) {
#line 373
  what->size += child->size;
#line 373

#line 373
  if (child->fi_code != FI_CONSTANT)
#line 373
    constargs = 0;
#line 373

#line 373
}
#line 374 "filter/f-inst.c"
what->type = T_BOOL;

#line 377 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 377
    if (!constargs)
#line 377
      return what;
#line 377

#line 377
    /* Try to pre-calculate the result */
#line 377
    #line 371 "filter/f-inst.c"
 {
    
#line 372 "filter/f-inst.c"
;
    
#line 373 "filter/f-inst.c"
;
     
#line 374 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !val_same(&v1, &v2) } );
  }

  
  #undef whati
#line 377 "filter/f-inst.c"
  }
#line 377

#line 377

#line 383 "filter/f-inst.c"
 /* Constructor for FI_EQ */
#line 383
struct f_inst *f_new_inst_FI_EQ(enum f_instruction_code fi_code
#line 378 "filter/f-inst.c"
  , struct f_inst * f1
#line 379 "filter/f-inst.c"
  , struct f_inst * f2
#line 383 "filter/f-inst.c"
)
#line 383
  {
#line 383
    /* Allocate the structure */
#line 383
    struct f_inst *what = fi_new(fi_code);
#line 383
    uint constargs = 1;
#line 383

#line 383
    /* Initialize all the members */
#line 383
  #define whati (&(what->i_FI_EQ))
#line 383
  #line 378 "filter/f-inst.c"
whati->f1 = f1;
#line 378
for (const struct f_inst *child = f1; child; child = child->next) {
#line 378
  what->size += child->size;
#line 378

#line 378
  if (child->fi_code != FI_CONSTANT)
#line 378
    constargs = 0;
#line 378

#line 378
}
#line 379 "filter/f-inst.c"
whati->f2 = f2;
#line 379
for (const struct f_inst *child = f2; child; child = child->next) {
#line 379
  what->size += child->size;
#line 379

#line 379
  if (child->fi_code != FI_CONSTANT)
#line 379
    constargs = 0;
#line 379

#line 379
}
#line 380 "filter/f-inst.c"
what->type = T_BOOL;

#line 383 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 383
    if (!constargs)
#line 383
      return what;
#line 383

#line 383
    /* Try to pre-calculate the result */
#line 383
    #line 377 "filter/f-inst.c"
 {
    
#line 378 "filter/f-inst.c"
;
    
#line 379 "filter/f-inst.c"
;
     
#line 380 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = val_same(&v1, &v2) } );
  }

  
  #undef whati
#line 383 "filter/f-inst.c"
  }
#line 383

#line 383

#line 394 "filter/f-inst.c"
 /* Constructor for FI_LT */
#line 394
struct f_inst *f_new_inst_FI_LT(enum f_instruction_code fi_code
#line 384 "filter/f-inst.c"
  , struct f_inst * f1
#line 385 "filter/f-inst.c"
  , struct f_inst * f2
#line 394 "filter/f-inst.c"
)
#line 394
  {
#line 394
    /* Allocate the structure */
#line 394
    struct f_inst *what = fi_new(fi_code);
#line 394
    uint constargs = 1;
#line 394

#line 394
    /* Initialize all the members */
#line 394
  #define whati (&(what->i_FI_LT))
#line 394
  #line 384 "filter/f-inst.c"
whati->f1 = f1;
#line 384
for (const struct f_inst *child = f1; child; child = child->next) {
#line 384
  what->size += child->size;
#line 384

#line 384
  if (child->fi_code != FI_CONSTANT)
#line 384
    constargs = 0;
#line 384

#line 384
}
#line 385 "filter/f-inst.c"
whati->f2 = f2;
#line 385
for (const struct f_inst *child = f2; child; child = child->next) {
#line 385
  what->size += child->size;
#line 385

#line 385
  if (child->fi_code != FI_CONSTANT)
#line 385
    constargs = 0;
#line 385

#line 385
}
#line 386 "filter/f-inst.c"
if (f1->type && f2->type && (f1->type != f2->type) &&
#line 386
   !f_const_promotion(f2, f1->type) && !f_const_promotion(f1, f2->type))
#line 386
  cf_error("Arguments 1 and 2 of %s must be of the same type", f_instruction_name(what->fi_code));
#line 391 "filter/f-inst.c"
what->type = T_BOOL;

#line 394 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 394
    if (!constargs)
#line 394
      return what;
#line 394

#line 394
    /* Try to pre-calculate the result */
#line 394
    #line 383 "filter/f-inst.c"
 {
    
#line 384 "filter/f-inst.c"
;
    
#line 385 "filter/f-inst.c"
;
    
#line 386 "filter/f-inst.c"
;

    int i = val_compare(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "Can't compare values of incompatible types" );
     
#line 391 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (i == -1) } );
  }

  
  #undef whati
#line 394 "filter/f-inst.c"
  }
#line 394

#line 394

#line 405 "filter/f-inst.c"
 /* Constructor for FI_LTE */
#line 405
struct f_inst *f_new_inst_FI_LTE(enum f_instruction_code fi_code
#line 395 "filter/f-inst.c"
  , struct f_inst * f1
#line 396 "filter/f-inst.c"
  , struct f_inst * f2
#line 405 "filter/f-inst.c"
)
#line 405
  {
#line 405
    /* Allocate the structure */
#line 405
    struct f_inst *what = fi_new(fi_code);
#line 405
    uint constargs = 1;
#line 405

#line 405
    /* Initialize all the members */
#line 405
  #define whati (&(what->i_FI_LTE))
#line 405
  #line 395 "filter/f-inst.c"
whati->f1 = f1;
#line 395
for (const struct f_inst *child = f1; child; child = child->next) {
#line 395
  what->size += child->size;
#line 395

#line 395
  if (child->fi_code != FI_CONSTANT)
#line 395
    constargs = 0;
#line 395

#line 395
}
#line 396 "filter/f-inst.c"
whati->f2 = f2;
#line 396
for (const struct f_inst *child = f2; child; child = child->next) {
#line 396
  what->size += child->size;
#line 396

#line 396
  if (child->fi_code != FI_CONSTANT)
#line 396
    constargs = 0;
#line 396

#line 396
}
#line 397 "filter/f-inst.c"
if (f1->type && f2->type && (f1->type != f2->type) &&
#line 397
   !f_const_promotion(f2, f1->type) && !f_const_promotion(f1, f2->type))
#line 397
  cf_error("Arguments 1 and 2 of %s must be of the same type", f_instruction_name(what->fi_code));
#line 402 "filter/f-inst.c"
what->type = T_BOOL;

#line 405 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 405
    if (!constargs)
#line 405
      return what;
#line 405

#line 405
    /* Try to pre-calculate the result */
#line 405
    #line 394 "filter/f-inst.c"
 {
    
#line 395 "filter/f-inst.c"
;
    
#line 396 "filter/f-inst.c"
;
    
#line 397 "filter/f-inst.c"
;

    int i = val_compare(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "Can't compare values of incompatible types" );
     
#line 402 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (i != 1) } );
  }

  
  #undef whati
#line 405 "filter/f-inst.c"
  }
#line 405

#line 405

#line 410 "filter/f-inst.c"
 /* Constructor for FI_NOT */
#line 410
struct f_inst *f_new_inst_FI_NOT(enum f_instruction_code fi_code
#line 406 "filter/f-inst.c"
  , struct f_inst * f1
#line 410 "filter/f-inst.c"
)
#line 410
  {
#line 410
    /* Allocate the structure */
#line 410
    struct f_inst *what = fi_new(fi_code);
#line 410
    uint constargs = 1;
#line 410

#line 410
    /* Initialize all the members */
#line 410
  #define whati (&(what->i_FI_NOT))
#line 410
  #line 406 "filter/f-inst.c"
whati->f1 = f1;
#line 406
for (const struct f_inst *child = f1; child; child = child->next) {
#line 406
  what->size += child->size;
#line 406

#line 406
  if (child->fi_code != FI_CONSTANT)
#line 406
    constargs = 0;
#line 406

#line 406
}
#line 406 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 406
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 406
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 407 "filter/f-inst.c"
what->type = T_BOOL;

#line 410 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 410
    if (!constargs)
#line 410
      return what;
#line 410

#line 410
    /* Try to pre-calculate the result */
#line 410
    #line 405 "filter/f-inst.c"
 {
    
#line 406 "filter/f-inst.c"
 
#line 406 "filter/f-inst.c"
 
#line 406 "filter/f-inst.c"
;
     
#line 407 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !v1.val.i } );
  }

  
  #undef whati
#line 410 "filter/f-inst.c"
  }
#line 410

#line 410

#line 419 "filter/f-inst.c"
 /* Constructor for FI_MATCH */
#line 419
struct f_inst *f_new_inst_FI_MATCH(enum f_instruction_code fi_code
#line 411 "filter/f-inst.c"
  , struct f_inst * f1
#line 412 "filter/f-inst.c"
  , struct f_inst * f2
#line 419 "filter/f-inst.c"
)
#line 419
  {
#line 419
    /* Allocate the structure */
#line 419
    struct f_inst *what = fi_new(fi_code);
#line 419
    uint constargs = 1;
#line 419

#line 419
    /* Initialize all the members */
#line 419
  #define whati (&(what->i_FI_MATCH))
#line 419
  #line 411 "filter/f-inst.c"
whati->f1 = f1;
#line 411
for (const struct f_inst *child = f1; child; child = child->next) {
#line 411
  what->size += child->size;
#line 411

#line 411
  if (child->fi_code != FI_CONSTANT)
#line 411
    constargs = 0;
#line 411

#line 411
}
#line 412 "filter/f-inst.c"
whati->f2 = f2;
#line 412
for (const struct f_inst *child = f2; child; child = child->next) {
#line 412
  what->size += child->size;
#line 412

#line 412
  if (child->fi_code != FI_CONSTANT)
#line 412
    constargs = 0;
#line 412

#line 412
}
#line 416 "filter/f-inst.c"
what->type = T_BOOL;

#line 419 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 419
    if (!constargs)
#line 419
      return what;
#line 419

#line 419
    /* Try to pre-calculate the result */
#line 419
    #line 410 "filter/f-inst.c"
 {
    
#line 411 "filter/f-inst.c"
;
    
#line 412 "filter/f-inst.c"
;
    int i = val_in_range(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "~ applied on unknown type pair" );
     
#line 416 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !!i } );
  }

  
  #undef whati
#line 419 "filter/f-inst.c"
  }
#line 419

#line 419

#line 428 "filter/f-inst.c"
 /* Constructor for FI_NOT_MATCH */
#line 428
struct f_inst *f_new_inst_FI_NOT_MATCH(enum f_instruction_code fi_code
#line 420 "filter/f-inst.c"
  , struct f_inst * f1
#line 421 "filter/f-inst.c"
  , struct f_inst * f2
#line 428 "filter/f-inst.c"
)
#line 428
  {
#line 428
    /* Allocate the structure */
#line 428
    struct f_inst *what = fi_new(fi_code);
#line 428
    uint constargs = 1;
#line 428

#line 428
    /* Initialize all the members */
#line 428
  #define whati (&(what->i_FI_NOT_MATCH))
#line 428
  #line 420 "filter/f-inst.c"
whati->f1 = f1;
#line 420
for (const struct f_inst *child = f1; child; child = child->next) {
#line 420
  what->size += child->size;
#line 420

#line 420
  if (child->fi_code != FI_CONSTANT)
#line 420
    constargs = 0;
#line 420

#line 420
}
#line 421 "filter/f-inst.c"
whati->f2 = f2;
#line 421
for (const struct f_inst *child = f2; child; child = child->next) {
#line 421
  what->size += child->size;
#line 421

#line 421
  if (child->fi_code != FI_CONSTANT)
#line 421
    constargs = 0;
#line 421

#line 421
}
#line 425 "filter/f-inst.c"
what->type = T_BOOL;

#line 428 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 428
    if (!constargs)
#line 428
      return what;
#line 428

#line 428
    /* Try to pre-calculate the result */
#line 428
    #line 419 "filter/f-inst.c"
 {
    
#line 420 "filter/f-inst.c"
;
    
#line 421 "filter/f-inst.c"
;
    int i = val_in_range(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "!~ applied on unknown type pair" );
     
#line 425 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !i } );
  }

  
  #undef whati
#line 428 "filter/f-inst.c"
  }
#line 428

#line 428

#line 433 "filter/f-inst.c"
 /* Constructor for FI_DEFINED */
#line 433
struct f_inst *f_new_inst_FI_DEFINED(enum f_instruction_code fi_code
#line 429 "filter/f-inst.c"
  , struct f_inst * f1
#line 433 "filter/f-inst.c"
)
#line 433
  {
#line 433
    /* Allocate the structure */
#line 433
    struct f_inst *what = fi_new(fi_code);
#line 433
    uint constargs = 1;
#line 433

#line 433
    /* Initialize all the members */
#line 433
  #define whati (&(what->i_FI_DEFINED))
#line 433
  #line 429 "filter/f-inst.c"
whati->f1 = f1;
#line 429
for (const struct f_inst *child = f1; child; child = child->next) {
#line 429
  what->size += child->size;
#line 429

#line 429
  if (child->fi_code != FI_CONSTANT)
#line 429
    constargs = 0;
#line 429

#line 429
}
#line 430 "filter/f-inst.c"
what->type = T_BOOL;

#line 433 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 433
    if (!constargs)
#line 433
      return what;
#line 433

#line 433
    /* Try to pre-calculate the result */
#line 433
    #line 428 "filter/f-inst.c"
 {
    
#line 429 "filter/f-inst.c"
;
     
#line 430 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (v1.type != T_VOID) && !undef_value(v1) } );
  }

  
  #undef whati
#line 433 "filter/f-inst.c"
  }
#line 433

#line 433

#line 445 "filter/f-inst.c"
 /* Constructor for FI_TYPE */
#line 445
struct f_inst *f_new_inst_FI_TYPE(enum f_instruction_code fi_code
#line 434 "filter/f-inst.c"
  , struct f_inst * f1
#line 445 "filter/f-inst.c"
)
#line 445
  {
#line 445
    /* Allocate the structure */
#line 445
    struct f_inst *what = fi_new(fi_code);
#line 445
    uint constargs = 1;
#line 445

#line 445
    /* Initialize all the members */
#line 445
  #define whati (&(what->i_FI_TYPE))
#line 445
  #line 434 "filter/f-inst.c"
whati->f1 = f1;
#line 434
for (const struct f_inst *child = f1; child; child = child->next) {
#line 434
  what->size += child->size;
#line 434

#line 434
  if (child->fi_code != FI_CONSTANT)
#line 434
    constargs = 0;
#line 434

#line 434
}
#line 438 "filter/f-inst.c"
what->type = T_ENUM_NETTYPE;

#line 445 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 445
    if (!constargs)
#line 445
      return what;
#line 445

#line 445
    /* Try to pre-calculate the result */
#line 445
    #line 433 "filter/f-inst.c"
 {
    
#line 434 "filter/f-inst.c"
; /* There may be more types supporting this operation */
    switch (v1.type)
    {
      case T_NET:
	 
#line 438 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_ENUM_NETTYPE, .val.i = v1.val.net->type } );
	break;
      default:
	runtime( "Can't determine type of this item" );
    }
  }

  
  #undef whati
#line 445 "filter/f-inst.c"
  }
#line 445

#line 445

#line 451 "filter/f-inst.c"
 /* Constructor for FI_IS_V4 */
#line 451
struct f_inst *f_new_inst_FI_IS_V4(enum f_instruction_code fi_code
#line 446 "filter/f-inst.c"
  , struct f_inst * f1
#line 451 "filter/f-inst.c"
)
#line 451
  {
#line 451
    /* Allocate the structure */
#line 451
    struct f_inst *what = fi_new(fi_code);
#line 451
    uint constargs = 1;
#line 451

#line 451
    /* Initialize all the members */
#line 451
  #define whati (&(what->i_FI_IS_V4))
#line 451
  #line 446 "filter/f-inst.c"
whati->f1 = f1;
#line 446
for (const struct f_inst *child = f1; child; child = child->next) {
#line 446
  what->size += child->size;
#line 446

#line 446
  if (child->fi_code != FI_CONSTANT)
#line 446
    constargs = 0;
#line 446

#line 446
}
#line 446 "filter/f-inst.c"
if (f1->type && (f1->type != (T_IP)) && !f_const_promotion(f1, (T_IP)))
#line 446
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 446
	   f_instruction_name(what->fi_code), f_type_name(T_IP), f_type_name(f1->type));
#line 447 "filter/f-inst.c"
what->type = T_BOOL;

#line 451 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 451
    if (!constargs)
#line 451
      return what;
#line 451

#line 451
    /* Try to pre-calculate the result */
#line 451
    #line 445 "filter/f-inst.c"
 {
    
#line 446 "filter/f-inst.c"
 
#line 446 "filter/f-inst.c"
 
#line 446 "filter/f-inst.c"
;
     
#line 447 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = ipa_is_ip4(v1.val.ip) } );
  }

  /* Set to indirect value prepared in v1 */
  
  #undef whati
#line 451 "filter/f-inst.c"
  }
#line 451

#line 451

#line 460 "filter/f-inst.c"
 /* Constructor for FI_VAR_SET */
#line 460
struct f_inst *f_new_inst_FI_VAR_SET(enum f_instruction_code fi_code
#line 453 "filter/f-inst.c"
  , struct f_inst * f1
#line 454 "filter/f-inst.c"
  , struct symbol * sym
#line 460 "filter/f-inst.c"
)
#line 460
  {
#line 460
    /* Allocate the structure */
#line 460
    struct f_inst *what = fi_new(fi_code);
#line 460
    
#line 460

#line 460
    /* Initialize all the members */
#line 460
  #define whati (&(what->i_FI_VAR_SET))
#line 460
  #line 453 "filter/f-inst.c"
whati->f1 = f1;
#line 453
for (const struct f_inst *child = f1; child; child = child->next) {
#line 453
  what->size += child->size;
#line 453

#line 453
}
#line 454 "filter/f-inst.c"
whati->sym = sym;
#line 455 "filter/f-inst.c"
if (f1->type && (f1->type != (sym->class & 0xff)) && !f_const_promotion(f1, (sym->class & 0xff)))
#line 455
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 455
	   f_instruction_name(what->fi_code), f_type_name(sym->class & 0xff), f_type_name(f1->type));

#line 460 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 460
    
#line 460
      return what;
#line 460

#line 460
    /* Try to pre-calculate the result */
#line 460
      #undef whati
#line 460
  }
#line 460

#line 460

#line 467 "filter/f-inst.c"
 /* Constructor for FI_VAR_GET */
#line 467
struct f_inst *f_new_inst_FI_VAR_GET(enum f_instruction_code fi_code
#line 461 "filter/f-inst.c"
  , struct symbol * sym
#line 467 "filter/f-inst.c"
)
#line 467
  {
#line 467
    /* Allocate the structure */
#line 467
    struct f_inst *what = fi_new(fi_code);
#line 467
    
#line 467

#line 467
    /* Initialize all the members */
#line 467
  #define whati (&(what->i_FI_VAR_GET))
#line 467
  #line 461 "filter/f-inst.c"
whati->sym = sym;
#line 463 "filter/f-inst.c"
what->type = sym->class & 0xff;

#line 467 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 467
    
#line 467
      return what;
#line 467

#line 467
    /* Try to pre-calculate the result */
#line 467
      #undef whati
#line 467
  }
#line 467

#line 467

#line 480 "filter/f-inst.c"
 /* Constructor for FI_CONSTANT */
#line 480
struct f_inst *f_new_inst_FI_CONSTANT(enum f_instruction_code fi_code
#line 468 "filter/f-inst.c"
  , struct f_val val
#line 480 "filter/f-inst.c"
)
#line 480
  {
#line 480
    /* Allocate the structure */
#line 480
    struct f_inst *what = fi_new(fi_code);
#line 480
    uint constargs = 1;
#line 480

#line 480
    /* Initialize all the members */
#line 480
  #define whati (&(what->i_FI_CONSTANT))
#line 480
  #line 468 "filter/f-inst.c"
whati->val = val;
#line 476 "filter/f-inst.c"
what->type = val.type;

#line 480 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 480
    if (!constargs)
#line 480
      return what;
#line 480

#line 480
    /* Try to pre-calculate the result */
#line 480
    #line 467 "filter/f-inst.c"
 {
    #line 474 "filter/f-inst.c"
;

     
#line 476 "filter/f-inst.c"
;
    return fi_constant(what, val);
  }

  
  #undef whati
#line 480 "filter/f-inst.c"
  }
#line 480

#line 480

#line 488 "filter/f-inst.c"
 /* Constructor for FI_CONDITION */
#line 488
struct f_inst *f_new_inst_FI_CONDITION(enum f_instruction_code fi_code
#line 481 "filter/f-inst.c"
  , struct f_inst * f1
#line 483 "filter/f-inst.c"
  , struct f_inst * f2
#line 485 "filter/f-inst.c"
  , struct f_inst * f3
#line 488 "filter/f-inst.c"
)
#line 488
  {
#line 488
    /* Allocate the structure */
#line 488
    struct f_inst *what = fi_new(fi_code);
#line 488
    uint constargs = 1;
#line 488

#line 488
    /* Initialize all the members */
#line 488
  #define whati (&(what->i_FI_CONDITION))
#line 488
  #line 481 "filter/f-inst.c"
whati->f1 = f1;
#line 481
for (const struct f_inst *child = f1; child; child = child->next) {
#line 481
  what->size += child->size;
#line 481

#line 481
  if (child->fi_code != FI_CONSTANT)
#line 481
    constargs = 0;
#line 481

#line 481
}
#line 481 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 481
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 481
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 483 "filter/f-inst.c"
whati->f2 = f2;
#line 485 "filter/f-inst.c"
whati->f3 = f3;

#line 488 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 488
    if (!constargs)
#line 488
      return what;
#line 488

#line 488
    /* Try to pre-calculate the result */
#line 488
    #line 480 "filter/f-inst.c"
 {
    
#line 481 "filter/f-inst.c"
 
#line 481 "filter/f-inst.c"
 
#line 481 "filter/f-inst.c"
;
    if (v1.val.i)
      
#line 483 "filter/f-inst.c"
return whati->f2
#line 483
;
    else
      
#line 485 "filter/f-inst.c"
return whati->f3
#line 485
;
  }

  
  #undef whati
#line 488 "filter/f-inst.c"
  }
#line 488

#line 488

#line 497 "filter/f-inst.c"
 /* Constructor for FI_PRINT */
#line 497
struct f_inst *f_new_inst_FI_PRINT(enum f_instruction_code fi_code
#line 490 "filter/f-inst.c"
  , struct f_inst * fvar
#line 497 "filter/f-inst.c"
)
#line 497
  {
#line 497
    /* Allocate the structure */
#line 497
    struct f_inst *what = fi_new(fi_code);
#line 497
    
#line 497

#line 497
    /* Initialize all the members */
#line 497
  #define whati (&(what->i_FI_PRINT))
#line 497
  #line 490 "filter/f-inst.c"
whati->varcount = 0;
#line 490
whati->fvar = fvar;
#line 490
for (const struct f_inst *child = fvar; child; child = child->next, whati->varcount++) {
#line 490
  what->size += child->size;
#line 490

#line 490
}
#line 490


#line 497 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 497
    
#line 497
      return what;
#line 497

#line 497
    /* Try to pre-calculate the result */
#line 497
      #undef whati
#line 497
  }
#line 497

#line 497

#line 504 "filter/f-inst.c"
 /* Constructor for FI_FLUSH */
#line 504
struct f_inst *f_new_inst_FI_FLUSH(enum f_instruction_code fi_code
#line 504
)
#line 504
  {
#line 504
    /* Allocate the structure */
#line 504
    struct f_inst *what = fi_new(fi_code);
#line 504
    
#line 504

#line 504
    /* Initialize all the members */
#line 504
  #define whati (&(what->i_FI_FLUSH))
#line 504
  
#line 504
    /* If not constant, return the instruction itself */
#line 504
    
#line 504
      return what;
#line 504

#line 504
    /* Try to pre-calculate the result */
#line 504
      #undef whati
#line 504
  }
#line 504

#line 504

#line 518 "filter/f-inst.c"
 /* Constructor for FI_DIE */
#line 518
struct f_inst *f_new_inst_FI_DIE(enum f_instruction_code fi_code
#line 506 "filter/f-inst.c"
  , enum filter_return fret
#line 518 "filter/f-inst.c"
)
#line 518
  {
#line 518
    /* Allocate the structure */
#line 518
    struct f_inst *what = fi_new(fi_code);
#line 518
    
#line 518

#line 518
    /* Initialize all the members */
#line 518
  #define whati (&(what->i_FI_DIE))
#line 518
  #line 506 "filter/f-inst.c"
whati->fret = fret;

#line 518 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 518
    
#line 518
      return what;
#line 518

#line 518
    /* Try to pre-calculate the result */
#line 518
      #undef whati
#line 518
  }
#line 518

#line 518

#line 544 "filter/f-inst.c"
 /* Constructor for FI_RTA_GET */
#line 544
struct f_inst *f_new_inst_FI_RTA_GET(enum f_instruction_code fi_code
#line 520 "filter/f-inst.c"
  , struct f_static_attr sa
#line 544 "filter/f-inst.c"
)
#line 544
  {
#line 544
    /* Allocate the structure */
#line 544
    struct f_inst *what = fi_new(fi_code);
#line 544
    
#line 544

#line 544
    /* Initialize all the members */
#line 544
  #define whati (&(what->i_FI_RTA_GET))
#line 544
  #line 520 "filter/f-inst.c"
whati->sa = sa;
#line 526 "filter/f-inst.c"
what->type = sa.f_type;

#line 544 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 544
    
#line 544
      return what;
#line 544

#line 544
    /* Try to pre-calculate the result */
#line 544
      #undef whati
#line 544
  }
#line 544

#line 544

#line 646 "filter/f-inst.c"
 /* Constructor for FI_RTA_SET */
#line 646
struct f_inst *f_new_inst_FI_RTA_SET(enum f_instruction_code fi_code
#line 546 "filter/f-inst.c"
  , struct f_inst * f1
#line 547 "filter/f-inst.c"
  , struct f_static_attr sa
#line 646 "filter/f-inst.c"
)
#line 646
  {
#line 646
    /* Allocate the structure */
#line 646
    struct f_inst *what = fi_new(fi_code);
#line 646
    
#line 646

#line 646
    /* Initialize all the members */
#line 646
  #define whati (&(what->i_FI_RTA_SET))
#line 646
  #line 546 "filter/f-inst.c"
whati->f1 = f1;
#line 546
for (const struct f_inst *child = f1; child; child = child->next) {
#line 546
  what->size += child->size;
#line 546

#line 546
}
#line 547 "filter/f-inst.c"
whati->sa = sa;
#line 548 "filter/f-inst.c"
if (f1->type && (f1->type != (sa.f_type)) && !f_const_promotion(f1, (sa.f_type)))
#line 548
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 548
	   f_instruction_name(what->fi_code), f_type_name(sa.f_type), f_type_name(f1->type));

#line 646 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 646
    
#line 646
      return what;
#line 646

#line 646
    /* Try to pre-calculate the result */
#line 646
      #undef whati
#line 646
  }
#line 646

#line 646

#line 721 "filter/f-inst.c"
 /* Constructor for FI_EA_GET */
#line 721
struct f_inst *f_new_inst_FI_EA_GET(enum f_instruction_code fi_code
#line 647 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 721 "filter/f-inst.c"
)
#line 721
  {
#line 721
    /* Allocate the structure */
#line 721
    struct f_inst *what = fi_new(fi_code);
#line 721
    
#line 721

#line 721
    /* Initialize all the members */
#line 721
  #define whati (&(what->i_FI_EA_GET))
#line 721
  #line 647 "filter/f-inst.c"
whati->da = da;
#line 650 "filter/f-inst.c"
what->type = da.f_type;

#line 721 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 721
    
#line 721
      return what;
#line 721

#line 721
    /* Try to pre-calculate the result */
#line 721
      #undef whati
#line 721
  }
#line 721

#line 721

#line 785 "filter/f-inst.c"
 /* Constructor for FI_EA_SET */
#line 785
struct f_inst *f_new_inst_FI_EA_SET(enum f_instruction_code fi_code
#line 724 "filter/f-inst.c"
  , struct f_inst * f1
#line 725 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 785 "filter/f-inst.c"
)
#line 785
  {
#line 785
    /* Allocate the structure */
#line 785
    struct f_inst *what = fi_new(fi_code);
#line 785
    
#line 785

#line 785
    /* Initialize all the members */
#line 785
  #define whati (&(what->i_FI_EA_SET))
#line 785
  #line 724 "filter/f-inst.c"
whati->f1 = f1;
#line 724
for (const struct f_inst *child = f1; child; child = child->next) {
#line 724
  what->size += child->size;
#line 724

#line 724
}
#line 725 "filter/f-inst.c"
whati->da = da;
#line 726 "filter/f-inst.c"
if (f1->type && (f1->type != (da.f_type)) && !f_const_promotion(f1, (da.f_type)))
#line 726
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 726
	   f_instruction_name(what->fi_code), f_type_name(da.f_type), f_type_name(f1->type));

#line 785 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 785
    
#line 785
      return what;
#line 785

#line 785
    /* Try to pre-calculate the result */
#line 785
      #undef whati
#line 785
  }
#line 785

#line 785

#line 807 "filter/f-inst.c"
 /* Constructor for FI_EA_UNSET */
#line 807
struct f_inst *f_new_inst_FI_EA_UNSET(enum f_instruction_code fi_code
#line 786 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 807 "filter/f-inst.c"
)
#line 807
  {
#line 807
    /* Allocate the structure */
#line 807
    struct f_inst *what = fi_new(fi_code);
#line 807
    
#line 807

#line 807
    /* Initialize all the members */
#line 807
  #define whati (&(what->i_FI_EA_UNSET))
#line 807
  #line 786 "filter/f-inst.c"
whati->da = da;

#line 807 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 807
    
#line 807
      return what;
#line 807

#line 807
    /* Try to pre-calculate the result */
#line 807
      #undef whati
#line 807
  }
#line 807

#line 807

#line 812 "filter/f-inst.c"
 /* Constructor for FI_PREF_GET */
#line 812
struct f_inst *f_new_inst_FI_PREF_GET(enum f_instruction_code fi_code
#line 812
)
#line 812
  {
#line 812
    /* Allocate the structure */
#line 812
    struct f_inst *what = fi_new(fi_code);
#line 812
    
#line 812

#line 812
    /* Initialize all the members */
#line 812
  #define whati (&(what->i_FI_PREF_GET))
#line 812
  #line 809 "filter/f-inst.c"
what->type = T_INT;

#line 812 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 812
    
#line 812
      return what;
#line 812

#line 812
    /* Try to pre-calculate the result */
#line 812
      #undef whati
#line 812
  }
#line 812

#line 812

#line 821 "filter/f-inst.c"
 /* Constructor for FI_PREF_SET */
#line 821
struct f_inst *f_new_inst_FI_PREF_SET(enum f_instruction_code fi_code
#line 814 "filter/f-inst.c"
  , struct f_inst * f1
#line 821 "filter/f-inst.c"
)
#line 821
  {
#line 821
    /* Allocate the structure */
#line 821
    struct f_inst *what = fi_new(fi_code);
#line 821
    
#line 821

#line 821
    /* Initialize all the members */
#line 821
  #define whati (&(what->i_FI_PREF_SET))
#line 821
  #line 814 "filter/f-inst.c"
whati->f1 = f1;
#line 814
for (const struct f_inst *child = f1; child; child = child->next) {
#line 814
  what->size += child->size;
#line 814

#line 814
}
#line 814 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 814
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 814
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));

#line 821 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 821
    
#line 821
      return what;
#line 821

#line 821
    /* Try to pre-calculate the result */
#line 821
      #undef whati
#line 821
  }
#line 821

#line 821

#line 833 "filter/f-inst.c"
 /* Constructor for FI_LENGTH */
#line 833
struct f_inst *f_new_inst_FI_LENGTH(enum f_instruction_code fi_code
#line 822 "filter/f-inst.c"
  , struct f_inst * f1
#line 833 "filter/f-inst.c"
)
#line 833
  {
#line 833
    /* Allocate the structure */
#line 833
    struct f_inst *what = fi_new(fi_code);
#line 833
    uint constargs = 1;
#line 833

#line 833
    /* Initialize all the members */
#line 833
  #define whati (&(what->i_FI_LENGTH))
#line 833
  #line 822 "filter/f-inst.c"
whati->f1 = f1;
#line 822
for (const struct f_inst *child = f1; child; child = child->next) {
#line 822
  what->size += child->size;
#line 822

#line 822
  if (child->fi_code != FI_CONSTANT)
#line 822
    constargs = 0;
#line 822

#line 822
}
#line 824 "filter/f-inst.c"
what->type = T_INT;

#line 833 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 833
    if (!constargs)
#line 833
      return what;
#line 833

#line 833
    /* Try to pre-calculate the result */
#line 833
    #line 821 "filter/f-inst.c"
 {	/* Get length of */
    
#line 822 "filter/f-inst.c"
;
    switch(v1.type) {
    case T_NET:     
#line 824 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = net_pxlen(v1.val.net) } ); break;
    case T_PATH:    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as_path_getlen(v1.val.ad) } ); break;
    case T_CLIST:   return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = int_set_get_size(v1.val.ad) } ); break;
    case T_ECLIST:  return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = ec_set_get_size(v1.val.ad) } ); break;
    case T_LCLIST:  return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = lc_set_get_size(v1.val.ad) } ); break;
    default: runtime( "Prefix, path, clist or eclist expected" );
    }
  }

  
  #undef whati
#line 833 "filter/f-inst.c"
  }
#line 833

#line 833

#line 868 "filter/f-inst.c"
 /* Constructor for FI_NET_SRC */
#line 868
struct f_inst *f_new_inst_FI_NET_SRC(enum f_instruction_code fi_code
#line 834 "filter/f-inst.c"
  , struct f_inst * f1
#line 868 "filter/f-inst.c"
)
#line 868
  {
#line 868
    /* Allocate the structure */
#line 868
    struct f_inst *what = fi_new(fi_code);
#line 868
    uint constargs = 1;
#line 868

#line 868
    /* Initialize all the members */
#line 868
  #define whati (&(what->i_FI_NET_SRC))
#line 868
  #line 834 "filter/f-inst.c"
whati->f1 = f1;
#line 834
for (const struct f_inst *child = f1; child; child = child->next) {
#line 834
  what->size += child->size;
#line 834

#line 834
  if (child->fi_code != FI_CONSTANT)
#line 834
    constargs = 0;
#line 834

#line 834
}
#line 834 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 834
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 834
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 865 "filter/f-inst.c"
what->type = T_NET;

#line 868 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 868
    if (!constargs)
#line 868
      return what;
#line 868

#line 868
    /* Try to pre-calculate the result */
#line 868
    #line 833 "filter/f-inst.c"
 { 	/* Get src prefix */
    
#line 834 "filter/f-inst.c"
 
#line 834 "filter/f-inst.c"
 
#line 834 "filter/f-inst.c"
;

    net_addr_union *net = (void *) v1.val.net;
    net_addr *src = falloc(sizeof(net_addr_ip6));
    const byte *part;

    switch(v1.val.net->type) {
    case NET_FLOW4:
      part = flow4_get_part(&net->flow4, FLOW_TYPE_SRC_PREFIX);
      if (part)
	net_fill_ip4(src, flow_read_ip4_part(part), flow_read_pxlen(part));
      else
	net_fill_ip4(src, IP4_NONE, 0);
      break;

    case NET_FLOW6:
      part = flow6_get_part(&net->flow6, FLOW_TYPE_SRC_PREFIX);
      if (part)
	net_fill_ip6(src, flow_read_ip6_part(part), flow_read_pxlen(part));
      else
	net_fill_ip6(src, IP6_NONE, 0);
      break;

    case NET_IP6_SADR:
      net_fill_ip6(src, net->ip6_sadr.src_prefix, net->ip6_sadr.src_pxlen);
      break;

    default:
      runtime( "Flow or SADR expected" );
    }

     
#line 865 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_NET, .val.net = src } );
  }

  
  #undef whati
#line 868 "filter/f-inst.c"
  }
#line 868

#line 868

#line 903 "filter/f-inst.c"
 /* Constructor for FI_NET_DST */
#line 903
struct f_inst *f_new_inst_FI_NET_DST(enum f_instruction_code fi_code
#line 869 "filter/f-inst.c"
  , struct f_inst * f1
#line 903 "filter/f-inst.c"
)
#line 903
  {
#line 903
    /* Allocate the structure */
#line 903
    struct f_inst *what = fi_new(fi_code);
#line 903
    uint constargs = 1;
#line 903

#line 903
    /* Initialize all the members */
#line 903
  #define whati (&(what->i_FI_NET_DST))
#line 903
  #line 869 "filter/f-inst.c"
whati->f1 = f1;
#line 869
for (const struct f_inst *child = f1; child; child = child->next) {
#line 869
  what->size += child->size;
#line 869

#line 869
  if (child->fi_code != FI_CONSTANT)
#line 869
    constargs = 0;
#line 869

#line 869
}
#line 869 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 869
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 869
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 900 "filter/f-inst.c"
what->type = T_NET;

#line 903 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 903
    if (!constargs)
#line 903
      return what;
#line 903

#line 903
    /* Try to pre-calculate the result */
#line 903
    #line 868 "filter/f-inst.c"
 { 	/* Get dst prefix */
    
#line 869 "filter/f-inst.c"
 
#line 869 "filter/f-inst.c"
 
#line 869 "filter/f-inst.c"
;

    net_addr_union *net = (void *) v1.val.net;
    net_addr *dst = falloc(sizeof(net_addr_ip6));
    const byte *part;

    switch(v1.val.net->type) {
    case NET_FLOW4:
      part = flow4_get_part(&net->flow4, FLOW_TYPE_DST_PREFIX);
      if (part)
	net_fill_ip4(dst, flow_read_ip4_part(part), flow_read_pxlen(part));
      else
	net_fill_ip4(dst, IP4_NONE, 0);
      break;

    case NET_FLOW6:
      part = flow6_get_part(&net->flow6, FLOW_TYPE_DST_PREFIX);
      if (part)
	net_fill_ip6(dst, flow_read_ip6_part(part), flow_read_pxlen(part));
      else
	net_fill_ip6(dst, IP6_NONE, 0);
      break;

    case NET_IP6_SADR:
      net_fill_ip6(dst, net->ip6_sadr.dst_prefix, net->ip6_sadr.dst_pxlen);
      break;

    default:
      runtime( "Flow or SADR expected" );
    }

     
#line 900 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_NET, .val.net = dst } );
  }

  
  #undef whati
#line 903 "filter/f-inst.c"
  }
#line 903

#line 903

#line 913 "filter/f-inst.c"
 /* Constructor for FI_ROA_MAXLEN */
#line 913
struct f_inst *f_new_inst_FI_ROA_MAXLEN(enum f_instruction_code fi_code
#line 904 "filter/f-inst.c"
  , struct f_inst * f1
#line 913 "filter/f-inst.c"
)
#line 913
  {
#line 913
    /* Allocate the structure */
#line 913
    struct f_inst *what = fi_new(fi_code);
#line 913
    uint constargs = 1;
#line 913

#line 913
    /* Initialize all the members */
#line 913
  #define whati (&(what->i_FI_ROA_MAXLEN))
#line 913
  #line 904 "filter/f-inst.c"
whati->f1 = f1;
#line 904
for (const struct f_inst *child = f1; child; child = child->next) {
#line 904
  what->size += child->size;
#line 904

#line 904
  if (child->fi_code != FI_CONSTANT)
#line 904
    constargs = 0;
#line 904

#line 904
}
#line 904 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 904
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 904
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 908 "filter/f-inst.c"
what->type = T_INT;

#line 913 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 913
    if (!constargs)
#line 913
      return what;
#line 913

#line 913
    /* Try to pre-calculate the result */
#line 913
    #line 903 "filter/f-inst.c"
 { 	/* Get ROA max prefix length */
    
#line 904 "filter/f-inst.c"
 
#line 904 "filter/f-inst.c"
 
#line 904 "filter/f-inst.c"
;
    if (!net_is_roa(v1.val.net))
      runtime( "ROA expected" );

     
#line 908 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = (v1.val.net->type == NET_ROA4) ?
#line 908
      ((net_addr_roa4 *) v1.val.net)->max_pxlen :
#line 908
      ((net_addr_roa6 *) v1.val.net)->max_pxlen } );
#line 911
  }

  
  #undef whati
#line 913 "filter/f-inst.c"
  }
#line 913

#line 913

#line 940 "filter/f-inst.c"
 /* Constructor for FI_ASN */
#line 940
struct f_inst *f_new_inst_FI_ASN(enum f_instruction_code fi_code
#line 914 "filter/f-inst.c"
  , struct f_inst * f1
#line 940 "filter/f-inst.c"
)
#line 940
  {
#line 940
    /* Allocate the structure */
#line 940
    struct f_inst *what = fi_new(fi_code);
#line 940
    uint constargs = 1;
#line 940

#line 940
    /* Initialize all the members */
#line 940
  #define whati (&(what->i_FI_ASN))
#line 940
  #line 914 "filter/f-inst.c"
whati->f1 = f1;
#line 914
for (const struct f_inst *child = f1; child; child = child->next) {
#line 914
  what->size += child->size;
#line 914

#line 914
  if (child->fi_code != FI_CONSTANT)
#line 914
    constargs = 0;
#line 914

#line 914
}
#line 915 "filter/f-inst.c"
what->type = T_INT;

#line 940 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 940
    if (!constargs)
#line 940
      return what;
#line 940

#line 940
    /* Try to pre-calculate the result */
#line 940
    #line 913 "filter/f-inst.c"
 { 	/* Get ROA ASN or community ASN part */
    
#line 914 "filter/f-inst.c"
;
     
#line 915 "filter/f-inst.c"
;
    switch(v1.type)
    {
      case T_NET:
        if (!net_is_roa(v1.val.net))
          runtime( "ROA expected" );

        return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = (v1.val.net->type == NET_ROA4) ?
#line 922
          ((net_addr_roa4 *) v1.val.net)->asn :
#line 922
          ((net_addr_roa6 *) v1.val.net)->asn } );
#line 925
        break;

      case T_PAIR:
        return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i >> 16 } );
        break;

      case T_LC:
        return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.lc.asn } );
        break;

      default:
        runtime( "Net, pair or lc expected" );
    }
  }

  
  #undef whati
#line 940 "filter/f-inst.c"
  }
#line 940

#line 940

#line 945 "filter/f-inst.c"
 /* Constructor for FI_IP */
#line 945
struct f_inst *f_new_inst_FI_IP(enum f_instruction_code fi_code
#line 941 "filter/f-inst.c"
  , struct f_inst * f1
#line 945 "filter/f-inst.c"
)
#line 945
  {
#line 945
    /* Allocate the structure */
#line 945
    struct f_inst *what = fi_new(fi_code);
#line 945
    uint constargs = 1;
#line 945

#line 945
    /* Initialize all the members */
#line 945
  #define whati (&(what->i_FI_IP))
#line 945
  #line 941 "filter/f-inst.c"
whati->f1 = f1;
#line 941
for (const struct f_inst *child = f1; child; child = child->next) {
#line 941
  what->size += child->size;
#line 941

#line 941
  if (child->fi_code != FI_CONSTANT)
#line 941
    constargs = 0;
#line 941

#line 941
}
#line 941 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 941
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 941
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 942 "filter/f-inst.c"
what->type = T_IP;

#line 945 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 945
    if (!constargs)
#line 945
      return what;
#line 945

#line 945
    /* Try to pre-calculate the result */
#line 945
    #line 940 "filter/f-inst.c"
 {	/* Convert prefix to ... */
    
#line 941 "filter/f-inst.c"
 
#line 941 "filter/f-inst.c"
 
#line 941 "filter/f-inst.c"
;
     
#line 942 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_IP, .val.ip = net_prefix(v1.val.net) } );
  }

  
  #undef whati
#line 945 "filter/f-inst.c"
  }
#line 945

#line 945

#line 952 "filter/f-inst.c"
 /* Constructor for FI_ROUTE_DISTINGUISHER */
#line 952
struct f_inst *f_new_inst_FI_ROUTE_DISTINGUISHER(enum f_instruction_code fi_code
#line 946 "filter/f-inst.c"
  , struct f_inst * f1
#line 952 "filter/f-inst.c"
)
#line 952
  {
#line 952
    /* Allocate the structure */
#line 952
    struct f_inst *what = fi_new(fi_code);
#line 952
    uint constargs = 1;
#line 952

#line 952
    /* Initialize all the members */
#line 952
  #define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 952
  #line 946 "filter/f-inst.c"
whati->f1 = f1;
#line 946
for (const struct f_inst *child = f1; child; child = child->next) {
#line 946
  what->size += child->size;
#line 946

#line 946
  if (child->fi_code != FI_CONSTANT)
#line 946
    constargs = 0;
#line 946

#line 946
}
#line 946 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 946
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 946
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 949 "filter/f-inst.c"
what->type = T_RD;

#line 952 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 952
    if (!constargs)
#line 952
      return what;
#line 952

#line 952
    /* Try to pre-calculate the result */
#line 952
    #line 945 "filter/f-inst.c"
 {
    
#line 946 "filter/f-inst.c"
 
#line 946 "filter/f-inst.c"
 
#line 946 "filter/f-inst.c"
;
    if (!net_is_vpn(v1.val.net))
      runtime( "VPN address expected" );
     
#line 949 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_RD, .val.ec = net_rd(v1.val.net) } );
  }

  
  #undef whati
#line 952 "filter/f-inst.c"
  }
#line 952

#line 952

#line 959 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_FIRST */
#line 959
struct f_inst *f_new_inst_FI_AS_PATH_FIRST(enum f_instruction_code fi_code
#line 953 "filter/f-inst.c"
  , struct f_inst * f1
#line 959 "filter/f-inst.c"
)
#line 959
  {
#line 959
    /* Allocate the structure */
#line 959
    struct f_inst *what = fi_new(fi_code);
#line 959
    uint constargs = 1;
#line 959

#line 959
    /* Initialize all the members */
#line 959
  #define whati (&(what->i_FI_AS_PATH_FIRST))
#line 959
  #line 953 "filter/f-inst.c"
whati->f1 = f1;
#line 953
for (const struct f_inst *child = f1; child; child = child->next) {
#line 953
  what->size += child->size;
#line 953

#line 953
  if (child->fi_code != FI_CONSTANT)
#line 953
    constargs = 0;
#line 953

#line 953
}
#line 953 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 953
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 953
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 956 "filter/f-inst.c"
what->type = T_INT;

#line 959 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 959
    if (!constargs)
#line 959
      return what;
#line 959

#line 959
    /* Try to pre-calculate the result */
#line 959
    #line 952 "filter/f-inst.c"
 {	/* Get first ASN from AS PATH */
    
#line 953 "filter/f-inst.c"
 
#line 953 "filter/f-inst.c"
 
#line 953 "filter/f-inst.c"
;
    u32 as = 0;
    as_path_get_first(v1.val.ad, &as);
     
#line 956 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as } );
  }

  
  #undef whati
#line 959 "filter/f-inst.c"
  }
#line 959

#line 959

#line 966 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_LAST */
#line 966
struct f_inst *f_new_inst_FI_AS_PATH_LAST(enum f_instruction_code fi_code
#line 960 "filter/f-inst.c"
  , struct f_inst * f1
#line 966 "filter/f-inst.c"
)
#line 966
  {
#line 966
    /* Allocate the structure */
#line 966
    struct f_inst *what = fi_new(fi_code);
#line 966
    uint constargs = 1;
#line 966

#line 966
    /* Initialize all the members */
#line 966
  #define whati (&(what->i_FI_AS_PATH_LAST))
#line 966
  #line 960 "filter/f-inst.c"
whati->f1 = f1;
#line 960
for (const struct f_inst *child = f1; child; child = child->next) {
#line 960
  what->size += child->size;
#line 960

#line 960
  if (child->fi_code != FI_CONSTANT)
#line 960
    constargs = 0;
#line 960

#line 960
}
#line 960 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 960
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 960
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 963 "filter/f-inst.c"
what->type = T_INT;

#line 966 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 966
    if (!constargs)
#line 966
      return what;
#line 966

#line 966
    /* Try to pre-calculate the result */
#line 966
    #line 959 "filter/f-inst.c"
 {		/* Get last ASN from AS PATH */
    
#line 960 "filter/f-inst.c"
 
#line 960 "filter/f-inst.c"
 
#line 960 "filter/f-inst.c"
;
    u32 as = 0;
    as_path_get_last(v1.val.ad, &as);
     
#line 963 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as } );
  }

  
  #undef whati
#line 966 "filter/f-inst.c"
  }
#line 966

#line 966

#line 971 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_LAST_NAG */
#line 971
struct f_inst *f_new_inst_FI_AS_PATH_LAST_NAG(enum f_instruction_code fi_code
#line 967 "filter/f-inst.c"
  , struct f_inst * f1
#line 971 "filter/f-inst.c"
)
#line 971
  {
#line 971
    /* Allocate the structure */
#line 971
    struct f_inst *what = fi_new(fi_code);
#line 971
    uint constargs = 1;
#line 971

#line 971
    /* Initialize all the members */
#line 971
  #define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 971
  #line 967 "filter/f-inst.c"
whati->f1 = f1;
#line 967
for (const struct f_inst *child = f1; child; child = child->next) {
#line 967
  what->size += child->size;
#line 967

#line 967
  if (child->fi_code != FI_CONSTANT)
#line 967
    constargs = 0;
#line 967

#line 967
}
#line 967 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 967
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 967
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 968 "filter/f-inst.c"
what->type = T_INT;

#line 971 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 971
    if (!constargs)
#line 971
      return what;
#line 971

#line 971
    /* Try to pre-calculate the result */
#line 971
    #line 966 "filter/f-inst.c"
 {	/* Get last ASN from non-aggregated part of AS PATH */
    
#line 967 "filter/f-inst.c"
 
#line 967 "filter/f-inst.c"
 
#line 967 "filter/f-inst.c"
;
     
#line 968 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as_path_get_last_nonaggregated(v1.val.ad) } );
  }

  
  #undef whati
#line 971 "filter/f-inst.c"
  }
#line 971

#line 971

#line 976 "filter/f-inst.c"
 /* Constructor for FI_PAIR_DATA */
#line 976
struct f_inst *f_new_inst_FI_PAIR_DATA(enum f_instruction_code fi_code
#line 972 "filter/f-inst.c"
  , struct f_inst * f1
#line 976 "filter/f-inst.c"
)
#line 976
  {
#line 976
    /* Allocate the structure */
#line 976
    struct f_inst *what = fi_new(fi_code);
#line 976
    uint constargs = 1;
#line 976

#line 976
    /* Initialize all the members */
#line 976
  #define whati (&(what->i_FI_PAIR_DATA))
#line 976
  #line 972 "filter/f-inst.c"
whati->f1 = f1;
#line 972
for (const struct f_inst *child = f1; child; child = child->next) {
#line 972
  what->size += child->size;
#line 972

#line 972
  if (child->fi_code != FI_CONSTANT)
#line 972
    constargs = 0;
#line 972

#line 972
}
#line 972 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PAIR)) && !f_const_promotion(f1, (T_PAIR)))
#line 972
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 972
	   f_instruction_name(what->fi_code), f_type_name(T_PAIR), f_type_name(f1->type));
#line 973 "filter/f-inst.c"
what->type = T_INT;

#line 976 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 976
    if (!constargs)
#line 976
      return what;
#line 976

#line 976
    /* Try to pre-calculate the result */
#line 976
    #line 971 "filter/f-inst.c"
 {	/* Get data part from the standard community */
    
#line 972 "filter/f-inst.c"
 
#line 972 "filter/f-inst.c"
 
#line 972 "filter/f-inst.c"
;
     
#line 973 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i & 0xFFFF } );
  }

  
  #undef whati
#line 976 "filter/f-inst.c"
  }
#line 976

#line 976

#line 981 "filter/f-inst.c"
 /* Constructor for FI_LC_DATA1 */
#line 981
struct f_inst *f_new_inst_FI_LC_DATA1(enum f_instruction_code fi_code
#line 977 "filter/f-inst.c"
  , struct f_inst * f1
#line 981 "filter/f-inst.c"
)
#line 981
  {
#line 981
    /* Allocate the structure */
#line 981
    struct f_inst *what = fi_new(fi_code);
#line 981
    uint constargs = 1;
#line 981

#line 981
    /* Initialize all the members */
#line 981
  #define whati (&(what->i_FI_LC_DATA1))
#line 981
  #line 977 "filter/f-inst.c"
whati->f1 = f1;
#line 977
for (const struct f_inst *child = f1; child; child = child->next) {
#line 977
  what->size += child->size;
#line 977

#line 977
  if (child->fi_code != FI_CONSTANT)
#line 977
    constargs = 0;
#line 977

#line 977
}
#line 977 "filter/f-inst.c"
if (f1->type && (f1->type != (T_LC)) && !f_const_promotion(f1, (T_LC)))
#line 977
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 977
	   f_instruction_name(what->fi_code), f_type_name(T_LC), f_type_name(f1->type));
#line 978 "filter/f-inst.c"
what->type = T_INT;

#line 981 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 981
    if (!constargs)
#line 981
      return what;
#line 981

#line 981
    /* Try to pre-calculate the result */
#line 981
    #line 976 "filter/f-inst.c"
 {	/* Get data1 part from the large community */
    
#line 977 "filter/f-inst.c"
 
#line 977 "filter/f-inst.c"
 
#line 977 "filter/f-inst.c"
;
     
#line 978 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.lc.ldp1 } );
  }

  
  #undef whati
#line 981 "filter/f-inst.c"
  }
#line 981

#line 981

#line 986 "filter/f-inst.c"
 /* Constructor for FI_LC_DATA2 */
#line 986
struct f_inst *f_new_inst_FI_LC_DATA2(enum f_instruction_code fi_code
#line 982 "filter/f-inst.c"
  , struct f_inst * f1
#line 986 "filter/f-inst.c"
)
#line 986
  {
#line 986
    /* Allocate the structure */
#line 986
    struct f_inst *what = fi_new(fi_code);
#line 986
    uint constargs = 1;
#line 986

#line 986
    /* Initialize all the members */
#line 986
  #define whati (&(what->i_FI_LC_DATA2))
#line 986
  #line 982 "filter/f-inst.c"
whati->f1 = f1;
#line 982
for (const struct f_inst *child = f1; child; child = child->next) {
#line 982
  what->size += child->size;
#line 982

#line 982
  if (child->fi_code != FI_CONSTANT)
#line 982
    constargs = 0;
#line 982

#line 982
}
#line 982 "filter/f-inst.c"
if (f1->type && (f1->type != (T_LC)) && !f_const_promotion(f1, (T_LC)))
#line 982
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 982
	   f_instruction_name(what->fi_code), f_type_name(T_LC), f_type_name(f1->type));
#line 983 "filter/f-inst.c"
what->type = T_INT;

#line 986 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 986
    if (!constargs)
#line 986
      return what;
#line 986

#line 986
    /* Try to pre-calculate the result */
#line 986
    #line 981 "filter/f-inst.c"
 {	/* Get data2 part from the large community */
    
#line 982 "filter/f-inst.c"
 
#line 982 "filter/f-inst.c"
 
#line 982 "filter/f-inst.c"
;
     
#line 983 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.lc.ldp2 } );
  }

  
  #undef whati
#line 986 "filter/f-inst.c"
  }
#line 986

#line 986

#line 1020 "filter/f-inst.c"
 /* Constructor for FI_MIN */
#line 1020
struct f_inst *f_new_inst_FI_MIN(enum f_instruction_code fi_code
#line 987 "filter/f-inst.c"
  , struct f_inst * f1
#line 1020 "filter/f-inst.c"
)
#line 1020
  {
#line 1020
    /* Allocate the structure */
#line 1020
    struct f_inst *what = fi_new(fi_code);
#line 1020
    uint constargs = 1;
#line 1020

#line 1020
    /* Initialize all the members */
#line 1020
  #define whati (&(what->i_FI_MIN))
#line 1020
  #line 987 "filter/f-inst.c"
whati->f1 = f1;
#line 987
for (const struct f_inst *child = f1; child; child = child->next) {
#line 987
  what->size += child->size;
#line 987

#line 987
  if (child->fi_code != FI_CONSTANT)
#line 987
    constargs = 0;
#line 987

#line 987
}
#line 988 "filter/f-inst.c"
what->type = f_type_element_type(v1.type);

#line 1020 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1020
    if (!constargs)
#line 1020
      return what;
#line 1020

#line 1020
    /* Try to pre-calculate the result */
#line 1020
    #line 986 "filter/f-inst.c"
 {	/* Get minimum element from set */
    
#line 987 "filter/f-inst.c"
;
     
#line 988 "filter/f-inst.c"
;
    switch(v1.type)
    {
      case T_CLIST:
        {
          u32 val = 0;
          int_set_min(v1.val.ad, &val);
          return fi_constant(what,  (struct f_val) { .type = T_PAIR, .val.i = val } );
        }
        break;

      case T_ECLIST:
        {
          u64 val = 0;
          ec_set_min(v1.val.ad, &val);
          return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = val } );
        }
        break;

      case T_LCLIST:
        {
          lcomm val = { 0, 0, 0 };
          lc_set_min(v1.val.ad, &val);
          return fi_constant(what,  (struct f_val) { .type = T_LC, .val.lc = val } );
        }
        break;

      default:
        runtime( "Clist or lclist expected" );
    }
  }

  
  #undef whati
#line 1020 "filter/f-inst.c"
  }
#line 1020

#line 1020

#line 1054 "filter/f-inst.c"
 /* Constructor for FI_MAX */
#line 1054
struct f_inst *f_new_inst_FI_MAX(enum f_instruction_code fi_code
#line 1021 "filter/f-inst.c"
  , struct f_inst * f1
#line 1054 "filter/f-inst.c"
)
#line 1054
  {
#line 1054
    /* Allocate the structure */
#line 1054
    struct f_inst *what = fi_new(fi_code);
#line 1054
    uint constargs = 1;
#line 1054

#line 1054
    /* Initialize all the members */
#line 1054
  #define whati (&(what->i_FI_MAX))
#line 1054
  #line 1021 "filter/f-inst.c"
whati->f1 = f1;
#line 1021
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1021
  what->size += child->size;
#line 1021

#line 1021
  if (child->fi_code != FI_CONSTANT)
#line 1021
    constargs = 0;
#line 1021

#line 1021
}
#line 1022 "filter/f-inst.c"
what->type = f_type_element_type(v1.type);

#line 1054 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1054
    if (!constargs)
#line 1054
      return what;
#line 1054

#line 1054
    /* Try to pre-calculate the result */
#line 1054
    #line 1020 "filter/f-inst.c"
 {	/* Get maximum element from set */
    
#line 1021 "filter/f-inst.c"
;
     
#line 1022 "filter/f-inst.c"
;
    switch(v1.type)
    {
      case T_CLIST:
        {
          u32 val = 0;
          int_set_max(v1.val.ad, &val);
          return fi_constant(what,  (struct f_val) { .type = T_PAIR, .val.i = val } );
        }
        break;

      case T_ECLIST:
        {
          u64 val = 0;
          ec_set_max(v1.val.ad, &val);
          return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = val } );
        }
        break;

      case T_LCLIST:
        {
          lcomm val = { 0, 0, 0 };
          lc_set_max(v1.val.ad, &val);
          return fi_constant(what,  (struct f_val) { .type = T_LC, .val.lc = val } );
        }
        break;

      default:
        runtime( "Clist or lclist expected" );
    }
  }

  
  #undef whati
#line 1054 "filter/f-inst.c"
  }
#line 1054

#line 1054

#line 1080 "filter/f-inst.c"
 /* Constructor for FI_RETURN */
#line 1080
struct f_inst *f_new_inst_FI_RETURN(enum f_instruction_code fi_code
#line 1057 "filter/f-inst.c"
  , struct f_inst * f1
#line 1080 "filter/f-inst.c"
)
#line 1080
  {
#line 1080
    /* Allocate the structure */
#line 1080
    struct f_inst *what = fi_new(fi_code);
#line 1080
    
#line 1080

#line 1080
    /* Initialize all the members */
#line 1080
  #define whati (&(what->i_FI_RETURN))
#line 1080
  #line 1057 "filter/f-inst.c"
whati->f1 = f1;
#line 1057
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1057
  what->size += child->size;
#line 1057

#line 1057
}

#line 1080 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1080
    
#line 1080
      return what;
#line 1080

#line 1080
    /* Try to pre-calculate the result */
#line 1080
      #undef whati
#line 1080
  }
#line 1080

#line 1080

#line 1110 "filter/f-inst.c"
 /* Constructor for FI_CALL */
#line 1110
struct f_inst *f_new_inst_FI_CALL(enum f_instruction_code fi_code
#line 1082 "filter/f-inst.c"
  , struct symbol * sym
#line 1110 "filter/f-inst.c"
)
#line 1110
  {
#line 1110
    /* Allocate the structure */
#line 1110
    struct f_inst *what = fi_new(fi_code);
#line 1110
    
#line 1110

#line 1110
    /* Initialize all the members */
#line 1110
  #define whati (&(what->i_FI_CALL))
#line 1110
  #line 1082 "filter/f-inst.c"
whati->sym = sym;

#line 1110 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1110
    
#line 1110
      return what;
#line 1110

#line 1110
    /* Try to pre-calculate the result */
#line 1110
      #undef whati
#line 1110
  }
#line 1110

#line 1110

#line 1115 "filter/f-inst.c"
 /* Constructor for FI_DROP_RESULT */
#line 1115
struct f_inst *f_new_inst_FI_DROP_RESULT(enum f_instruction_code fi_code
#line 1112 "filter/f-inst.c"
  , struct f_inst * f1
#line 1115 "filter/f-inst.c"
)
#line 1115
  {
#line 1115
    /* Allocate the structure */
#line 1115
    struct f_inst *what = fi_new(fi_code);
#line 1115
    
#line 1115

#line 1115
    /* Initialize all the members */
#line 1115
  #define whati (&(what->i_FI_DROP_RESULT))
#line 1115
  #line 1112 "filter/f-inst.c"
whati->f1 = f1;
#line 1112
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1112
  what->size += child->size;
#line 1112

#line 1112
}

#line 1115 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1115
    
#line 1115
      return what;
#line 1115

#line 1115
    /* Try to pre-calculate the result */
#line 1115
      #undef whati
#line 1115
  }
#line 1115

#line 1115

#line 1138 "filter/f-inst.c"
 /* Constructor for FI_SWITCH */
#line 1138
struct f_inst *f_new_inst_FI_SWITCH(enum f_instruction_code fi_code
#line 1116 "filter/f-inst.c"
  , struct f_inst * f1
#line 1118 "filter/f-inst.c"
  , struct f_tree * tree
#line 1138 "filter/f-inst.c"
)
#line 1138
  {
#line 1138
    /* Allocate the structure */
#line 1138
    struct f_inst *what = fi_new(fi_code);
#line 1138
    uint constargs = 1;
#line 1138

#line 1138
    /* Initialize all the members */
#line 1138
  #define whati (&(what->i_FI_SWITCH))
#line 1138
  #line 1116 "filter/f-inst.c"
whati->f1 = f1;
#line 1116
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1116
  what->size += child->size;
#line 1116

#line 1116
  if (child->fi_code != FI_CONSTANT)
#line 1116
    constargs = 0;
#line 1116

#line 1116
}
#line 1118 "filter/f-inst.c"
whati->tree = tree;

#line 1138 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1138
    if (!constargs)
#line 1138
      return what;
#line 1138

#line 1138
    /* Try to pre-calculate the result */
#line 1138
    #line 1115 "filter/f-inst.c"
 {
    
#line 1116 "filter/f-inst.c"
;

    #line 1118 "filter/f-inst.c"
;

    
#line 1124 "filter/f-inst.c"
    const struct f_tree *t = find_tree(tree, &v1);
    if (!t) {
      v1.type = T_VOID;
      t = find_tree(tree, &v1);
      if (!t) {
	debug( "No else statement?\n");
	return NULL;
      }
    }
    /* It is actually possible to have t->data NULL */

    return t->data ;
#line 1136 "filter/f-inst.c"
  }

  
  #undef whati
#line 1138 "filter/f-inst.c"
  }
#line 1138

#line 1138

#line 1146 "filter/f-inst.c"
 /* Constructor for FI_IP_MASK */
#line 1146
struct f_inst *f_new_inst_FI_IP_MASK(enum f_instruction_code fi_code
#line 1139 "filter/f-inst.c"
  , struct f_inst * f1
#line 1140 "filter/f-inst.c"
  , struct f_inst * f2
#line 1146 "filter/f-inst.c"
)
#line 1146
  {
#line 1146
    /* Allocate the structure */
#line 1146
    struct f_inst *what = fi_new(fi_code);
#line 1146
    uint constargs = 1;
#line 1146

#line 1146
    /* Initialize all the members */
#line 1146
  #define whati (&(what->i_FI_IP_MASK))
#line 1146
  #line 1139 "filter/f-inst.c"
whati->f1 = f1;
#line 1139
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1139
  what->size += child->size;
#line 1139

#line 1139
  if (child->fi_code != FI_CONSTANT)
#line 1139
    constargs = 0;
#line 1139

#line 1139
}
#line 1139 "filter/f-inst.c"
if (f1->type && (f1->type != (T_IP)) && !f_const_promotion(f1, (T_IP)))
#line 1139
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1139
	   f_instruction_name(what->fi_code), f_type_name(T_IP), f_type_name(f1->type));
#line 1140 "filter/f-inst.c"
whati->f2 = f2;
#line 1140
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1140
  what->size += child->size;
#line 1140

#line 1140
  if (child->fi_code != FI_CONSTANT)
#line 1140
    constargs = 0;
#line 1140

#line 1140
}
#line 1140 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 1140
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 1140
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 1141 "filter/f-inst.c"
what->type = T_IP;

#line 1146 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1146
    if (!constargs)
#line 1146
      return what;
#line 1146

#line 1146
    /* Try to pre-calculate the result */
#line 1146
    #line 1138 "filter/f-inst.c"
 { /* IP.MASK(val) */
    
#line 1139 "filter/f-inst.c"
 
#line 1139 "filter/f-inst.c"
 
#line 1139 "filter/f-inst.c"
;
    
#line 1140 "filter/f-inst.c"
 
#line 1140 "filter/f-inst.c"
 
#line 1140 "filter/f-inst.c"
;
     
#line 1141 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_IP, .val.ip =  ipa_is_ip4(v1.val.ip) ?
#line 1141
      ipa_from_ip4(ip4_and(ipa_to_ip4(v1.val.ip), ip4_mkmask(v2.val.i))) :
#line 1141
      ipa_from_ip6(ip6_and(ipa_to_ip6(v1.val.ip), ip6_mkmask(v2.val.i)))  } );
#line 1144
  }

  
  #undef whati
#line 1146 "filter/f-inst.c"
  }
#line 1146

#line 1146

#line 1152 "filter/f-inst.c"
 /* Constructor for FI_PATH_PREPEND */
#line 1152
struct f_inst *f_new_inst_FI_PATH_PREPEND(enum f_instruction_code fi_code
#line 1147 "filter/f-inst.c"
  , struct f_inst * f1
#line 1148 "filter/f-inst.c"
  , struct f_inst * f2
#line 1152 "filter/f-inst.c"
)
#line 1152
  {
#line 1152
    /* Allocate the structure */
#line 1152
    struct f_inst *what = fi_new(fi_code);
#line 1152
    uint constargs = 1;
#line 1152

#line 1152
    /* Initialize all the members */
#line 1152
  #define whati (&(what->i_FI_PATH_PREPEND))
#line 1152
  #line 1147 "filter/f-inst.c"
whati->f1 = f1;
#line 1147
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1147
  what->size += child->size;
#line 1147

#line 1147
  if (child->fi_code != FI_CONSTANT)
#line 1147
    constargs = 0;
#line 1147

#line 1147
}
#line 1147 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 1147
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1147
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 1148 "filter/f-inst.c"
whati->f2 = f2;
#line 1148
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1148
  what->size += child->size;
#line 1148

#line 1148
  if (child->fi_code != FI_CONSTANT)
#line 1148
    constargs = 0;
#line 1148

#line 1148
}
#line 1148 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 1148
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 1148
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 1149 "filter/f-inst.c"
what->type = T_PATH;

#line 1152 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1152
    if (!constargs)
#line 1152
      return what;
#line 1152

#line 1152
    /* Try to pre-calculate the result */
#line 1152
    #line 1146 "filter/f-inst.c"
 {	/* Path prepend */
    
#line 1147 "filter/f-inst.c"
 
#line 1147 "filter/f-inst.c"
 
#line 1147 "filter/f-inst.c"
;
    
#line 1148 "filter/f-inst.c"
 
#line 1148 "filter/f-inst.c"
 
#line 1148 "filter/f-inst.c"
;
     
#line 1149 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_prepend(fpool, v1.val.ad, v2.val.i)  } );
  }

  
  #undef whati
#line 1152 "filter/f-inst.c"
  }
#line 1152

#line 1152

#line 1209 "filter/f-inst.c"
 /* Constructor for FI_CLIST_ADD */
#line 1209
struct f_inst *f_new_inst_FI_CLIST_ADD(enum f_instruction_code fi_code
#line 1153 "filter/f-inst.c"
  , struct f_inst * f1
#line 1154 "filter/f-inst.c"
  , struct f_inst * f2
#line 1209 "filter/f-inst.c"
)
#line 1209
  {
#line 1209
    /* Allocate the structure */
#line 1209
    struct f_inst *what = fi_new(fi_code);
#line 1209
    uint constargs = 1;
#line 1209

#line 1209
    /* Initialize all the members */
#line 1209
  #define whati (&(what->i_FI_CLIST_ADD))
#line 1209
  #line 1153 "filter/f-inst.c"
whati->f1 = f1;
#line 1153
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1153
  what->size += child->size;
#line 1153

#line 1153
  if (child->fi_code != FI_CONSTANT)
#line 1153
    constargs = 0;
#line 1153

#line 1153
}
#line 1154 "filter/f-inst.c"
whati->f2 = f2;
#line 1154
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1154
  what->size += child->size;
#line 1154

#line 1154
  if (child->fi_code != FI_CONSTANT)
#line 1154
    constargs = 0;
#line 1154

#line 1154
}
#line 1155 "filter/f-inst.c"
what->type = f1->type;

#line 1209 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1209
    if (!constargs)
#line 1209
      return what;
#line 1209

#line 1209
    /* Try to pre-calculate the result */
#line 1209
    #line 1152 "filter/f-inst.c"
 {	/* (Extended) Community list add */
    
#line 1153 "filter/f-inst.c"
;
    
#line 1154 "filter/f-inst.c"
;
     
#line 1155 "filter/f-inst.c"
;

    if (v1.type == T_PATH)
      runtime("Can't add to path");

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_PAIR) || (v2.type == T_QUAD))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_add(fpool, v1.val.ad, v2.val.i)  } );
      /* IP->Quad implicit conversion */
      else if (val_is_ip4(&v2))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_add(fpool, v1.val.ad, ipa_to_u32(v2.val.ip))  } );
      else if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy))
	runtime("Can't add set");
      else if (v2.type == T_CLIST)
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else
	runtime("Can't add non-pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t))
	runtime("Can't add set");
      else if (v2.type == T_ECLIST)
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else if (v2.type != T_EC)
	runtime("Can't add non-ec");
      else
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_add(fpool, v1.val.ad, v2.val.ec)  } );
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t))
	runtime("Can't add set");
      else if (v2.type == T_LCLIST)
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else if (v2.type != T_LC)
	runtime("Can't add non-lc");
      else
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_add(fpool, v1.val.ad, v2.val.lc)  } );

    }

    else
      runtime("Can't add to non-[e|l]clist");
  }

  
  #undef whati
#line 1209 "filter/f-inst.c"
  }
#line 1209

#line 1209

#line 1271 "filter/f-inst.c"
 /* Constructor for FI_CLIST_DEL */
#line 1271
struct f_inst *f_new_inst_FI_CLIST_DEL(enum f_instruction_code fi_code
#line 1210 "filter/f-inst.c"
  , struct f_inst * f1
#line 1211 "filter/f-inst.c"
  , struct f_inst * f2
#line 1271 "filter/f-inst.c"
)
#line 1271
  {
#line 1271
    /* Allocate the structure */
#line 1271
    struct f_inst *what = fi_new(fi_code);
#line 1271
    uint constargs = 1;
#line 1271

#line 1271
    /* Initialize all the members */
#line 1271
  #define whati (&(what->i_FI_CLIST_DEL))
#line 1271
  #line 1210 "filter/f-inst.c"
whati->f1 = f1;
#line 1210
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1210
  what->size += child->size;
#line 1210

#line 1210
  if (child->fi_code != FI_CONSTANT)
#line 1210
    constargs = 0;
#line 1210

#line 1210
}
#line 1211 "filter/f-inst.c"
whati->f2 = f2;
#line 1211
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1211
  what->size += child->size;
#line 1211

#line 1211
  if (child->fi_code != FI_CONSTANT)
#line 1211
    constargs = 0;
#line 1211

#line 1211
}
#line 1212 "filter/f-inst.c"
what->type = f1->type;

#line 1271 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1271
    if (!constargs)
#line 1271
      return what;
#line 1271

#line 1271
    /* Try to pre-calculate the result */
#line 1271
    #line 1209 "filter/f-inst.c"
 {	/* (Extended) Community list add or delete */
    
#line 1210 "filter/f-inst.c"
;
    
#line 1211 "filter/f-inst.c"
;
     
#line 1212 "filter/f-inst.c"
;

    if (v1.type == T_PATH)
    {
      const struct f_tree *set = NULL;
      u32 key = 0;

      if (v2.type == T_INT)
	key = v2.val.i;
      else if ((v2.type == T_SET) && (v2.val.t->from.type == T_INT))
	set = v2.val.t;
      else
	runtime("Can't delete non-integer (set)");

      return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_filter(fpool, v1.val.ad, set, key, 0)  } );
    }

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_PAIR) || (v2.type == T_QUAD))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_del(fpool, v1.val.ad, v2.val.i)  } );
      /* IP->Quad implicit conversion */
      else if (val_is_ip4(&v2))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_del(fpool, v1.val.ad, ipa_to_u32(v2.val.ip))  } );
      else if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy) || (v2.type == T_CLIST))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  clist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else
	runtime("Can't delete non-pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t) || (v2.type == T_ECLIST))
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  eclist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else if (v2.type != T_EC)
	runtime("Can't delete non-ec");
      else
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_del(fpool, v1.val.ad, v2.val.ec)  } );
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t) || (v2.type == T_LCLIST))
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lclist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else if (v2.type != T_LC)
	runtime("Can't delete non-lc");
      else
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_del(fpool, v1.val.ad, v2.val.lc)  } );
    }

    else
      runtime("Can't delete in non-[e|l]clist");
  }

  
  #undef whati
#line 1271 "filter/f-inst.c"
  }
#line 1271

#line 1271

#line 1319 "filter/f-inst.c"
 /* Constructor for FI_CLIST_FILTER */
#line 1319
struct f_inst *f_new_inst_FI_CLIST_FILTER(enum f_instruction_code fi_code
#line 1272 "filter/f-inst.c"
  , struct f_inst * f1
#line 1273 "filter/f-inst.c"
  , struct f_inst * f2
#line 1319 "filter/f-inst.c"
)
#line 1319
  {
#line 1319
    /* Allocate the structure */
#line 1319
    struct f_inst *what = fi_new(fi_code);
#line 1319
    uint constargs = 1;
#line 1319

#line 1319
    /* Initialize all the members */
#line 1319
  #define whati (&(what->i_FI_CLIST_FILTER))
#line 1319
  #line 1272 "filter/f-inst.c"
whati->f1 = f1;
#line 1272
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1272
  what->size += child->size;
#line 1272

#line 1272
  if (child->fi_code != FI_CONSTANT)
#line 1272
    constargs = 0;
#line 1272

#line 1272
}
#line 1273 "filter/f-inst.c"
whati->f2 = f2;
#line 1273
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1273
  what->size += child->size;
#line 1273

#line 1273
  if (child->fi_code != FI_CONSTANT)
#line 1273
    constargs = 0;
#line 1273

#line 1273
}
#line 1274 "filter/f-inst.c"
what->type = f1->type;

#line 1319 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1319
    if (!constargs)
#line 1319
      return what;
#line 1319

#line 1319
    /* Try to pre-calculate the result */
#line 1319
    #line 1271 "filter/f-inst.c"
 {	/* (Extended) Community list add or delete */
    
#line 1272 "filter/f-inst.c"
;
    
#line 1273 "filter/f-inst.c"
;
     
#line 1274 "filter/f-inst.c"
;

    if (v1.type == T_PATH)
    {
      u32 key = 0;

      if ((v2.type == T_SET) && (v2.val.t->from.type == T_INT))
	return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_filter(fpool, v1.val.ad, v2.val.t, key, 1)  } );
      else
	runtime("Can't filter integer");
    }

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy) || (v2.type == T_CLIST))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  clist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t) || (v2.type == T_ECLIST))
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  eclist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter ec");
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t) || (v2.type == T_LCLIST))
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lclist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter lc");
    }

    else
      runtime("Can't filter non-[e|l]clist");
  }

  
  #undef whati
#line 1319 "filter/f-inst.c"
  }
#line 1319

#line 1319

#line 1349 "filter/f-inst.c"
 /* Constructor for FI_ROA_CHECK_IMPLICIT */
#line 1349
struct f_inst *f_new_inst_FI_ROA_CHECK_IMPLICIT(enum f_instruction_code fi_code
#line 1321 "filter/f-inst.c"
  , struct rtable_config * rtc
#line 1349 "filter/f-inst.c"
)
#line 1349
  {
#line 1349
    /* Allocate the structure */
#line 1349
    struct f_inst *what = fi_new(fi_code);
#line 1349
    
#line 1349

#line 1349
    /* Initialize all the members */
#line 1349
  #define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1349
  #line 1321 "filter/f-inst.c"
whati->rtc = rtc;
#line 1344 "filter/f-inst.c"
what->type = T_ENUM_ROA;

#line 1349 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1349
    
#line 1349
      return what;
#line 1349

#line 1349
    /* Try to pre-calculate the result */
#line 1349
      #undef whati
#line 1349
  }
#line 1349

#line 1349

#line 1371 "filter/f-inst.c"
 /* Constructor for FI_ROA_CHECK_EXPLICIT */
#line 1371
struct f_inst *f_new_inst_FI_ROA_CHECK_EXPLICIT(enum f_instruction_code fi_code
#line 1351 "filter/f-inst.c"
  , struct f_inst * f1
#line 1352 "filter/f-inst.c"
  , struct f_inst * f2
#line 1353 "filter/f-inst.c"
  , struct rtable_config * rtc
#line 1371 "filter/f-inst.c"
)
#line 1371
  {
#line 1371
    /* Allocate the structure */
#line 1371
    struct f_inst *what = fi_new(fi_code);
#line 1371
    
#line 1371

#line 1371
    /* Initialize all the members */
#line 1371
  #define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1371
  #line 1351 "filter/f-inst.c"
whati->f1 = f1;
#line 1351
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1351
  what->size += child->size;
#line 1351

#line 1351
}
#line 1351 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 1351
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1351
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 1352 "filter/f-inst.c"
whati->f2 = f2;
#line 1352
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1352
  what->size += child->size;
#line 1352

#line 1352
}
#line 1352 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 1352
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 1352
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 1353 "filter/f-inst.c"
whati->rtc = rtc;
#line 1365 "filter/f-inst.c"
what->type = T_ENUM_ROA;

#line 1371 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1371
    
#line 1371
      return what;
#line 1371

#line 1371
    /* Try to pre-calculate the result */
#line 1371
      #undef whati
#line 1371
  }
#line 1371

#line 1371

#line 1376 "filter/f-inst.c"
 /* Constructor for FI_FORMAT */
#line 1376
struct f_inst *f_new_inst_FI_FORMAT(enum f_instruction_code fi_code
#line 1372 "filter/f-inst.c"
  , struct f_inst * f1
#line 1376 "filter/f-inst.c"
)
#line 1376
  {
#line 1376
    /* Allocate the structure */
#line 1376
    struct f_inst *what = fi_new(fi_code);
#line 1376
    uint constargs = 1;
#line 1376

#line 1376
    /* Initialize all the members */
#line 1376
  #define whati (&(what->i_FI_FORMAT))
#line 1376
  #line 1372 "filter/f-inst.c"
whati->f1 = f1;
#line 1372
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1372
  what->size += child->size;
#line 1372

#line 1372
  if (child->fi_code != FI_CONSTANT)
#line 1372
    constargs = 0;
#line 1372

#line 1372
}
#line 1373 "filter/f-inst.c"
what->type = T_STRING;

#line 1376 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1376
    if (!constargs)
#line 1376
      return what;
#line 1376

#line 1376
    /* Try to pre-calculate the result */
#line 1376
    #line 1371 "filter/f-inst.c"
 {	/* Format */
    
#line 1372 "filter/f-inst.c"
;
     
#line 1373 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_STRING, .val.s = val_format_str(fpool, &v1) } );
  }

  
  #undef whati
#line 1376 "filter/f-inst.c"
  }
#line 1376

#line 1376

#line 668 "filter/decl.m4"
 /* Constructor for FI_ASSERT */
#line 668
struct f_inst *f_new_inst_FI_ASSERT(enum f_instruction_code fi_code
#line 1378 "filter/f-inst.c"
  , struct f_inst * f1
#line 1380 "filter/f-inst.c"
  , char * s
#line 668 "filter/decl.m4"
)
#line 668
  {
#line 668
    /* Allocate the structure */
#line 668
    struct f_inst *what = fi_new(fi_code);
#line 668
    
#line 668

#line 668
    /* Initialize all the members */
#line 668
  #define whati (&(what->i_FI_ASSERT))
#line 668
  #line 1378 "filter/f-inst.c"
whati->f1 = f1;
#line 1378
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1378
  what->size += child->size;
#line 1378

#line 1378
}
#line 1378 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 1378
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1378
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 1380 "filter/f-inst.c"
whati->s = s;

#line 668 "filter/decl.m4"
    /* If not constant, return the instruction itself */
#line 668
    
#line 668
      return what;
#line 668

#line 668
    /* Try to pre-calculate the result */
#line 668
      #undef whati
#line 668
  }
#line 668

#line 668

#line 509 "filter/decl.m4"

#undef v1
#undef v2
#undef v3
#undef vv

/* Line dumpers */
#define INDENT (((const char *) f_dump_line_indent_str) + sizeof(f_dump_line_indent_str) - (indent) - 1)
static const char f_dump_line_indent_str[] = "                                ";

#line 227 "filter/f-inst.c"
 /* Dump line for FI_ADD */
#line 227
static inline void f_dump_line_item_FI_ADD(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 227

#line 227
{
#line 227
#define item (&(item_->i_FI_ADD))
#line 227
#undef item
#line 227
}
#line 227

#line 232 "filter/f-inst.c"
 /* Dump line for FI_SUBTRACT */
#line 232
static inline void f_dump_line_item_FI_SUBTRACT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 232

#line 232
{
#line 232
#define item (&(item_->i_FI_SUBTRACT))
#line 232
#undef item
#line 232
}
#line 232

#line 237 "filter/f-inst.c"
 /* Dump line for FI_MULTIPLY */
#line 237
static inline void f_dump_line_item_FI_MULTIPLY(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 237

#line 237
{
#line 237
#define item (&(item_->i_FI_MULTIPLY))
#line 237
#undef item
#line 237
}
#line 237

#line 243 "filter/f-inst.c"
 /* Dump line for FI_DIVIDE */
#line 243
static inline void f_dump_line_item_FI_DIVIDE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 243

#line 243
{
#line 243
#define item (&(item_->i_FI_DIVIDE))
#line 243
#undef item
#line 243
}
#line 243

#line 253 "filter/f-inst.c"
 /* Dump line for FI_AND */
#line 253
static inline void f_dump_line_item_FI_AND(const struct f_line_item *item_, const int indent)
#line 253

#line 253
{
#line 253
#define item (&(item_->i_FI_AND))
#line 249 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 253 "filter/f-inst.c"
#undef item
#line 253
}
#line 253

#line 264 "filter/f-inst.c"
 /* Dump line for FI_OR */
#line 264
static inline void f_dump_line_item_FI_OR(const struct f_line_item *item_, const int indent)
#line 264

#line 264
{
#line 264
#define item (&(item_->i_FI_OR))
#line 259 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 264 "filter/f-inst.c"
#undef item
#line 264
}
#line 264

#line 274 "filter/f-inst.c"
 /* Dump line for FI_PAIR_CONSTRUCT */
#line 274
static inline void f_dump_line_item_FI_PAIR_CONSTRUCT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 274

#line 274
{
#line 274
#define item (&(item_->i_FI_PAIR_CONSTRUCT))
#line 274
#undef item
#line 274
}
#line 274

#line 314 "filter/f-inst.c"
 /* Dump line for FI_EC_CONSTRUCT */
#line 314
static inline void f_dump_line_item_FI_EC_CONSTRUCT(const struct f_line_item *item_, const int indent)
#line 314

#line 314
{
#line 314
#define item (&(item_->i_FI_EC_CONSTRUCT))
#line 278 "filter/f-inst.c"
debug("%s" "ec subtype %s" "\n", INDENT, ec_subtype_str(item->ecs));
#line 278

#line 314 "filter/f-inst.c"
#undef item
#line 314
}
#line 314

#line 321 "filter/f-inst.c"
 /* Dump line for FI_LC_CONSTRUCT */
#line 321
static inline void f_dump_line_item_FI_LC_CONSTRUCT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 321

#line 321
{
#line 321
#define item (&(item_->i_FI_LC_CONSTRUCT))
#line 321
#undef item
#line 321
}
#line 321

#line 371 "filter/f-inst.c"
 /* Dump line for FI_PATHMASK_CONSTRUCT */
#line 371
static inline void f_dump_line_item_FI_PATHMASK_CONSTRUCT(const struct f_line_item *item_, const int indent)
#line 371

#line 371
{
#line 371
#define item (&(item_->i_FI_PATHMASK_CONSTRUCT))
#line 322 "filter/f-inst.c"
  debug("%snumber of varargs %u\n", INDENT, item->varcount);
#line 371 "filter/f-inst.c"
#undef item
#line 371
}
#line 371

#line 377 "filter/f-inst.c"
 /* Dump line for FI_NEQ */
#line 377
static inline void f_dump_line_item_FI_NEQ(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 377

#line 377
{
#line 377
#define item (&(item_->i_FI_NEQ))
#line 377
#undef item
#line 377
}
#line 377

#line 383 "filter/f-inst.c"
 /* Dump line for FI_EQ */
#line 383
static inline void f_dump_line_item_FI_EQ(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 383

#line 383
{
#line 383
#define item (&(item_->i_FI_EQ))
#line 383
#undef item
#line 383
}
#line 383

#line 394 "filter/f-inst.c"
 /* Dump line for FI_LT */
#line 394
static inline void f_dump_line_item_FI_LT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 394

#line 394
{
#line 394
#define item (&(item_->i_FI_LT))
#line 394
#undef item
#line 394
}
#line 394

#line 405 "filter/f-inst.c"
 /* Dump line for FI_LTE */
#line 405
static inline void f_dump_line_item_FI_LTE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 405

#line 405
{
#line 405
#define item (&(item_->i_FI_LTE))
#line 405
#undef item
#line 405
}
#line 405

#line 410 "filter/f-inst.c"
 /* Dump line for FI_NOT */
#line 410
static inline void f_dump_line_item_FI_NOT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 410

#line 410
{
#line 410
#define item (&(item_->i_FI_NOT))
#line 410
#undef item
#line 410
}
#line 410

#line 419 "filter/f-inst.c"
 /* Dump line for FI_MATCH */
#line 419
static inline void f_dump_line_item_FI_MATCH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 419

#line 419
{
#line 419
#define item (&(item_->i_FI_MATCH))
#line 419
#undef item
#line 419
}
#line 419

#line 428 "filter/f-inst.c"
 /* Dump line for FI_NOT_MATCH */
#line 428
static inline void f_dump_line_item_FI_NOT_MATCH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 428

#line 428
{
#line 428
#define item (&(item_->i_FI_NOT_MATCH))
#line 428
#undef item
#line 428
}
#line 428

#line 433 "filter/f-inst.c"
 /* Dump line for FI_DEFINED */
#line 433
static inline void f_dump_line_item_FI_DEFINED(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 433

#line 433
{
#line 433
#define item (&(item_->i_FI_DEFINED))
#line 433
#undef item
#line 433
}
#line 433

#line 445 "filter/f-inst.c"
 /* Dump line for FI_TYPE */
#line 445
static inline void f_dump_line_item_FI_TYPE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 445

#line 445
{
#line 445
#define item (&(item_->i_FI_TYPE))
#line 445
#undef item
#line 445
}
#line 445

#line 451 "filter/f-inst.c"
 /* Dump line for FI_IS_V4 */
#line 451
static inline void f_dump_line_item_FI_IS_V4(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 451

#line 451
{
#line 451
#define item (&(item_->i_FI_IS_V4))
#line 451
#undef item
#line 451
}
#line 451

#line 460 "filter/f-inst.c"
 /* Dump line for FI_VAR_SET */
#line 460
static inline void f_dump_line_item_FI_VAR_SET(const struct f_line_item *item_, const int indent)
#line 460

#line 460
{
#line 460
#define item (&(item_->i_FI_VAR_SET))
#line 454 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 454

#line 460 "filter/f-inst.c"
#undef item
#line 460
}
#line 460

#line 467 "filter/f-inst.c"
 /* Dump line for FI_VAR_GET */
#line 467
static inline void f_dump_line_item_FI_VAR_GET(const struct f_line_item *item_, const int indent)
#line 467

#line 467
{
#line 467
#define item (&(item_->i_FI_VAR_GET))
#line 461 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 461

#line 467 "filter/f-inst.c"
#undef item
#line 467
}
#line 467

#line 480 "filter/f-inst.c"
 /* Dump line for FI_CONSTANT */
#line 480
static inline void f_dump_line_item_FI_CONSTANT(const struct f_line_item *item_, const int indent)
#line 480

#line 480
{
#line 480
#define item (&(item_->i_FI_CONSTANT))
#line 468 "filter/f-inst.c"
debug("%s" "value %s" "\n", INDENT, val_dump(&(item->val))
#line 468
    );
#line 468

#line 480 "filter/f-inst.c"
#undef item
#line 480
}
#line 480

#line 488 "filter/f-inst.c"
 /* Dump line for FI_CONDITION */
#line 488
static inline void f_dump_line_item_FI_CONDITION(const struct f_line_item *item_, const int indent)
#line 488

#line 488
{
#line 488
#define item (&(item_->i_FI_CONDITION))
#line 483 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 485 "filter/f-inst.c"
f_dump_line(item->fl3, indent + 1);
#line 488 "filter/f-inst.c"
#undef item
#line 488
}
#line 488

#line 497 "filter/f-inst.c"
 /* Dump line for FI_PRINT */
#line 497
static inline void f_dump_line_item_FI_PRINT(const struct f_line_item *item_, const int indent)
#line 497

#line 497
{
#line 497
#define item (&(item_->i_FI_PRINT))
#line 490 "filter/f-inst.c"
  debug("%snumber of varargs %u\n", INDENT, item->varcount);
#line 497 "filter/f-inst.c"
#undef item
#line 497
}
#line 497

#line 504 "filter/f-inst.c"
 /* Dump line for FI_FLUSH */
#line 504
static inline void f_dump_line_item_FI_FLUSH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 504

#line 504
{
#line 504
#define item (&(item_->i_FI_FLUSH))
#line 504
#undef item
#line 504
}
#line 504

#line 518 "filter/f-inst.c"
 /* Dump line for FI_DIE */
#line 518
static inline void f_dump_line_item_FI_DIE(const struct f_line_item *item_, const int indent)
#line 518

#line 518
{
#line 518
#define item (&(item_->i_FI_DIE))
#line 506 "filter/f-inst.c"
debug("%s" "%s" "\n", INDENT, filter_return_str(item->fret));
#line 506

#line 518 "filter/f-inst.c"
#undef item
#line 518
}
#line 518

#line 544 "filter/f-inst.c"
 /* Dump line for FI_RTA_GET */
#line 544
static inline void f_dump_line_item_FI_RTA_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 544

#line 544
{
#line 544
#define item (&(item_->i_FI_RTA_GET))
#line 544
#undef item
#line 544
}
#line 544

#line 646 "filter/f-inst.c"
 /* Dump line for FI_RTA_SET */
#line 646
static inline void f_dump_line_item_FI_RTA_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 646

#line 646
{
#line 646
#define item (&(item_->i_FI_RTA_SET))
#line 646
#undef item
#line 646
}
#line 646

#line 721 "filter/f-inst.c"
 /* Dump line for FI_EA_GET */
#line 721
static inline void f_dump_line_item_FI_EA_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 721

#line 721
{
#line 721
#define item (&(item_->i_FI_EA_GET))
#line 721
#undef item
#line 721
}
#line 721

#line 785 "filter/f-inst.c"
 /* Dump line for FI_EA_SET */
#line 785
static inline void f_dump_line_item_FI_EA_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 785

#line 785
{
#line 785
#define item (&(item_->i_FI_EA_SET))
#line 785
#undef item
#line 785
}
#line 785

#line 807 "filter/f-inst.c"
 /* Dump line for FI_EA_UNSET */
#line 807
static inline void f_dump_line_item_FI_EA_UNSET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 807

#line 807
{
#line 807
#define item (&(item_->i_FI_EA_UNSET))
#line 807
#undef item
#line 807
}
#line 807

#line 812 "filter/f-inst.c"
 /* Dump line for FI_PREF_GET */
#line 812
static inline void f_dump_line_item_FI_PREF_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 812

#line 812
{
#line 812
#define item (&(item_->i_FI_PREF_GET))
#line 812
#undef item
#line 812
}
#line 812

#line 821 "filter/f-inst.c"
 /* Dump line for FI_PREF_SET */
#line 821
static inline void f_dump_line_item_FI_PREF_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 821

#line 821
{
#line 821
#define item (&(item_->i_FI_PREF_SET))
#line 821
#undef item
#line 821
}
#line 821

#line 833 "filter/f-inst.c"
 /* Dump line for FI_LENGTH */
#line 833
static inline void f_dump_line_item_FI_LENGTH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 833

#line 833
{
#line 833
#define item (&(item_->i_FI_LENGTH))
#line 833
#undef item
#line 833
}
#line 833

#line 868 "filter/f-inst.c"
 /* Dump line for FI_NET_SRC */
#line 868
static inline void f_dump_line_item_FI_NET_SRC(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 868

#line 868
{
#line 868
#define item (&(item_->i_FI_NET_SRC))
#line 868
#undef item
#line 868
}
#line 868

#line 903 "filter/f-inst.c"
 /* Dump line for FI_NET_DST */
#line 903
static inline void f_dump_line_item_FI_NET_DST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 903

#line 903
{
#line 903
#define item (&(item_->i_FI_NET_DST))
#line 903
#undef item
#line 903
}
#line 903

#line 913 "filter/f-inst.c"
 /* Dump line for FI_ROA_MAXLEN */
#line 913
static inline void f_dump_line_item_FI_ROA_MAXLEN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 913

#line 913
{
#line 913
#define item (&(item_->i_FI_ROA_MAXLEN))
#line 913
#undef item
#line 913
}
#line 913

#line 940 "filter/f-inst.c"
 /* Dump line for FI_ASN */
#line 940
static inline void f_dump_line_item_FI_ASN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 940

#line 940
{
#line 940
#define item (&(item_->i_FI_ASN))
#line 940
#undef item
#line 940
}
#line 940

#line 945 "filter/f-inst.c"
 /* Dump line for FI_IP */
#line 945
static inline void f_dump_line_item_FI_IP(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 945

#line 945
{
#line 945
#define item (&(item_->i_FI_IP))
#line 945
#undef item
#line 945
}
#line 945

#line 952 "filter/f-inst.c"
 /* Dump line for FI_ROUTE_DISTINGUISHER */
#line 952
static inline void f_dump_line_item_FI_ROUTE_DISTINGUISHER(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 952

#line 952
{
#line 952
#define item (&(item_->i_FI_ROUTE_DISTINGUISHER))
#line 952
#undef item
#line 952
}
#line 952

#line 959 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_FIRST */
#line 959
static inline void f_dump_line_item_FI_AS_PATH_FIRST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 959

#line 959
{
#line 959
#define item (&(item_->i_FI_AS_PATH_FIRST))
#line 959
#undef item
#line 959
}
#line 959

#line 966 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_LAST */
#line 966
static inline void f_dump_line_item_FI_AS_PATH_LAST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 966

#line 966
{
#line 966
#define item (&(item_->i_FI_AS_PATH_LAST))
#line 966
#undef item
#line 966
}
#line 966

#line 971 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_LAST_NAG */
#line 971
static inline void f_dump_line_item_FI_AS_PATH_LAST_NAG(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 971

#line 971
{
#line 971
#define item (&(item_->i_FI_AS_PATH_LAST_NAG))
#line 971
#undef item
#line 971
}
#line 971

#line 976 "filter/f-inst.c"
 /* Dump line for FI_PAIR_DATA */
#line 976
static inline void f_dump_line_item_FI_PAIR_DATA(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 976

#line 976
{
#line 976
#define item (&(item_->i_FI_PAIR_DATA))
#line 976
#undef item
#line 976
}
#line 976

#line 981 "filter/f-inst.c"
 /* Dump line for FI_LC_DATA1 */
#line 981
static inline void f_dump_line_item_FI_LC_DATA1(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 981

#line 981
{
#line 981
#define item (&(item_->i_FI_LC_DATA1))
#line 981
#undef item
#line 981
}
#line 981

#line 986 "filter/f-inst.c"
 /* Dump line for FI_LC_DATA2 */
#line 986
static inline void f_dump_line_item_FI_LC_DATA2(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 986

#line 986
{
#line 986
#define item (&(item_->i_FI_LC_DATA2))
#line 986
#undef item
#line 986
}
#line 986

#line 1020 "filter/f-inst.c"
 /* Dump line for FI_MIN */
#line 1020
static inline void f_dump_line_item_FI_MIN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1020

#line 1020
{
#line 1020
#define item (&(item_->i_FI_MIN))
#line 1020
#undef item
#line 1020
}
#line 1020

#line 1054 "filter/f-inst.c"
 /* Dump line for FI_MAX */
#line 1054
static inline void f_dump_line_item_FI_MAX(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1054

#line 1054
{
#line 1054
#define item (&(item_->i_FI_MAX))
#line 1054
#undef item
#line 1054
}
#line 1054

#line 1080 "filter/f-inst.c"
 /* Dump line for FI_RETURN */
#line 1080
static inline void f_dump_line_item_FI_RETURN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1080

#line 1080
{
#line 1080
#define item (&(item_->i_FI_RETURN))
#line 1080
#undef item
#line 1080
}
#line 1080

#line 1110 "filter/f-inst.c"
 /* Dump line for FI_CALL */
#line 1110
static inline void f_dump_line_item_FI_CALL(const struct f_line_item *item_, const int indent)
#line 1110

#line 1110
{
#line 1110
#define item (&(item_->i_FI_CALL))
#line 1082 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 1082

#line 1110 "filter/f-inst.c"
#undef item
#line 1110
}
#line 1110

#line 1115 "filter/f-inst.c"
 /* Dump line for FI_DROP_RESULT */
#line 1115
static inline void f_dump_line_item_FI_DROP_RESULT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1115

#line 1115
{
#line 1115
#define item (&(item_->i_FI_DROP_RESULT))
#line 1115
#undef item
#line 1115
}
#line 1115

#line 1138 "filter/f-inst.c"
 /* Dump line for FI_SWITCH */
#line 1138
static inline void f_dump_line_item_FI_SWITCH(const struct f_line_item *item_, const int indent)
#line 1138

#line 1138
{
#line 1138
#define item (&(item_->i_FI_SWITCH))
#line 1118 "filter/f-inst.c"
debug("%s" "tree %p" "\n", INDENT, item->tree);
#line 1118

#line 1138 "filter/f-inst.c"
#undef item
#line 1138
}
#line 1138

#line 1146 "filter/f-inst.c"
 /* Dump line for FI_IP_MASK */
#line 1146
static inline void f_dump_line_item_FI_IP_MASK(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1146

#line 1146
{
#line 1146
#define item (&(item_->i_FI_IP_MASK))
#line 1146
#undef item
#line 1146
}
#line 1146

#line 1152 "filter/f-inst.c"
 /* Dump line for FI_PATH_PREPEND */
#line 1152
static inline void f_dump_line_item_FI_PATH_PREPEND(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1152

#line 1152
{
#line 1152
#define item (&(item_->i_FI_PATH_PREPEND))
#line 1152
#undef item
#line 1152
}
#line 1152

#line 1209 "filter/f-inst.c"
 /* Dump line for FI_CLIST_ADD */
#line 1209
static inline void f_dump_line_item_FI_CLIST_ADD(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1209

#line 1209
{
#line 1209
#define item (&(item_->i_FI_CLIST_ADD))
#line 1209
#undef item
#line 1209
}
#line 1209

#line 1271 "filter/f-inst.c"
 /* Dump line for FI_CLIST_DEL */
#line 1271
static inline void f_dump_line_item_FI_CLIST_DEL(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1271

#line 1271
{
#line 1271
#define item (&(item_->i_FI_CLIST_DEL))
#line 1271
#undef item
#line 1271
}
#line 1271

#line 1319 "filter/f-inst.c"
 /* Dump line for FI_CLIST_FILTER */
#line 1319
static inline void f_dump_line_item_FI_CLIST_FILTER(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1319

#line 1319
{
#line 1319
#define item (&(item_->i_FI_CLIST_FILTER))
#line 1319
#undef item
#line 1319
}
#line 1319

#line 1349 "filter/f-inst.c"
 /* Dump line for FI_ROA_CHECK_IMPLICIT */
#line 1349
static inline void f_dump_line_item_FI_ROA_CHECK_IMPLICIT(const struct f_line_item *item_, const int indent)
#line 1349

#line 1349
{
#line 1349
#define item (&(item_->i_FI_ROA_CHECK_IMPLICIT))
#line 1321 "filter/f-inst.c"
debug("%s" "route table %s" "\n", INDENT, item->rtc->name);
#line 1321

#line 1349 "filter/f-inst.c"
#undef item
#line 1349
}
#line 1349

#line 1371 "filter/f-inst.c"
 /* Dump line for FI_ROA_CHECK_EXPLICIT */
#line 1371
static inline void f_dump_line_item_FI_ROA_CHECK_EXPLICIT(const struct f_line_item *item_, const int indent)
#line 1371

#line 1371
{
#line 1371
#define item (&(item_->i_FI_ROA_CHECK_EXPLICIT))
#line 1353 "filter/f-inst.c"
debug("%s" "route table %s" "\n", INDENT, item->rtc->name);
#line 1353

#line 1371 "filter/f-inst.c"
#undef item
#line 1371
}
#line 1371

#line 1376 "filter/f-inst.c"
 /* Dump line for FI_FORMAT */
#line 1376
static inline void f_dump_line_item_FI_FORMAT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1376

#line 1376
{
#line 1376
#define item (&(item_->i_FI_FORMAT))
#line 1376
#undef item
#line 1376
}
#line 1376

#line 668 "filter/decl.m4"
 /* Dump line for FI_ASSERT */
#line 668
static inline void f_dump_line_item_FI_ASSERT(const struct f_line_item *item_, const int indent)
#line 668

#line 668
{
#line 668
#define item (&(item_->i_FI_ASSERT))
#line 1380 "filter/f-inst.c"
debug("%s" "string %s" "\n", INDENT, item->s);
#line 1380

#line 668 "filter/decl.m4"
#undef item
#line 668
}
#line 668

#line 519 "filter/decl.m4"


void f_dump_line(const struct f_line *dest, uint indent)
{
  if (!dest) {
    debug("%sNo filter line (NULL)\n", INDENT);
    return;
  }
  debug("%sFilter line %p (len=%u)\n", INDENT, dest, dest->len);
  for (uint i=0; i<dest->len; i++) {
    const struct f_line_item *item = &dest->items[i];
    debug("%sInstruction %s at line %u\n", INDENT, f_instruction_name_(item->fi_code), item->lineno);
    switch (item->fi_code) {
#line 227 "filter/f-inst.c"
 /* Dump line caller for FI_ADD */
#line 227
case FI_ADD: f_dump_line_item_FI_ADD(item, indent + 1); break;
#line 227

#line 232 "filter/f-inst.c"
 /* Dump line caller for FI_SUBTRACT */
#line 232
case FI_SUBTRACT: f_dump_line_item_FI_SUBTRACT(item, indent + 1); break;
#line 232

#line 237 "filter/f-inst.c"
 /* Dump line caller for FI_MULTIPLY */
#line 237
case FI_MULTIPLY: f_dump_line_item_FI_MULTIPLY(item, indent + 1); break;
#line 237

#line 243 "filter/f-inst.c"
 /* Dump line caller for FI_DIVIDE */
#line 243
case FI_DIVIDE: f_dump_line_item_FI_DIVIDE(item, indent + 1); break;
#line 243

#line 253 "filter/f-inst.c"
 /* Dump line caller for FI_AND */
#line 253
case FI_AND: f_dump_line_item_FI_AND(item, indent + 1); break;
#line 253

#line 264 "filter/f-inst.c"
 /* Dump line caller for FI_OR */
#line 264
case FI_OR: f_dump_line_item_FI_OR(item, indent + 1); break;
#line 264

#line 274 "filter/f-inst.c"
 /* Dump line caller for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT: f_dump_line_item_FI_PAIR_CONSTRUCT(item, indent + 1); break;
#line 274

#line 314 "filter/f-inst.c"
 /* Dump line caller for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT: f_dump_line_item_FI_EC_CONSTRUCT(item, indent + 1); break;
#line 314

#line 321 "filter/f-inst.c"
 /* Dump line caller for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT: f_dump_line_item_FI_LC_CONSTRUCT(item, indent + 1); break;
#line 321

#line 371 "filter/f-inst.c"
 /* Dump line caller for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT: f_dump_line_item_FI_PATHMASK_CONSTRUCT(item, indent + 1); break;
#line 371

#line 377 "filter/f-inst.c"
 /* Dump line caller for FI_NEQ */
#line 377
case FI_NEQ: f_dump_line_item_FI_NEQ(item, indent + 1); break;
#line 377

#line 383 "filter/f-inst.c"
 /* Dump line caller for FI_EQ */
#line 383
case FI_EQ: f_dump_line_item_FI_EQ(item, indent + 1); break;
#line 383

#line 394 "filter/f-inst.c"
 /* Dump line caller for FI_LT */
#line 394
case FI_LT: f_dump_line_item_FI_LT(item, indent + 1); break;
#line 394

#line 405 "filter/f-inst.c"
 /* Dump line caller for FI_LTE */
#line 405
case FI_LTE: f_dump_line_item_FI_LTE(item, indent + 1); break;
#line 405

#line 410 "filter/f-inst.c"
 /* Dump line caller for FI_NOT */
#line 410
case FI_NOT: f_dump_line_item_FI_NOT(item, indent + 1); break;
#line 410

#line 419 "filter/f-inst.c"
 /* Dump line caller for FI_MATCH */
#line 419
case FI_MATCH: f_dump_line_item_FI_MATCH(item, indent + 1); break;
#line 419

#line 428 "filter/f-inst.c"
 /* Dump line caller for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH: f_dump_line_item_FI_NOT_MATCH(item, indent + 1); break;
#line 428

#line 433 "filter/f-inst.c"
 /* Dump line caller for FI_DEFINED */
#line 433
case FI_DEFINED: f_dump_line_item_FI_DEFINED(item, indent + 1); break;
#line 433

#line 445 "filter/f-inst.c"
 /* Dump line caller for FI_TYPE */
#line 445
case FI_TYPE: f_dump_line_item_FI_TYPE(item, indent + 1); break;
#line 445

#line 451 "filter/f-inst.c"
 /* Dump line caller for FI_IS_V4 */
#line 451
case FI_IS_V4: f_dump_line_item_FI_IS_V4(item, indent + 1); break;
#line 451

#line 460 "filter/f-inst.c"
 /* Dump line caller for FI_VAR_SET */
#line 460
case FI_VAR_SET: f_dump_line_item_FI_VAR_SET(item, indent + 1); break;
#line 460

#line 467 "filter/f-inst.c"
 /* Dump line caller for FI_VAR_GET */
#line 467
case FI_VAR_GET: f_dump_line_item_FI_VAR_GET(item, indent + 1); break;
#line 467

#line 480 "filter/f-inst.c"
 /* Dump line caller for FI_CONSTANT */
#line 480
case FI_CONSTANT: f_dump_line_item_FI_CONSTANT(item, indent + 1); break;
#line 480

#line 488 "filter/f-inst.c"
 /* Dump line caller for FI_CONDITION */
#line 488
case FI_CONDITION: f_dump_line_item_FI_CONDITION(item, indent + 1); break;
#line 488

#line 497 "filter/f-inst.c"
 /* Dump line caller for FI_PRINT */
#line 497
case FI_PRINT: f_dump_line_item_FI_PRINT(item, indent + 1); break;
#line 497

#line 504 "filter/f-inst.c"
 /* Dump line caller for FI_FLUSH */
#line 504
case FI_FLUSH: f_dump_line_item_FI_FLUSH(item, indent + 1); break;
#line 504

#line 518 "filter/f-inst.c"
 /* Dump line caller for FI_DIE */
#line 518
case FI_DIE: f_dump_line_item_FI_DIE(item, indent + 1); break;
#line 518

#line 544 "filter/f-inst.c"
 /* Dump line caller for FI_RTA_GET */
#line 544
case FI_RTA_GET: f_dump_line_item_FI_RTA_GET(item, indent + 1); break;
#line 544

#line 646 "filter/f-inst.c"
 /* Dump line caller for FI_RTA_SET */
#line 646
case FI_RTA_SET: f_dump_line_item_FI_RTA_SET(item, indent + 1); break;
#line 646

#line 721 "filter/f-inst.c"
 /* Dump line caller for FI_EA_GET */
#line 721
case FI_EA_GET: f_dump_line_item_FI_EA_GET(item, indent + 1); break;
#line 721

#line 785 "filter/f-inst.c"
 /* Dump line caller for FI_EA_SET */
#line 785
case FI_EA_SET: f_dump_line_item_FI_EA_SET(item, indent + 1); break;
#line 785

#line 807 "filter/f-inst.c"
 /* Dump line caller for FI_EA_UNSET */
#line 807
case FI_EA_UNSET: f_dump_line_item_FI_EA_UNSET(item, indent + 1); break;
#line 807

#line 812 "filter/f-inst.c"
 /* Dump line caller for FI_PREF_GET */
#line 812
case FI_PREF_GET: f_dump_line_item_FI_PREF_GET(item, indent + 1); break;
#line 812

#line 821 "filter/f-inst.c"
 /* Dump line caller for FI_PREF_SET */
#line 821
case FI_PREF_SET: f_dump_line_item_FI_PREF_SET(item, indent + 1); break;
#line 821

#line 833 "filter/f-inst.c"
 /* Dump line caller for FI_LENGTH */
#line 833
case FI_LENGTH: f_dump_line_item_FI_LENGTH(item, indent + 1); break;
#line 833

#line 868 "filter/f-inst.c"
 /* Dump line caller for FI_NET_SRC */
#line 868
case FI_NET_SRC: f_dump_line_item_FI_NET_SRC(item, indent + 1); break;
#line 868

#line 903 "filter/f-inst.c"
 /* Dump line caller for FI_NET_DST */
#line 903
case FI_NET_DST: f_dump_line_item_FI_NET_DST(item, indent + 1); break;
#line 903

#line 913 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_MAXLEN */
#line 913
case FI_ROA_MAXLEN: f_dump_line_item_FI_ROA_MAXLEN(item, indent + 1); break;
#line 913

#line 940 "filter/f-inst.c"
 /* Dump line caller for FI_ASN */
#line 940
case FI_ASN: f_dump_line_item_FI_ASN(item, indent + 1); break;
#line 940

#line 945 "filter/f-inst.c"
 /* Dump line caller for FI_IP */
#line 945
case FI_IP: f_dump_line_item_FI_IP(item, indent + 1); break;
#line 945

#line 952 "filter/f-inst.c"
 /* Dump line caller for FI_ROUTE_DISTINGUISHER */
#line 952
case FI_ROUTE_DISTINGUISHER: f_dump_line_item_FI_ROUTE_DISTINGUISHER(item, indent + 1); break;
#line 952

#line 959 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_FIRST */
#line 959
case FI_AS_PATH_FIRST: f_dump_line_item_FI_AS_PATH_FIRST(item, indent + 1); break;
#line 959

#line 966 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_LAST */
#line 966
case FI_AS_PATH_LAST: f_dump_line_item_FI_AS_PATH_LAST(item, indent + 1); break;
#line 966

#line 971 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_LAST_NAG */
#line 971
case FI_AS_PATH_LAST_NAG: f_dump_line_item_FI_AS_PATH_LAST_NAG(item, indent + 1); break;
#line 971

#line 976 "filter/f-inst.c"
 /* Dump line caller for FI_PAIR_DATA */
#line 976
case FI_PAIR_DATA: f_dump_line_item_FI_PAIR_DATA(item, indent + 1); break;
#line 976

#line 981 "filter/f-inst.c"
 /* Dump line caller for FI_LC_DATA1 */
#line 981
case FI_LC_DATA1: f_dump_line_item_FI_LC_DATA1(item, indent + 1); break;
#line 981

#line 986 "filter/f-inst.c"
 /* Dump line caller for FI_LC_DATA2 */
#line 986
case FI_LC_DATA2: f_dump_line_item_FI_LC_DATA2(item, indent + 1); break;
#line 986

#line 1020 "filter/f-inst.c"
 /* Dump line caller for FI_MIN */
#line 1020
case FI_MIN: f_dump_line_item_FI_MIN(item, indent + 1); break;
#line 1020

#line 1054 "filter/f-inst.c"
 /* Dump line caller for FI_MAX */
#line 1054
case FI_MAX: f_dump_line_item_FI_MAX(item, indent + 1); break;
#line 1054

#line 1080 "filter/f-inst.c"
 /* Dump line caller for FI_RETURN */
#line 1080
case FI_RETURN: f_dump_line_item_FI_RETURN(item, indent + 1); break;
#line 1080

#line 1110 "filter/f-inst.c"
 /* Dump line caller for FI_CALL */
#line 1110
case FI_CALL: f_dump_line_item_FI_CALL(item, indent + 1); break;
#line 1110

#line 1115 "filter/f-inst.c"
 /* Dump line caller for FI_DROP_RESULT */
#line 1115
case FI_DROP_RESULT: f_dump_line_item_FI_DROP_RESULT(item, indent + 1); break;
#line 1115

#line 1138 "filter/f-inst.c"
 /* Dump line caller for FI_SWITCH */
#line 1138
case FI_SWITCH: f_dump_line_item_FI_SWITCH(item, indent + 1); break;
#line 1138

#line 1146 "filter/f-inst.c"
 /* Dump line caller for FI_IP_MASK */
#line 1146
case FI_IP_MASK: f_dump_line_item_FI_IP_MASK(item, indent + 1); break;
#line 1146

#line 1152 "filter/f-inst.c"
 /* Dump line caller for FI_PATH_PREPEND */
#line 1152
case FI_PATH_PREPEND: f_dump_line_item_FI_PATH_PREPEND(item, indent + 1); break;
#line 1152

#line 1209 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_ADD */
#line 1209
case FI_CLIST_ADD: f_dump_line_item_FI_CLIST_ADD(item, indent + 1); break;
#line 1209

#line 1271 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_DEL */
#line 1271
case FI_CLIST_DEL: f_dump_line_item_FI_CLIST_DEL(item, indent + 1); break;
#line 1271

#line 1319 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_FILTER */
#line 1319
case FI_CLIST_FILTER: f_dump_line_item_FI_CLIST_FILTER(item, indent + 1); break;
#line 1319

#line 1349 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_CHECK_IMPLICIT */
#line 1349
case FI_ROA_CHECK_IMPLICIT: f_dump_line_item_FI_ROA_CHECK_IMPLICIT(item, indent + 1); break;
#line 1349

#line 1371 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_CHECK_EXPLICIT */
#line 1371
case FI_ROA_CHECK_EXPLICIT: f_dump_line_item_FI_ROA_CHECK_EXPLICIT(item, indent + 1); break;
#line 1371

#line 1376 "filter/f-inst.c"
 /* Dump line caller for FI_FORMAT */
#line 1376
case FI_FORMAT: f_dump_line_item_FI_FORMAT(item, indent + 1); break;
#line 1376

#line 668 "filter/decl.m4"
 /* Dump line caller for FI_ASSERT */
#line 668
case FI_ASSERT: f_dump_line_item_FI_ASSERT(item, indent + 1); break;
#line 668

#line 532 "filter/decl.m4"

      default: bug("Unknown instruction %x in f_dump_line", item->fi_code);
    }
  }
  debug("%sFilter line %p dump done\n", INDENT, dest);
}

/* Linearize */
static uint
linearize(struct f_line *dest, const struct f_inst *what, uint pos)
{
  for ( ; what; what = what->next) {
    switch (what->fi_code) {
#line 227 "filter/f-inst.c"
 /* Linearize for FI_ADD */
#line 227
case FI_ADD: {
#line 227
#define whati (&(what->i_FI_ADD))
#line 227
#define item (&(dest->items[pos].i_FI_ADD))
#line 227
  #line 223 "filter/f-inst.c"

#line 223
pos = linearize(dest, whati->f1, pos);
#line 224 "filter/f-inst.c"

#line 224
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 227 "filter/f-inst.c"
#undef item
#line 227
  dest->items[pos].fi_code = what->fi_code;
#line 227
  dest->items[pos].lineno = what->lineno;
#line 227
  break;
#line 227
}
#line 227

#line 232 "filter/f-inst.c"
 /* Linearize for FI_SUBTRACT */
#line 232
case FI_SUBTRACT: {
#line 232
#define whati (&(what->i_FI_SUBTRACT))
#line 232
#define item (&(dest->items[pos].i_FI_SUBTRACT))
#line 232
  #line 228 "filter/f-inst.c"

#line 228
pos = linearize(dest, whati->f1, pos);
#line 229 "filter/f-inst.c"

#line 229
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 232 "filter/f-inst.c"
#undef item
#line 232
  dest->items[pos].fi_code = what->fi_code;
#line 232
  dest->items[pos].lineno = what->lineno;
#line 232
  break;
#line 232
}
#line 232

#line 237 "filter/f-inst.c"
 /* Linearize for FI_MULTIPLY */
#line 237
case FI_MULTIPLY: {
#line 237
#define whati (&(what->i_FI_MULTIPLY))
#line 237
#define item (&(dest->items[pos].i_FI_MULTIPLY))
#line 237
  #line 233 "filter/f-inst.c"

#line 233
pos = linearize(dest, whati->f1, pos);
#line 234 "filter/f-inst.c"

#line 234
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 237 "filter/f-inst.c"
#undef item
#line 237
  dest->items[pos].fi_code = what->fi_code;
#line 237
  dest->items[pos].lineno = what->lineno;
#line 237
  break;
#line 237
}
#line 237

#line 243 "filter/f-inst.c"
 /* Linearize for FI_DIVIDE */
#line 243
case FI_DIVIDE: {
#line 243
#define whati (&(what->i_FI_DIVIDE))
#line 243
#define item (&(dest->items[pos].i_FI_DIVIDE))
#line 243
  #line 238 "filter/f-inst.c"

#line 238
pos = linearize(dest, whati->f1, pos);
#line 239 "filter/f-inst.c"

#line 239
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 243 "filter/f-inst.c"
#undef item
#line 243
  dest->items[pos].fi_code = what->fi_code;
#line 243
  dest->items[pos].lineno = what->lineno;
#line 243
  break;
#line 243
}
#line 243

#line 253 "filter/f-inst.c"
 /* Linearize for FI_AND */
#line 253
case FI_AND: {
#line 253
#define whati (&(what->i_FI_AND))
#line 253
#define item (&(dest->items[pos].i_FI_AND))
#line 253
  #line 244 "filter/f-inst.c"

#line 244
pos = linearize(dest, whati->f1, pos);
#line 249 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#undef whati
#line 253 "filter/f-inst.c"
#undef item
#line 253
  dest->items[pos].fi_code = what->fi_code;
#line 253
  dest->items[pos].lineno = what->lineno;
#line 253
  break;
#line 253
}
#line 253

#line 264 "filter/f-inst.c"
 /* Linearize for FI_OR */
#line 264
case FI_OR: {
#line 264
#define whati (&(what->i_FI_OR))
#line 264
#define item (&(dest->items[pos].i_FI_OR))
#line 264
  #line 254 "filter/f-inst.c"

#line 254
pos = linearize(dest, whati->f1, pos);
#line 259 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#undef whati
#line 264 "filter/f-inst.c"
#undef item
#line 264
  dest->items[pos].fi_code = what->fi_code;
#line 264
  dest->items[pos].lineno = what->lineno;
#line 264
  break;
#line 264
}
#line 264

#line 274 "filter/f-inst.c"
 /* Linearize for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT: {
#line 274
#define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 274
#define item (&(dest->items[pos].i_FI_PAIR_CONSTRUCT))
#line 274
  #line 265 "filter/f-inst.c"

#line 265
pos = linearize(dest, whati->f1, pos);
#line 266 "filter/f-inst.c"

#line 266
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 274 "filter/f-inst.c"
#undef item
#line 274
  dest->items[pos].fi_code = what->fi_code;
#line 274
  dest->items[pos].lineno = what->lineno;
#line 274
  break;
#line 274
}
#line 274

#line 314 "filter/f-inst.c"
 /* Linearize for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT: {
#line 314
#define whati (&(what->i_FI_EC_CONSTRUCT))
#line 314
#define item (&(dest->items[pos].i_FI_EC_CONSTRUCT))
#line 314
  #line 275 "filter/f-inst.c"

#line 275
pos = linearize(dest, whati->f1, pos);
#line 276 "filter/f-inst.c"

#line 276
pos = linearize(dest, whati->f2, pos);
#line 278 "filter/f-inst.c"
item->ecs = whati->ecs;
#line 278

#undef whati
#line 314 "filter/f-inst.c"
#undef item
#line 314
  dest->items[pos].fi_code = what->fi_code;
#line 314
  dest->items[pos].lineno = what->lineno;
#line 314
  break;
#line 314
}
#line 314

#line 321 "filter/f-inst.c"
 /* Linearize for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT: {
#line 321
#define whati (&(what->i_FI_LC_CONSTRUCT))
#line 321
#define item (&(dest->items[pos].i_FI_LC_CONSTRUCT))
#line 321
  #line 315 "filter/f-inst.c"

#line 315
pos = linearize(dest, whati->f1, pos);
#line 316 "filter/f-inst.c"

#line 316
pos = linearize(dest, whati->f2, pos);
#line 317 "filter/f-inst.c"

#line 317
pos = linearize(dest, whati->f3, pos);
#undef whati
#line 321 "filter/f-inst.c"
#undef item
#line 321
  dest->items[pos].fi_code = what->fi_code;
#line 321
  dest->items[pos].lineno = what->lineno;
#line 321
  break;
#line 321
}
#line 321

#line 371 "filter/f-inst.c"
 /* Linearize for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT: {
#line 371
#define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 371
#define item (&(dest->items[pos].i_FI_PATHMASK_CONSTRUCT))
#line 371
  #line 322 "filter/f-inst.c"
  pos = linearize(dest, whati->fvar, pos);
#line 322
  item->varcount = whati->varcount;
#undef whati
#line 371 "filter/f-inst.c"
#undef item
#line 371
  dest->items[pos].fi_code = what->fi_code;
#line 371
  dest->items[pos].lineno = what->lineno;
#line 371
  break;
#line 371
}
#line 371

#line 377 "filter/f-inst.c"
 /* Linearize for FI_NEQ */
#line 377
case FI_NEQ: {
#line 377
#define whati (&(what->i_FI_NEQ))
#line 377
#define item (&(dest->items[pos].i_FI_NEQ))
#line 377
  #line 372 "filter/f-inst.c"

#line 372
pos = linearize(dest, whati->f1, pos);
#line 373 "filter/f-inst.c"

#line 373
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 377 "filter/f-inst.c"
#undef item
#line 377
  dest->items[pos].fi_code = what->fi_code;
#line 377
  dest->items[pos].lineno = what->lineno;
#line 377
  break;
#line 377
}
#line 377

#line 383 "filter/f-inst.c"
 /* Linearize for FI_EQ */
#line 383
case FI_EQ: {
#line 383
#define whati (&(what->i_FI_EQ))
#line 383
#define item (&(dest->items[pos].i_FI_EQ))
#line 383
  #line 378 "filter/f-inst.c"

#line 378
pos = linearize(dest, whati->f1, pos);
#line 379 "filter/f-inst.c"

#line 379
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 383 "filter/f-inst.c"
#undef item
#line 383
  dest->items[pos].fi_code = what->fi_code;
#line 383
  dest->items[pos].lineno = what->lineno;
#line 383
  break;
#line 383
}
#line 383

#line 394 "filter/f-inst.c"
 /* Linearize for FI_LT */
#line 394
case FI_LT: {
#line 394
#define whati (&(what->i_FI_LT))
#line 394
#define item (&(dest->items[pos].i_FI_LT))
#line 394
  #line 384 "filter/f-inst.c"

#line 384
pos = linearize(dest, whati->f1, pos);
#line 385 "filter/f-inst.c"

#line 385
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 394 "filter/f-inst.c"
#undef item
#line 394
  dest->items[pos].fi_code = what->fi_code;
#line 394
  dest->items[pos].lineno = what->lineno;
#line 394
  break;
#line 394
}
#line 394

#line 405 "filter/f-inst.c"
 /* Linearize for FI_LTE */
#line 405
case FI_LTE: {
#line 405
#define whati (&(what->i_FI_LTE))
#line 405
#define item (&(dest->items[pos].i_FI_LTE))
#line 405
  #line 395 "filter/f-inst.c"

#line 395
pos = linearize(dest, whati->f1, pos);
#line 396 "filter/f-inst.c"

#line 396
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 405 "filter/f-inst.c"
#undef item
#line 405
  dest->items[pos].fi_code = what->fi_code;
#line 405
  dest->items[pos].lineno = what->lineno;
#line 405
  break;
#line 405
}
#line 405

#line 410 "filter/f-inst.c"
 /* Linearize for FI_NOT */
#line 410
case FI_NOT: {
#line 410
#define whati (&(what->i_FI_NOT))
#line 410
#define item (&(dest->items[pos].i_FI_NOT))
#line 410
  #line 406 "filter/f-inst.c"

#line 406
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 410 "filter/f-inst.c"
#undef item
#line 410
  dest->items[pos].fi_code = what->fi_code;
#line 410
  dest->items[pos].lineno = what->lineno;
#line 410
  break;
#line 410
}
#line 410

#line 419 "filter/f-inst.c"
 /* Linearize for FI_MATCH */
#line 419
case FI_MATCH: {
#line 419
#define whati (&(what->i_FI_MATCH))
#line 419
#define item (&(dest->items[pos].i_FI_MATCH))
#line 419
  #line 411 "filter/f-inst.c"

#line 411
pos = linearize(dest, whati->f1, pos);
#line 412 "filter/f-inst.c"

#line 412
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 419 "filter/f-inst.c"
#undef item
#line 419
  dest->items[pos].fi_code = what->fi_code;
#line 419
  dest->items[pos].lineno = what->lineno;
#line 419
  break;
#line 419
}
#line 419

#line 428 "filter/f-inst.c"
 /* Linearize for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH: {
#line 428
#define whati (&(what->i_FI_NOT_MATCH))
#line 428
#define item (&(dest->items[pos].i_FI_NOT_MATCH))
#line 428
  #line 420 "filter/f-inst.c"

#line 420
pos = linearize(dest, whati->f1, pos);
#line 421 "filter/f-inst.c"

#line 421
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 428 "filter/f-inst.c"
#undef item
#line 428
  dest->items[pos].fi_code = what->fi_code;
#line 428
  dest->items[pos].lineno = what->lineno;
#line 428
  break;
#line 428
}
#line 428

#line 433 "filter/f-inst.c"
 /* Linearize for FI_DEFINED */
#line 433
case FI_DEFINED: {
#line 433
#define whati (&(what->i_FI_DEFINED))
#line 433
#define item (&(dest->items[pos].i_FI_DEFINED))
#line 433
  #line 429 "filter/f-inst.c"

#line 429
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 433 "filter/f-inst.c"
#undef item
#line 433
  dest->items[pos].fi_code = what->fi_code;
#line 433
  dest->items[pos].lineno = what->lineno;
#line 433
  break;
#line 433
}
#line 433

#line 445 "filter/f-inst.c"
 /* Linearize for FI_TYPE */
#line 445
case FI_TYPE: {
#line 445
#define whati (&(what->i_FI_TYPE))
#line 445
#define item (&(dest->items[pos].i_FI_TYPE))
#line 445
  #line 434 "filter/f-inst.c"

#line 434
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 445 "filter/f-inst.c"
#undef item
#line 445
  dest->items[pos].fi_code = what->fi_code;
#line 445
  dest->items[pos].lineno = what->lineno;
#line 445
  break;
#line 445
}
#line 445

#line 451 "filter/f-inst.c"
 /* Linearize for FI_IS_V4 */
#line 451
case FI_IS_V4: {
#line 451
#define whati (&(what->i_FI_IS_V4))
#line 451
#define item (&(dest->items[pos].i_FI_IS_V4))
#line 451
  #line 446 "filter/f-inst.c"

#line 446
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 451 "filter/f-inst.c"
#undef item
#line 451
  dest->items[pos].fi_code = what->fi_code;
#line 451
  dest->items[pos].lineno = what->lineno;
#line 451
  break;
#line 451
}
#line 451

#line 460 "filter/f-inst.c"
 /* Linearize for FI_VAR_SET */
#line 460
case FI_VAR_SET: {
#line 460
#define whati (&(what->i_FI_VAR_SET))
#line 460
#define item (&(dest->items[pos].i_FI_VAR_SET))
#line 460
  #line 453 "filter/f-inst.c"

#line 453
pos = linearize(dest, whati->f1, pos);
#line 454 "filter/f-inst.c"
item->sym = whati->sym;
#line 454

#undef whati
#line 460 "filter/f-inst.c"
#undef item
#line 460
  dest->items[pos].fi_code = what->fi_code;
#line 460
  dest->items[pos].lineno = what->lineno;
#line 460
  break;
#line 460
}
#line 460

#line 467 "filter/f-inst.c"
 /* Linearize for FI_VAR_GET */
#line 467
case FI_VAR_GET: {
#line 467
#define whati (&(what->i_FI_VAR_GET))
#line 467
#define item (&(dest->items[pos].i_FI_VAR_GET))
#line 467
  #line 461 "filter/f-inst.c"
item->sym = whati->sym;
#line 461

#undef whati
#line 467 "filter/f-inst.c"
#undef item
#line 467
  dest->items[pos].fi_code = what->fi_code;
#line 467
  dest->items[pos].lineno = what->lineno;
#line 467
  break;
#line 467
}
#line 467

#line 480 "filter/f-inst.c"
 /* Linearize for FI_CONSTANT */
#line 480
case FI_CONSTANT: {
#line 480
#define whati (&(what->i_FI_CONSTANT))
#line 480
#define item (&(dest->items[pos].i_FI_CONSTANT))
#line 480
  #line 468 "filter/f-inst.c"
item->val = whati->val;
#line 468

#undef whati
#line 480 "filter/f-inst.c"
#undef item
#line 480
  dest->items[pos].fi_code = what->fi_code;
#line 480
  dest->items[pos].lineno = what->lineno;
#line 480
  break;
#line 480
}
#line 480

#line 488 "filter/f-inst.c"
 /* Linearize for FI_CONDITION */
#line 488
case FI_CONDITION: {
#line 488
#define whati (&(what->i_FI_CONDITION))
#line 488
#define item (&(dest->items[pos].i_FI_CONDITION))
#line 488
  #line 481 "filter/f-inst.c"

#line 481
pos = linearize(dest, whati->f1, pos);
#line 483 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#line 485 "filter/f-inst.c"
item->fl3 = f_linearize(whati->f3);
#undef whati
#line 488 "filter/f-inst.c"
#undef item
#line 488
  dest->items[pos].fi_code = what->fi_code;
#line 488
  dest->items[pos].lineno = what->lineno;
#line 488
  break;
#line 488
}
#line 488

#line 497 "filter/f-inst.c"
 /* Linearize for FI_PRINT */
#line 497
case FI_PRINT: {
#line 497
#define whati (&(what->i_FI_PRINT))
#line 497
#define item (&(dest->items[pos].i_FI_PRINT))
#line 497
  #line 490 "filter/f-inst.c"
  pos = linearize(dest, whati->fvar, pos);
#line 490
  item->varcount = whati->varcount;
#undef whati
#line 497 "filter/f-inst.c"
#undef item
#line 497
  dest->items[pos].fi_code = what->fi_code;
#line 497
  dest->items[pos].lineno = what->lineno;
#line 497
  break;
#line 497
}
#line 497

#line 504 "filter/f-inst.c"
 /* Linearize for FI_FLUSH */
#line 504
case FI_FLUSH: {
#line 504
#define whati (&(what->i_FI_FLUSH))
#line 504
#define item (&(dest->items[pos].i_FI_FLUSH))
#line 504
  #undef whati
#line 504
#undef item
#line 504
  dest->items[pos].fi_code = what->fi_code;
#line 504
  dest->items[pos].lineno = what->lineno;
#line 504
  break;
#line 504
}
#line 504

#line 518 "filter/f-inst.c"
 /* Linearize for FI_DIE */
#line 518
case FI_DIE: {
#line 518
#define whati (&(what->i_FI_DIE))
#line 518
#define item (&(dest->items[pos].i_FI_DIE))
#line 518
  #line 506 "filter/f-inst.c"
item->fret = whati->fret;
#line 506

#undef whati
#line 518 "filter/f-inst.c"
#undef item
#line 518
  dest->items[pos].fi_code = what->fi_code;
#line 518
  dest->items[pos].lineno = what->lineno;
#line 518
  break;
#line 518
}
#line 518

#line 544 "filter/f-inst.c"
 /* Linearize for FI_RTA_GET */
#line 544
case FI_RTA_GET: {
#line 544
#define whati (&(what->i_FI_RTA_GET))
#line 544
#define item (&(dest->items[pos].i_FI_RTA_GET))
#line 544
  #line 520 "filter/f-inst.c"
item->sa = whati->sa;
#line 520

#undef whati
#line 544 "filter/f-inst.c"
#undef item
#line 544
  dest->items[pos].fi_code = what->fi_code;
#line 544
  dest->items[pos].lineno = what->lineno;
#line 544
  break;
#line 544
}
#line 544

#line 646 "filter/f-inst.c"
 /* Linearize for FI_RTA_SET */
#line 646
case FI_RTA_SET: {
#line 646
#define whati (&(what->i_FI_RTA_SET))
#line 646
#define item (&(dest->items[pos].i_FI_RTA_SET))
#line 646
  #line 546 "filter/f-inst.c"

#line 546
pos = linearize(dest, whati->f1, pos);
#line 547 "filter/f-inst.c"
item->sa = whati->sa;
#line 547

#undef whati
#line 646 "filter/f-inst.c"
#undef item
#line 646
  dest->items[pos].fi_code = what->fi_code;
#line 646
  dest->items[pos].lineno = what->lineno;
#line 646
  break;
#line 646
}
#line 646

#line 721 "filter/f-inst.c"
 /* Linearize for FI_EA_GET */
#line 721
case FI_EA_GET: {
#line 721
#define whati (&(what->i_FI_EA_GET))
#line 721
#define item (&(dest->items[pos].i_FI_EA_GET))
#line 721
  #line 647 "filter/f-inst.c"
item->da = whati->da;
#line 647

#undef whati
#line 721 "filter/f-inst.c"
#undef item
#line 721
  dest->items[pos].fi_code = what->fi_code;
#line 721
  dest->items[pos].lineno = what->lineno;
#line 721
  break;
#line 721
}
#line 721

#line 785 "filter/f-inst.c"
 /* Linearize for FI_EA_SET */
#line 785
case FI_EA_SET: {
#line 785
#define whati (&(what->i_FI_EA_SET))
#line 785
#define item (&(dest->items[pos].i_FI_EA_SET))
#line 785
  #line 724 "filter/f-inst.c"

#line 724
pos = linearize(dest, whati->f1, pos);
#line 725 "filter/f-inst.c"
item->da = whati->da;
#line 725

#undef whati
#line 785 "filter/f-inst.c"
#undef item
#line 785
  dest->items[pos].fi_code = what->fi_code;
#line 785
  dest->items[pos].lineno = what->lineno;
#line 785
  break;
#line 785
}
#line 785

#line 807 "filter/f-inst.c"
 /* Linearize for FI_EA_UNSET */
#line 807
case FI_EA_UNSET: {
#line 807
#define whati (&(what->i_FI_EA_UNSET))
#line 807
#define item (&(dest->items[pos].i_FI_EA_UNSET))
#line 807
  #line 786 "filter/f-inst.c"
item->da = whati->da;
#line 786

#undef whati
#line 807 "filter/f-inst.c"
#undef item
#line 807
  dest->items[pos].fi_code = what->fi_code;
#line 807
  dest->items[pos].lineno = what->lineno;
#line 807
  break;
#line 807
}
#line 807

#line 812 "filter/f-inst.c"
 /* Linearize for FI_PREF_GET */
#line 812
case FI_PREF_GET: {
#line 812
#define whati (&(what->i_FI_PREF_GET))
#line 812
#define item (&(dest->items[pos].i_FI_PREF_GET))
#line 812
  #undef whati
#line 812
#undef item
#line 812
  dest->items[pos].fi_code = what->fi_code;
#line 812
  dest->items[pos].lineno = what->lineno;
#line 812
  break;
#line 812
}
#line 812

#line 821 "filter/f-inst.c"
 /* Linearize for FI_PREF_SET */
#line 821
case FI_PREF_SET: {
#line 821
#define whati (&(what->i_FI_PREF_SET))
#line 821
#define item (&(dest->items[pos].i_FI_PREF_SET))
#line 821
  #line 814 "filter/f-inst.c"

#line 814
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 821 "filter/f-inst.c"
#undef item
#line 821
  dest->items[pos].fi_code = what->fi_code;
#line 821
  dest->items[pos].lineno = what->lineno;
#line 821
  break;
#line 821
}
#line 821

#line 833 "filter/f-inst.c"
 /* Linearize for FI_LENGTH */
#line 833
case FI_LENGTH: {
#line 833
#define whati (&(what->i_FI_LENGTH))
#line 833
#define item (&(dest->items[pos].i_FI_LENGTH))
#line 833
  #line 822 "filter/f-inst.c"

#line 822
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 833 "filter/f-inst.c"
#undef item
#line 833
  dest->items[pos].fi_code = what->fi_code;
#line 833
  dest->items[pos].lineno = what->lineno;
#line 833
  break;
#line 833
}
#line 833

#line 868 "filter/f-inst.c"
 /* Linearize for FI_NET_SRC */
#line 868
case FI_NET_SRC: {
#line 868
#define whati (&(what->i_FI_NET_SRC))
#line 868
#define item (&(dest->items[pos].i_FI_NET_SRC))
#line 868
  #line 834 "filter/f-inst.c"

#line 834
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 868 "filter/f-inst.c"
#undef item
#line 868
  dest->items[pos].fi_code = what->fi_code;
#line 868
  dest->items[pos].lineno = what->lineno;
#line 868
  break;
#line 868
}
#line 868

#line 903 "filter/f-inst.c"
 /* Linearize for FI_NET_DST */
#line 903
case FI_NET_DST: {
#line 903
#define whati (&(what->i_FI_NET_DST))
#line 903
#define item (&(dest->items[pos].i_FI_NET_DST))
#line 903
  #line 869 "filter/f-inst.c"

#line 869
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 903 "filter/f-inst.c"
#undef item
#line 903
  dest->items[pos].fi_code = what->fi_code;
#line 903
  dest->items[pos].lineno = what->lineno;
#line 903
  break;
#line 903
}
#line 903

#line 913 "filter/f-inst.c"
 /* Linearize for FI_ROA_MAXLEN */
#line 913
case FI_ROA_MAXLEN: {
#line 913
#define whati (&(what->i_FI_ROA_MAXLEN))
#line 913
#define item (&(dest->items[pos].i_FI_ROA_MAXLEN))
#line 913
  #line 904 "filter/f-inst.c"

#line 904
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 913 "filter/f-inst.c"
#undef item
#line 913
  dest->items[pos].fi_code = what->fi_code;
#line 913
  dest->items[pos].lineno = what->lineno;
#line 913
  break;
#line 913
}
#line 913

#line 940 "filter/f-inst.c"
 /* Linearize for FI_ASN */
#line 940
case FI_ASN: {
#line 940
#define whati (&(what->i_FI_ASN))
#line 940
#define item (&(dest->items[pos].i_FI_ASN))
#line 940
  #line 914 "filter/f-inst.c"

#line 914
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 940 "filter/f-inst.c"
#undef item
#line 940
  dest->items[pos].fi_code = what->fi_code;
#line 940
  dest->items[pos].lineno = what->lineno;
#line 940
  break;
#line 940
}
#line 940

#line 945 "filter/f-inst.c"
 /* Linearize for FI_IP */
#line 945
case FI_IP: {
#line 945
#define whati (&(what->i_FI_IP))
#line 945
#define item (&(dest->items[pos].i_FI_IP))
#line 945
  #line 941 "filter/f-inst.c"

#line 941
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 945 "filter/f-inst.c"
#undef item
#line 945
  dest->items[pos].fi_code = what->fi_code;
#line 945
  dest->items[pos].lineno = what->lineno;
#line 945
  break;
#line 945
}
#line 945

#line 952 "filter/f-inst.c"
 /* Linearize for FI_ROUTE_DISTINGUISHER */
#line 952
case FI_ROUTE_DISTINGUISHER: {
#line 952
#define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 952
#define item (&(dest->items[pos].i_FI_ROUTE_DISTINGUISHER))
#line 952
  #line 946 "filter/f-inst.c"

#line 946
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 952 "filter/f-inst.c"
#undef item
#line 952
  dest->items[pos].fi_code = what->fi_code;
#line 952
  dest->items[pos].lineno = what->lineno;
#line 952
  break;
#line 952
}
#line 952

#line 959 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_FIRST */
#line 959
case FI_AS_PATH_FIRST: {
#line 959
#define whati (&(what->i_FI_AS_PATH_FIRST))
#line 959
#define item (&(dest->items[pos].i_FI_AS_PATH_FIRST))
#line 959
  #line 953 "filter/f-inst.c"

#line 953
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 959 "filter/f-inst.c"
#undef item
#line 959
  dest->items[pos].fi_code = what->fi_code;
#line 959
  dest->items[pos].lineno = what->lineno;
#line 959
  break;
#line 959
}
#line 959

#line 966 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_LAST */
#line 966
case FI_AS_PATH_LAST: {
#line 966
#define whati (&(what->i_FI_AS_PATH_LAST))
#line 966
#define item (&(dest->items[pos].i_FI_AS_PATH_LAST))
#line 966
  #line 960 "filter/f-inst.c"

#line 960
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 966 "filter/f-inst.c"
#undef item
#line 966
  dest->items[pos].fi_code = what->fi_code;
#line 966
  dest->items[pos].lineno = what->lineno;
#line 966
  break;
#line 966
}
#line 966

#line 971 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_LAST_NAG */
#line 971
case FI_AS_PATH_LAST_NAG: {
#line 971
#define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 971
#define item (&(dest->items[pos].i_FI_AS_PATH_LAST_NAG))
#line 971
  #line 967 "filter/f-inst.c"

#line 967
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 971 "filter/f-inst.c"
#undef item
#line 971
  dest->items[pos].fi_code = what->fi_code;
#line 971
  dest->items[pos].lineno = what->lineno;
#line 971
  break;
#line 971
}
#line 971

#line 976 "filter/f-inst.c"
 /* Linearize for FI_PAIR_DATA */
#line 976
case FI_PAIR_DATA: {
#line 976
#define whati (&(what->i_FI_PAIR_DATA))
#line 976
#define item (&(dest->items[pos].i_FI_PAIR_DATA))
#line 976
  #line 972 "filter/f-inst.c"

#line 972
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 976 "filter/f-inst.c"
#undef item
#line 976
  dest->items[pos].fi_code = what->fi_code;
#line 976
  dest->items[pos].lineno = what->lineno;
#line 976
  break;
#line 976
}
#line 976

#line 981 "filter/f-inst.c"
 /* Linearize for FI_LC_DATA1 */
#line 981
case FI_LC_DATA1: {
#line 981
#define whati (&(what->i_FI_LC_DATA1))
#line 981
#define item (&(dest->items[pos].i_FI_LC_DATA1))
#line 981
  #line 977 "filter/f-inst.c"

#line 977
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 981 "filter/f-inst.c"
#undef item
#line 981
  dest->items[pos].fi_code = what->fi_code;
#line 981
  dest->items[pos].lineno = what->lineno;
#line 981
  break;
#line 981
}
#line 981

#line 986 "filter/f-inst.c"
 /* Linearize for FI_LC_DATA2 */
#line 986
case FI_LC_DATA2: {
#line 986
#define whati (&(what->i_FI_LC_DATA2))
#line 986
#define item (&(dest->items[pos].i_FI_LC_DATA2))
#line 986
  #line 982 "filter/f-inst.c"

#line 982
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 986 "filter/f-inst.c"
#undef item
#line 986
  dest->items[pos].fi_code = what->fi_code;
#line 986
  dest->items[pos].lineno = what->lineno;
#line 986
  break;
#line 986
}
#line 986

#line 1020 "filter/f-inst.c"
 /* Linearize for FI_MIN */
#line 1020
case FI_MIN: {
#line 1020
#define whati (&(what->i_FI_MIN))
#line 1020
#define item (&(dest->items[pos].i_FI_MIN))
#line 1020
  #line 987 "filter/f-inst.c"

#line 987
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1020 "filter/f-inst.c"
#undef item
#line 1020
  dest->items[pos].fi_code = what->fi_code;
#line 1020
  dest->items[pos].lineno = what->lineno;
#line 1020
  break;
#line 1020
}
#line 1020

#line 1054 "filter/f-inst.c"
 /* Linearize for FI_MAX */
#line 1054
case FI_MAX: {
#line 1054
#define whati (&(what->i_FI_MAX))
#line 1054
#define item (&(dest->items[pos].i_FI_MAX))
#line 1054
  #line 1021 "filter/f-inst.c"

#line 1021
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1054 "filter/f-inst.c"
#undef item
#line 1054
  dest->items[pos].fi_code = what->fi_code;
#line 1054
  dest->items[pos].lineno = what->lineno;
#line 1054
  break;
#line 1054
}
#line 1054

#line 1080 "filter/f-inst.c"
 /* Linearize for FI_RETURN */
#line 1080
case FI_RETURN: {
#line 1080
#define whati (&(what->i_FI_RETURN))
#line 1080
#define item (&(dest->items[pos].i_FI_RETURN))
#line 1080
  #line 1057 "filter/f-inst.c"

#line 1057
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1080 "filter/f-inst.c"
#undef item
#line 1080
  dest->items[pos].fi_code = what->fi_code;
#line 1080
  dest->items[pos].lineno = what->lineno;
#line 1080
  break;
#line 1080
}
#line 1080

#line 1110 "filter/f-inst.c"
 /* Linearize for FI_CALL */
#line 1110
case FI_CALL: {
#line 1110
#define whati (&(what->i_FI_CALL))
#line 1110
#define item (&(dest->items[pos].i_FI_CALL))
#line 1110
  #line 1082 "filter/f-inst.c"
item->sym = whati->sym;
#line 1082

#undef whati
#line 1110 "filter/f-inst.c"
#undef item
#line 1110
  dest->items[pos].fi_code = what->fi_code;
#line 1110
  dest->items[pos].lineno = what->lineno;
#line 1110
  break;
#line 1110
}
#line 1110

#line 1115 "filter/f-inst.c"
 /* Linearize for FI_DROP_RESULT */
#line 1115
case FI_DROP_RESULT: {
#line 1115
#define whati (&(what->i_FI_DROP_RESULT))
#line 1115
#define item (&(dest->items[pos].i_FI_DROP_RESULT))
#line 1115
  #line 1112 "filter/f-inst.c"

#line 1112
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1115 "filter/f-inst.c"
#undef item
#line 1115
  dest->items[pos].fi_code = what->fi_code;
#line 1115
  dest->items[pos].lineno = what->lineno;
#line 1115
  break;
#line 1115
}
#line 1115

#line 1138 "filter/f-inst.c"
 /* Linearize for FI_SWITCH */
#line 1138
case FI_SWITCH: {
#line 1138
#define whati (&(what->i_FI_SWITCH))
#line 1138
#define item (&(dest->items[pos].i_FI_SWITCH))
#line 1138
  #line 1116 "filter/f-inst.c"

#line 1116
pos = linearize(dest, whati->f1, pos);
#line 1118 "filter/f-inst.c"
item->tree = whati->tree;
#line 1118

#undef whati
#line 1138 "filter/f-inst.c"
#undef item
#line 1138
  dest->items[pos].fi_code = what->fi_code;
#line 1138
  dest->items[pos].lineno = what->lineno;
#line 1138
  break;
#line 1138
}
#line 1138

#line 1146 "filter/f-inst.c"
 /* Linearize for FI_IP_MASK */
#line 1146
case FI_IP_MASK: {
#line 1146
#define whati (&(what->i_FI_IP_MASK))
#line 1146
#define item (&(dest->items[pos].i_FI_IP_MASK))
#line 1146
  #line 1139 "filter/f-inst.c"

#line 1139
pos = linearize(dest, whati->f1, pos);
#line 1140 "filter/f-inst.c"

#line 1140
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1146 "filter/f-inst.c"
#undef item
#line 1146
  dest->items[pos].fi_code = what->fi_code;
#line 1146
  dest->items[pos].lineno = what->lineno;
#line 1146
  break;
#line 1146
}
#line 1146

#line 1152 "filter/f-inst.c"
 /* Linearize for FI_PATH_PREPEND */
#line 1152
case FI_PATH_PREPEND: {
#line 1152
#define whati (&(what->i_FI_PATH_PREPEND))
#line 1152
#define item (&(dest->items[pos].i_FI_PATH_PREPEND))
#line 1152
  #line 1147 "filter/f-inst.c"

#line 1147
pos = linearize(dest, whati->f1, pos);
#line 1148 "filter/f-inst.c"

#line 1148
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1152 "filter/f-inst.c"
#undef item
#line 1152
  dest->items[pos].fi_code = what->fi_code;
#line 1152
  dest->items[pos].lineno = what->lineno;
#line 1152
  break;
#line 1152
}
#line 1152

#line 1209 "filter/f-inst.c"
 /* Linearize for FI_CLIST_ADD */
#line 1209
case FI_CLIST_ADD: {
#line 1209
#define whati (&(what->i_FI_CLIST_ADD))
#line 1209
#define item (&(dest->items[pos].i_FI_CLIST_ADD))
#line 1209
  #line 1153 "filter/f-inst.c"

#line 1153
pos = linearize(dest, whati->f1, pos);
#line 1154 "filter/f-inst.c"

#line 1154
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1209 "filter/f-inst.c"
#undef item
#line 1209
  dest->items[pos].fi_code = what->fi_code;
#line 1209
  dest->items[pos].lineno = what->lineno;
#line 1209
  break;
#line 1209
}
#line 1209

#line 1271 "filter/f-inst.c"
 /* Linearize for FI_CLIST_DEL */
#line 1271
case FI_CLIST_DEL: {
#line 1271
#define whati (&(what->i_FI_CLIST_DEL))
#line 1271
#define item (&(dest->items[pos].i_FI_CLIST_DEL))
#line 1271
  #line 1210 "filter/f-inst.c"

#line 1210
pos = linearize(dest, whati->f1, pos);
#line 1211 "filter/f-inst.c"

#line 1211
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1271 "filter/f-inst.c"
#undef item
#line 1271
  dest->items[pos].fi_code = what->fi_code;
#line 1271
  dest->items[pos].lineno = what->lineno;
#line 1271
  break;
#line 1271
}
#line 1271

#line 1319 "filter/f-inst.c"
 /* Linearize for FI_CLIST_FILTER */
#line 1319
case FI_CLIST_FILTER: {
#line 1319
#define whati (&(what->i_FI_CLIST_FILTER))
#line 1319
#define item (&(dest->items[pos].i_FI_CLIST_FILTER))
#line 1319
  #line 1272 "filter/f-inst.c"

#line 1272
pos = linearize(dest, whati->f1, pos);
#line 1273 "filter/f-inst.c"

#line 1273
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1319 "filter/f-inst.c"
#undef item
#line 1319
  dest->items[pos].fi_code = what->fi_code;
#line 1319
  dest->items[pos].lineno = what->lineno;
#line 1319
  break;
#line 1319
}
#line 1319

#line 1349 "filter/f-inst.c"
 /* Linearize for FI_ROA_CHECK_IMPLICIT */
#line 1349
case FI_ROA_CHECK_IMPLICIT: {
#line 1349
#define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1349
#define item (&(dest->items[pos].i_FI_ROA_CHECK_IMPLICIT))
#line 1349
  #line 1321 "filter/f-inst.c"
item->rtc = whati->rtc;
#line 1321

#undef whati
#line 1349 "filter/f-inst.c"
#undef item
#line 1349
  dest->items[pos].fi_code = what->fi_code;
#line 1349
  dest->items[pos].lineno = what->lineno;
#line 1349
  break;
#line 1349
}
#line 1349

#line 1371 "filter/f-inst.c"
 /* Linearize for FI_ROA_CHECK_EXPLICIT */
#line 1371
case FI_ROA_CHECK_EXPLICIT: {
#line 1371
#define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1371
#define item (&(dest->items[pos].i_FI_ROA_CHECK_EXPLICIT))
#line 1371
  #line 1351 "filter/f-inst.c"

#line 1351
pos = linearize(dest, whati->f1, pos);
#line 1352 "filter/f-inst.c"

#line 1352
pos = linearize(dest, whati->f2, pos);
#line 1353 "filter/f-inst.c"
item->rtc = whati->rtc;
#line 1353

#undef whati
#line 1371 "filter/f-inst.c"
#undef item
#line 1371
  dest->items[pos].fi_code = what->fi_code;
#line 1371
  dest->items[pos].lineno = what->lineno;
#line 1371
  break;
#line 1371
}
#line 1371

#line 1376 "filter/f-inst.c"
 /* Linearize for FI_FORMAT */
#line 1376
case FI_FORMAT: {
#line 1376
#define whati (&(what->i_FI_FORMAT))
#line 1376
#define item (&(dest->items[pos].i_FI_FORMAT))
#line 1376
  #line 1372 "filter/f-inst.c"

#line 1372
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1376 "filter/f-inst.c"
#undef item
#line 1376
  dest->items[pos].fi_code = what->fi_code;
#line 1376
  dest->items[pos].lineno = what->lineno;
#line 1376
  break;
#line 1376
}
#line 1376

#line 668 "filter/decl.m4"
 /* Linearize for FI_ASSERT */
#line 668
case FI_ASSERT: {
#line 668
#define whati (&(what->i_FI_ASSERT))
#line 668
#define item (&(dest->items[pos].i_FI_ASSERT))
#line 668
  #line 1378 "filter/f-inst.c"

#line 1378
pos = linearize(dest, whati->f1, pos);
#line 1380 "filter/f-inst.c"
item->s = whati->s;
#line 1380

#undef whati
#line 668 "filter/decl.m4"
#undef item
#line 668
  dest->items[pos].fi_code = what->fi_code;
#line 668
  dest->items[pos].lineno = what->lineno;
#line 668
  break;
#line 668
}
#line 668

#line 545 "filter/decl.m4"

    }
    pos++;
  }
  return pos;
}

struct f_line *
f_linearize_concat(const struct f_inst * const inst[], uint count)
{
  uint len = 0;
  for (uint i=0; i<count; i++)
    for (const struct f_inst *what = inst[i]; what; what = what->next)
      len += what->size;

  struct f_line *out = cfg_allocz(sizeof(struct f_line) + sizeof(struct f_line_item)*len);

  for (uint i=0; i<count; i++)
    out->len = linearize(out, inst[i], out->len);

#ifdef LOCAL_DEBUG
  f_dump_line(out, 0);
#endif
  return out;
}

/* Filter line comparison */
int
f_same(const struct f_line *fl1, const struct f_line *fl2)
{
  if ((!fl1) && (!fl2))
    return 1;
  if ((!fl1) || (!fl2))
    return 0;
  if (fl1->len != fl2->len)
    return 0;
  for (uint i=0; i<fl1->len; i++) {
#define f1_ (&(fl1->items[i]))
#define f2_ (&(fl2->items[i]))
    if (f1_->fi_code != f2_->fi_code)
      return 0;
    if (f1_->flags != f2_->flags)
      return 0;

    switch(f1_->fi_code) {
#line 227 "filter/f-inst.c"
 /* Comparison for FI_ADD */
#line 227
case FI_ADD:
#line 227
#define f1 (&(f1_->i_FI_ADD))
#line 227
#define f2 (&(f2_->i_FI_ADD))
#line 227
#undef f1
#line 227
#undef f2
#line 227
break;
#line 227

#line 232 "filter/f-inst.c"
 /* Comparison for FI_SUBTRACT */
#line 232
case FI_SUBTRACT:
#line 232
#define f1 (&(f1_->i_FI_SUBTRACT))
#line 232
#define f2 (&(f2_->i_FI_SUBTRACT))
#line 232
#undef f1
#line 232
#undef f2
#line 232
break;
#line 232

#line 237 "filter/f-inst.c"
 /* Comparison for FI_MULTIPLY */
#line 237
case FI_MULTIPLY:
#line 237
#define f1 (&(f1_->i_FI_MULTIPLY))
#line 237
#define f2 (&(f2_->i_FI_MULTIPLY))
#line 237
#undef f1
#line 237
#undef f2
#line 237
break;
#line 237

#line 243 "filter/f-inst.c"
 /* Comparison for FI_DIVIDE */
#line 243
case FI_DIVIDE:
#line 243
#define f1 (&(f1_->i_FI_DIVIDE))
#line 243
#define f2 (&(f2_->i_FI_DIVIDE))
#line 243
#undef f1
#line 243
#undef f2
#line 243
break;
#line 243

#line 253 "filter/f-inst.c"
 /* Comparison for FI_AND */
#line 253
case FI_AND:
#line 253
#define f1 (&(f1_->i_FI_AND))
#line 253
#define f2 (&(f2_->i_FI_AND))
#line 249 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 253 "filter/f-inst.c"
#undef f1
#line 253
#undef f2
#line 253
break;
#line 253

#line 264 "filter/f-inst.c"
 /* Comparison for FI_OR */
#line 264
case FI_OR:
#line 264
#define f1 (&(f1_->i_FI_OR))
#line 264
#define f2 (&(f2_->i_FI_OR))
#line 259 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 264 "filter/f-inst.c"
#undef f1
#line 264
#undef f2
#line 264
break;
#line 264

#line 274 "filter/f-inst.c"
 /* Comparison for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT:
#line 274
#define f1 (&(f1_->i_FI_PAIR_CONSTRUCT))
#line 274
#define f2 (&(f2_->i_FI_PAIR_CONSTRUCT))
#line 274
#undef f1
#line 274
#undef f2
#line 274
break;
#line 274

#line 314 "filter/f-inst.c"
 /* Comparison for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT:
#line 314
#define f1 (&(f1_->i_FI_EC_CONSTRUCT))
#line 314
#define f2 (&(f2_->i_FI_EC_CONSTRUCT))
#line 278 "filter/f-inst.c"
if (f1->ecs != f2->ecs) return 0;
#line 278

#line 278

#line 314 "filter/f-inst.c"
#undef f1
#line 314
#undef f2
#line 314
break;
#line 314

#line 321 "filter/f-inst.c"
 /* Comparison for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT:
#line 321
#define f1 (&(f1_->i_FI_LC_CONSTRUCT))
#line 321
#define f2 (&(f2_->i_FI_LC_CONSTRUCT))
#line 321
#undef f1
#line 321
#undef f2
#line 321
break;
#line 321

#line 371 "filter/f-inst.c"
 /* Comparison for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT:
#line 371
#define f1 (&(f1_->i_FI_PATHMASK_CONSTRUCT))
#line 371
#define f2 (&(f2_->i_FI_PATHMASK_CONSTRUCT))
#line 322 "filter/f-inst.c"
  if (f1->varcount != f2->varcount) return 0;
#line 371 "filter/f-inst.c"
#undef f1
#line 371
#undef f2
#line 371
break;
#line 371

#line 377 "filter/f-inst.c"
 /* Comparison for FI_NEQ */
#line 377
case FI_NEQ:
#line 377
#define f1 (&(f1_->i_FI_NEQ))
#line 377
#define f2 (&(f2_->i_FI_NEQ))
#line 377
#undef f1
#line 377
#undef f2
#line 377
break;
#line 377

#line 383 "filter/f-inst.c"
 /* Comparison for FI_EQ */
#line 383
case FI_EQ:
#line 383
#define f1 (&(f1_->i_FI_EQ))
#line 383
#define f2 (&(f2_->i_FI_EQ))
#line 383
#undef f1
#line 383
#undef f2
#line 383
break;
#line 383

#line 394 "filter/f-inst.c"
 /* Comparison for FI_LT */
#line 394
case FI_LT:
#line 394
#define f1 (&(f1_->i_FI_LT))
#line 394
#define f2 (&(f2_->i_FI_LT))
#line 394
#undef f1
#line 394
#undef f2
#line 394
break;
#line 394

#line 405 "filter/f-inst.c"
 /* Comparison for FI_LTE */
#line 405
case FI_LTE:
#line 405
#define f1 (&(f1_->i_FI_LTE))
#line 405
#define f2 (&(f2_->i_FI_LTE))
#line 405
#undef f1
#line 405
#undef f2
#line 405
break;
#line 405

#line 410 "filter/f-inst.c"
 /* Comparison for FI_NOT */
#line 410
case FI_NOT:
#line 410
#define f1 (&(f1_->i_FI_NOT))
#line 410
#define f2 (&(f2_->i_FI_NOT))
#line 410
#undef f1
#line 410
#undef f2
#line 410
break;
#line 410

#line 419 "filter/f-inst.c"
 /* Comparison for FI_MATCH */
#line 419
case FI_MATCH:
#line 419
#define f1 (&(f1_->i_FI_MATCH))
#line 419
#define f2 (&(f2_->i_FI_MATCH))
#line 419
#undef f1
#line 419
#undef f2
#line 419
break;
#line 419

#line 428 "filter/f-inst.c"
 /* Comparison for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH:
#line 428
#define f1 (&(f1_->i_FI_NOT_MATCH))
#line 428
#define f2 (&(f2_->i_FI_NOT_MATCH))
#line 428
#undef f1
#line 428
#undef f2
#line 428
break;
#line 428

#line 433 "filter/f-inst.c"
 /* Comparison for FI_DEFINED */
#line 433
case FI_DEFINED:
#line 433
#define f1 (&(f1_->i_FI_DEFINED))
#line 433
#define f2 (&(f2_->i_FI_DEFINED))
#line 433
#undef f1
#line 433
#undef f2
#line 433
break;
#line 433

#line 445 "filter/f-inst.c"
 /* Comparison for FI_TYPE */
#line 445
case FI_TYPE:
#line 445
#define f1 (&(f1_->i_FI_TYPE))
#line 445
#define f2 (&(f2_->i_FI_TYPE))
#line 445
#undef f1
#line 445
#undef f2
#line 445
break;
#line 445

#line 451 "filter/f-inst.c"
 /* Comparison for FI_IS_V4 */
#line 451
case FI_IS_V4:
#line 451
#define f1 (&(f1_->i_FI_IS_V4))
#line 451
#define f2 (&(f2_->i_FI_IS_V4))
#line 451
#undef f1
#line 451
#undef f2
#line 451
break;
#line 451

#line 460 "filter/f-inst.c"
 /* Comparison for FI_VAR_SET */
#line 460
case FI_VAR_SET:
#line 460
#define f1 (&(f1_->i_FI_VAR_SET))
#line 460
#define f2 (&(f2_->i_FI_VAR_SET))
#line 454 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 454

#line 454

#line 460 "filter/f-inst.c"
#undef f1
#line 460
#undef f2
#line 460
break;
#line 460

#line 467 "filter/f-inst.c"
 /* Comparison for FI_VAR_GET */
#line 467
case FI_VAR_GET:
#line 467
#define f1 (&(f1_->i_FI_VAR_GET))
#line 467
#define f2 (&(f2_->i_FI_VAR_GET))
#line 461 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 461

#line 461

#line 467 "filter/f-inst.c"
#undef f1
#line 467
#undef f2
#line 467
break;
#line 467

#line 480 "filter/f-inst.c"
 /* Comparison for FI_CONSTANT */
#line 480
case FI_CONSTANT:
#line 480
#define f1 (&(f1_->i_FI_CONSTANT))
#line 480
#define f2 (&(f2_->i_FI_CONSTANT))
#line 468 "filter/f-inst.c"
if ( !val_same(&(f1->val), &(f2->val)) ) return 0;
#line 468

#line 468

#line 480 "filter/f-inst.c"
#undef f1
#line 480
#undef f2
#line 480
break;
#line 480

#line 488 "filter/f-inst.c"
 /* Comparison for FI_CONDITION */
#line 488
case FI_CONDITION:
#line 488
#define f1 (&(f1_->i_FI_CONDITION))
#line 488
#define f2 (&(f2_->i_FI_CONDITION))
#line 483 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 485 "filter/f-inst.c"
if (!f_same(f1->fl3, f2->fl3)) return 0;
#line 488 "filter/f-inst.c"
#undef f1
#line 488
#undef f2
#line 488
break;
#line 488

#line 497 "filter/f-inst.c"
 /* Comparison for FI_PRINT */
#line 497
case FI_PRINT:
#line 497
#define f1 (&(f1_->i_FI_PRINT))
#line 497
#define f2 (&(f2_->i_FI_PRINT))
#line 490 "filter/f-inst.c"
  if (f1->varcount != f2->varcount) return 0;
#line 497 "filter/f-inst.c"
#undef f1
#line 497
#undef f2
#line 497
break;
#line 497

#line 504 "filter/f-inst.c"
 /* Comparison for FI_FLUSH */
#line 504
case FI_FLUSH:
#line 504
#define f1 (&(f1_->i_FI_FLUSH))
#line 504
#define f2 (&(f2_->i_FI_FLUSH))
#line 504
#undef f1
#line 504
#undef f2
#line 504
break;
#line 504

#line 518 "filter/f-inst.c"
 /* Comparison for FI_DIE */
#line 518
case FI_DIE:
#line 518
#define f1 (&(f1_->i_FI_DIE))
#line 518
#define f2 (&(f2_->i_FI_DIE))
#line 506 "filter/f-inst.c"
if (f1->fret != f2->fret) return 0;
#line 506

#line 506

#line 518 "filter/f-inst.c"
#undef f1
#line 518
#undef f2
#line 518
break;
#line 518

#line 544 "filter/f-inst.c"
 /* Comparison for FI_RTA_GET */
#line 544
case FI_RTA_GET:
#line 544
#define f1 (&(f1_->i_FI_RTA_GET))
#line 544
#define f2 (&(f2_->i_FI_RTA_GET))
#line 520 "filter/f-inst.c"
if (f1->sa.sa_code != f2->sa.sa_code) return 0;
#line 520

#line 520

#line 544 "filter/f-inst.c"
#undef f1
#line 544
#undef f2
#line 544
break;
#line 544

#line 646 "filter/f-inst.c"
 /* Comparison for FI_RTA_SET */
#line 646
case FI_RTA_SET:
#line 646
#define f1 (&(f1_->i_FI_RTA_SET))
#line 646
#define f2 (&(f2_->i_FI_RTA_SET))
#line 547 "filter/f-inst.c"
if (f1->sa.sa_code != f2->sa.sa_code) return 0;
#line 547

#line 547

#line 646 "filter/f-inst.c"
#undef f1
#line 646
#undef f2
#line 646
break;
#line 646

#line 721 "filter/f-inst.c"
 /* Comparison for FI_EA_GET */
#line 721
case FI_EA_GET:
#line 721
#define f1 (&(f1_->i_FI_EA_GET))
#line 721
#define f2 (&(f2_->i_FI_EA_GET))
#line 647 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 647

#line 647

#line 721 "filter/f-inst.c"
#undef f1
#line 721
#undef f2
#line 721
break;
#line 721

#line 785 "filter/f-inst.c"
 /* Comparison for FI_EA_SET */
#line 785
case FI_EA_SET:
#line 785
#define f1 (&(f1_->i_FI_EA_SET))
#line 785
#define f2 (&(f2_->i_FI_EA_SET))
#line 725 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 725

#line 725

#line 785 "filter/f-inst.c"
#undef f1
#line 785
#undef f2
#line 785
break;
#line 785

#line 807 "filter/f-inst.c"
 /* Comparison for FI_EA_UNSET */
#line 807
case FI_EA_UNSET:
#line 807
#define f1 (&(f1_->i_FI_EA_UNSET))
#line 807
#define f2 (&(f2_->i_FI_EA_UNSET))
#line 786 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 786

#line 786

#line 807 "filter/f-inst.c"
#undef f1
#line 807
#undef f2
#line 807
break;
#line 807

#line 812 "filter/f-inst.c"
 /* Comparison for FI_PREF_GET */
#line 812
case FI_PREF_GET:
#line 812
#define f1 (&(f1_->i_FI_PREF_GET))
#line 812
#define f2 (&(f2_->i_FI_PREF_GET))
#line 812
#undef f1
#line 812
#undef f2
#line 812
break;
#line 812

#line 821 "filter/f-inst.c"
 /* Comparison for FI_PREF_SET */
#line 821
case FI_PREF_SET:
#line 821
#define f1 (&(f1_->i_FI_PREF_SET))
#line 821
#define f2 (&(f2_->i_FI_PREF_SET))
#line 821
#undef f1
#line 821
#undef f2
#line 821
break;
#line 821

#line 833 "filter/f-inst.c"
 /* Comparison for FI_LENGTH */
#line 833
case FI_LENGTH:
#line 833
#define f1 (&(f1_->i_FI_LENGTH))
#line 833
#define f2 (&(f2_->i_FI_LENGTH))
#line 833
#undef f1
#line 833
#undef f2
#line 833
break;
#line 833

#line 868 "filter/f-inst.c"
 /* Comparison for FI_NET_SRC */
#line 868
case FI_NET_SRC:
#line 868
#define f1 (&(f1_->i_FI_NET_SRC))
#line 868
#define f2 (&(f2_->i_FI_NET_SRC))
#line 868
#undef f1
#line 868
#undef f2
#line 868
break;
#line 868

#line 903 "filter/f-inst.c"
 /* Comparison for FI_NET_DST */
#line 903
case FI_NET_DST:
#line 903
#define f1 (&(f1_->i_FI_NET_DST))
#line 903
#define f2 (&(f2_->i_FI_NET_DST))
#line 903
#undef f1
#line 903
#undef f2
#line 903
break;
#line 903

#line 913 "filter/f-inst.c"
 /* Comparison for FI_ROA_MAXLEN */
#line 913
case FI_ROA_MAXLEN:
#line 913
#define f1 (&(f1_->i_FI_ROA_MAXLEN))
#line 913
#define f2 (&(f2_->i_FI_ROA_MAXLEN))
#line 913
#undef f1
#line 913
#undef f2
#line 913
break;
#line 913

#line 940 "filter/f-inst.c"
 /* Comparison for FI_ASN */
#line 940
case FI_ASN:
#line 940
#define f1 (&(f1_->i_FI_ASN))
#line 940
#define f2 (&(f2_->i_FI_ASN))
#line 940
#undef f1
#line 940
#undef f2
#line 940
break;
#line 940

#line 945 "filter/f-inst.c"
 /* Comparison for FI_IP */
#line 945
case FI_IP:
#line 945
#define f1 (&(f1_->i_FI_IP))
#line 945
#define f2 (&(f2_->i_FI_IP))
#line 945
#undef f1
#line 945
#undef f2
#line 945
break;
#line 945

#line 952 "filter/f-inst.c"
 /* Comparison for FI_ROUTE_DISTINGUISHER */
#line 952
case FI_ROUTE_DISTINGUISHER:
#line 952
#define f1 (&(f1_->i_FI_ROUTE_DISTINGUISHER))
#line 952
#define f2 (&(f2_->i_FI_ROUTE_DISTINGUISHER))
#line 952
#undef f1
#line 952
#undef f2
#line 952
break;
#line 952

#line 959 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_FIRST */
#line 959
case FI_AS_PATH_FIRST:
#line 959
#define f1 (&(f1_->i_FI_AS_PATH_FIRST))
#line 959
#define f2 (&(f2_->i_FI_AS_PATH_FIRST))
#line 959
#undef f1
#line 959
#undef f2
#line 959
break;
#line 959

#line 966 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_LAST */
#line 966
case FI_AS_PATH_LAST:
#line 966
#define f1 (&(f1_->i_FI_AS_PATH_LAST))
#line 966
#define f2 (&(f2_->i_FI_AS_PATH_LAST))
#line 966
#undef f1
#line 966
#undef f2
#line 966
break;
#line 966

#line 971 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_LAST_NAG */
#line 971
case FI_AS_PATH_LAST_NAG:
#line 971
#define f1 (&(f1_->i_FI_AS_PATH_LAST_NAG))
#line 971
#define f2 (&(f2_->i_FI_AS_PATH_LAST_NAG))
#line 971
#undef f1
#line 971
#undef f2
#line 971
break;
#line 971

#line 976 "filter/f-inst.c"
 /* Comparison for FI_PAIR_DATA */
#line 976
case FI_PAIR_DATA:
#line 976
#define f1 (&(f1_->i_FI_PAIR_DATA))
#line 976
#define f2 (&(f2_->i_FI_PAIR_DATA))
#line 976
#undef f1
#line 976
#undef f2
#line 976
break;
#line 976

#line 981 "filter/f-inst.c"
 /* Comparison for FI_LC_DATA1 */
#line 981
case FI_LC_DATA1:
#line 981
#define f1 (&(f1_->i_FI_LC_DATA1))
#line 981
#define f2 (&(f2_->i_FI_LC_DATA1))
#line 981
#undef f1
#line 981
#undef f2
#line 981
break;
#line 981

#line 986 "filter/f-inst.c"
 /* Comparison for FI_LC_DATA2 */
#line 986
case FI_LC_DATA2:
#line 986
#define f1 (&(f1_->i_FI_LC_DATA2))
#line 986
#define f2 (&(f2_->i_FI_LC_DATA2))
#line 986
#undef f1
#line 986
#undef f2
#line 986
break;
#line 986

#line 1020 "filter/f-inst.c"
 /* Comparison for FI_MIN */
#line 1020
case FI_MIN:
#line 1020
#define f1 (&(f1_->i_FI_MIN))
#line 1020
#define f2 (&(f2_->i_FI_MIN))
#line 1020
#undef f1
#line 1020
#undef f2
#line 1020
break;
#line 1020

#line 1054 "filter/f-inst.c"
 /* Comparison for FI_MAX */
#line 1054
case FI_MAX:
#line 1054
#define f1 (&(f1_->i_FI_MAX))
#line 1054
#define f2 (&(f2_->i_FI_MAX))
#line 1054
#undef f1
#line 1054
#undef f2
#line 1054
break;
#line 1054

#line 1080 "filter/f-inst.c"
 /* Comparison for FI_RETURN */
#line 1080
case FI_RETURN:
#line 1080
#define f1 (&(f1_->i_FI_RETURN))
#line 1080
#define f2 (&(f2_->i_FI_RETURN))
#line 1080
#undef f1
#line 1080
#undef f2
#line 1080
break;
#line 1080

#line 1110 "filter/f-inst.c"
 /* Comparison for FI_CALL */
#line 1110
case FI_CALL:
#line 1110
#define f1 (&(f1_->i_FI_CALL))
#line 1110
#define f2 (&(f2_->i_FI_CALL))
#line 1082 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 1082

#line 1082


#line 1085 "filter/f-inst.c"
      if (!(f1->sym->flags & SYM_FLAG_SAME))
	return 0;

    #line 1110 "filter/f-inst.c"
#undef f1
#line 1110
#undef f2
#line 1110
break;
#line 1110

#line 1115 "filter/f-inst.c"
 /* Comparison for FI_DROP_RESULT */
#line 1115
case FI_DROP_RESULT:
#line 1115
#define f1 (&(f1_->i_FI_DROP_RESULT))
#line 1115
#define f2 (&(f2_->i_FI_DROP_RESULT))
#line 1115
#undef f1
#line 1115
#undef f2
#line 1115
break;
#line 1115

#line 1138 "filter/f-inst.c"
 /* Comparison for FI_SWITCH */
#line 1138
case FI_SWITCH:
#line 1138
#define f1 (&(f1_->i_FI_SWITCH))
#line 1138
#define f2 (&(f2_->i_FI_SWITCH))
#line 1118 "filter/f-inst.c"
if (!same_tree(f1->tree, f2->tree)) return 0;
#line 1118

#line 1118

#line 1138 "filter/f-inst.c"
#undef f1
#line 1138
#undef f2
#line 1138
break;
#line 1138

#line 1146 "filter/f-inst.c"
 /* Comparison for FI_IP_MASK */
#line 1146
case FI_IP_MASK:
#line 1146
#define f1 (&(f1_->i_FI_IP_MASK))
#line 1146
#define f2 (&(f2_->i_FI_IP_MASK))
#line 1146
#undef f1
#line 1146
#undef f2
#line 1146
break;
#line 1146

#line 1152 "filter/f-inst.c"
 /* Comparison for FI_PATH_PREPEND */
#line 1152
case FI_PATH_PREPEND:
#line 1152
#define f1 (&(f1_->i_FI_PATH_PREPEND))
#line 1152
#define f2 (&(f2_->i_FI_PATH_PREPEND))
#line 1152
#undef f1
#line 1152
#undef f2
#line 1152
break;
#line 1152

#line 1209 "filter/f-inst.c"
 /* Comparison for FI_CLIST_ADD */
#line 1209
case FI_CLIST_ADD:
#line 1209
#define f1 (&(f1_->i_FI_CLIST_ADD))
#line 1209
#define f2 (&(f2_->i_FI_CLIST_ADD))
#line 1209
#undef f1
#line 1209
#undef f2
#line 1209
break;
#line 1209

#line 1271 "filter/f-inst.c"
 /* Comparison for FI_CLIST_DEL */
#line 1271
case FI_CLIST_DEL:
#line 1271
#define f1 (&(f1_->i_FI_CLIST_DEL))
#line 1271
#define f2 (&(f2_->i_FI_CLIST_DEL))
#line 1271
#undef f1
#line 1271
#undef f2
#line 1271
break;
#line 1271

#line 1319 "filter/f-inst.c"
 /* Comparison for FI_CLIST_FILTER */
#line 1319
case FI_CLIST_FILTER:
#line 1319
#define f1 (&(f1_->i_FI_CLIST_FILTER))
#line 1319
#define f2 (&(f2_->i_FI_CLIST_FILTER))
#line 1319
#undef f1
#line 1319
#undef f2
#line 1319
break;
#line 1319

#line 1349 "filter/f-inst.c"
 /* Comparison for FI_ROA_CHECK_IMPLICIT */
#line 1349
case FI_ROA_CHECK_IMPLICIT:
#line 1349
#define f1 (&(f1_->i_FI_ROA_CHECK_IMPLICIT))
#line 1349
#define f2 (&(f2_->i_FI_ROA_CHECK_IMPLICIT))
#line 1321 "filter/f-inst.c"
if (strcmp(f1->rtc->name, f2->rtc->name)) return 0;
#line 1321

#line 1321

#line 1349 "filter/f-inst.c"
#undef f1
#line 1349
#undef f2
#line 1349
break;
#line 1349

#line 1371 "filter/f-inst.c"
 /* Comparison for FI_ROA_CHECK_EXPLICIT */
#line 1371
case FI_ROA_CHECK_EXPLICIT:
#line 1371
#define f1 (&(f1_->i_FI_ROA_CHECK_EXPLICIT))
#line 1371
#define f2 (&(f2_->i_FI_ROA_CHECK_EXPLICIT))
#line 1353 "filter/f-inst.c"
if (strcmp(f1->rtc->name, f2->rtc->name)) return 0;
#line 1353

#line 1353

#line 1371 "filter/f-inst.c"
#undef f1
#line 1371
#undef f2
#line 1371
break;
#line 1371

#line 1376 "filter/f-inst.c"
 /* Comparison for FI_FORMAT */
#line 1376
case FI_FORMAT:
#line 1376
#define f1 (&(f1_->i_FI_FORMAT))
#line 1376
#define f2 (&(f2_->i_FI_FORMAT))
#line 1376
#undef f1
#line 1376
#undef f2
#line 1376
break;
#line 1376

#line 668 "filter/decl.m4"
 /* Comparison for FI_ASSERT */
#line 668
case FI_ASSERT:
#line 668
#define f1 (&(f1_->i_FI_ASSERT))
#line 668
#define f2 (&(f2_->i_FI_ASSERT))
#line 1380 "filter/f-inst.c"
if (strcmp(f1->s, f2->s)) return 0;
#line 1380

#line 1380

#line 668 "filter/decl.m4"
#undef f1
#line 668
#undef f2
#line 668
break;
#line 668

#line 590 "filter/decl.m4"

    }
  }
#undef f1_
#undef f2_
  return 1;
}


/* Part of FI_SWITCH filter iterator */
static void
f_add_tree_lines(const struct f_tree *t, void *fit_)
{
  struct filter_iterator * fit = fit_;

  if (t->data)
    BUFFER_PUSH(fit->lines) = t->data;
}

/* Filter line iterator */
void
f_add_lines(const struct f_line_item *what, struct filter_iterator *fit)
{
  switch(what->fi_code) {
#line 227 "filter/f-inst.c"
 /* Iteration for FI_ADD */
#line 227
case FI_ADD:
#line 227
#define whati (&(what->i_FI_ADD))
#line 227
#undef whati
#line 227
break;
#line 227

#line 232 "filter/f-inst.c"
 /* Iteration for FI_SUBTRACT */
#line 232
case FI_SUBTRACT:
#line 232
#define whati (&(what->i_FI_SUBTRACT))
#line 232
#undef whati
#line 232
break;
#line 232

#line 237 "filter/f-inst.c"
 /* Iteration for FI_MULTIPLY */
#line 237
case FI_MULTIPLY:
#line 237
#define whati (&(what->i_FI_MULTIPLY))
#line 237
#undef whati
#line 237
break;
#line 237

#line 243 "filter/f-inst.c"
 /* Iteration for FI_DIVIDE */
#line 243
case FI_DIVIDE:
#line 243
#define whati (&(what->i_FI_DIVIDE))
#line 243
#undef whati
#line 243
break;
#line 243

#line 253 "filter/f-inst.c"
 /* Iteration for FI_AND */
#line 253
case FI_AND:
#line 253
#define whati (&(what->i_FI_AND))
#line 249 "filter/f-inst.c"
if (whati->fl2) BUFFER_PUSH(fit->lines) = whati->fl2;
#line 253 "filter/f-inst.c"
#undef whati
#line 253
break;
#line 253

#line 264 "filter/f-inst.c"
 /* Iteration for FI_OR */
#line 264
case FI_OR:
#line 264
#define whati (&(what->i_FI_OR))
#line 259 "filter/f-inst.c"
if (whati->fl2) BUFFER_PUSH(fit->lines) = whati->fl2;
#line 264 "filter/f-inst.c"
#undef whati
#line 264
break;
#line 264

#line 274 "filter/f-inst.c"
 /* Iteration for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT:
#line 274
#define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 274
#undef whati
#line 274
break;
#line 274

#line 314 "filter/f-inst.c"
 /* Iteration for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT:
#line 314
#define whati (&(what->i_FI_EC_CONSTRUCT))
#line 314
#undef whati
#line 314
break;
#line 314

#line 321 "filter/f-inst.c"
 /* Iteration for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT:
#line 321
#define whati (&(what->i_FI_LC_CONSTRUCT))
#line 321
#undef whati
#line 321
break;
#line 321

#line 371 "filter/f-inst.c"
 /* Iteration for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT:
#line 371
#define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 371
#undef whati
#line 371
break;
#line 371

#line 377 "filter/f-inst.c"
 /* Iteration for FI_NEQ */
#line 377
case FI_NEQ:
#line 377
#define whati (&(what->i_FI_NEQ))
#line 377
#undef whati
#line 377
break;
#line 377

#line 383 "filter/f-inst.c"
 /* Iteration for FI_EQ */
#line 383
case FI_EQ:
#line 383
#define whati (&(what->i_FI_EQ))
#line 383
#undef whati
#line 383
break;
#line 383

#line 394 "filter/f-inst.c"
 /* Iteration for FI_LT */
#line 394
case FI_LT:
#line 394
#define whati (&(what->i_FI_LT))
#line 394
#undef whati
#line 394
break;
#line 394

#line 405 "filter/f-inst.c"
 /* Iteration for FI_LTE */
#line 405
case FI_LTE:
#line 405
#define whati (&(what->i_FI_LTE))
#line 405
#undef whati
#line 405
break;
#line 405

#line 410 "filter/f-inst.c"
 /* Iteration for FI_NOT */
#line 410
case FI_NOT:
#line 410
#define whati (&(what->i_FI_NOT))
#line 410
#undef whati
#line 410
break;
#line 410

#line 419 "filter/f-inst.c"
 /* Iteration for FI_MATCH */
#line 419
case FI_MATCH:
#line 419
#define whati (&(what->i_FI_MATCH))
#line 419
#undef whati
#line 419
break;
#line 419

#line 428 "filter/f-inst.c"
 /* Iteration for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH:
#line 428
#define whati (&(what->i_FI_NOT_MATCH))
#line 428
#undef whati
#line 428
break;
#line 428

#line 433 "filter/f-inst.c"
 /* Iteration for FI_DEFINED */
#line 433
case FI_DEFINED:
#line 433
#define whati (&(what->i_FI_DEFINED))
#line 433
#undef whati
#line 433
break;
#line 433

#line 445 "filter/f-inst.c"
 /* Iteration for FI_TYPE */
#line 445
case FI_TYPE:
#line 445
#define whati (&(what->i_FI_TYPE))
#line 445
#undef whati
#line 445
break;
#line 445

#line 451 "filter/f-inst.c"
 /* Iteration for FI_IS_V4 */
#line 451
case FI_IS_V4:
#line 451
#define whati (&(what->i_FI_IS_V4))
#line 451
#undef whati
#line 451
break;
#line 451

#line 460 "filter/f-inst.c"
 /* Iteration for FI_VAR_SET */
#line 460
case FI_VAR_SET:
#line 460
#define whati (&(what->i_FI_VAR_SET))
#line 460
#undef whati
#line 460
break;
#line 460

#line 467 "filter/f-inst.c"
 /* Iteration for FI_VAR_GET */
#line 467
case FI_VAR_GET:
#line 467
#define whati (&(what->i_FI_VAR_GET))
#line 467
#undef whati
#line 467
break;
#line 467

#line 480 "filter/f-inst.c"
 /* Iteration for FI_CONSTANT */
#line 480
case FI_CONSTANT:
#line 480
#define whati (&(what->i_FI_CONSTANT))
#line 480
#undef whati
#line 480
break;
#line 480

#line 488 "filter/f-inst.c"
 /* Iteration for FI_CONDITION */
#line 488
case FI_CONDITION:
#line 488
#define whati (&(what->i_FI_CONDITION))
#line 483 "filter/f-inst.c"
if (whati->fl2) BUFFER_PUSH(fit->lines) = whati->fl2;
#line 485 "filter/f-inst.c"
if (whati->fl3) BUFFER_PUSH(fit->lines) = whati->fl3;
#line 488 "filter/f-inst.c"
#undef whati
#line 488
break;
#line 488

#line 497 "filter/f-inst.c"
 /* Iteration for FI_PRINT */
#line 497
case FI_PRINT:
#line 497
#define whati (&(what->i_FI_PRINT))
#line 497
#undef whati
#line 497
break;
#line 497

#line 504 "filter/f-inst.c"
 /* Iteration for FI_FLUSH */
#line 504
case FI_FLUSH:
#line 504
#define whati (&(what->i_FI_FLUSH))
#line 504
#undef whati
#line 504
break;
#line 504

#line 518 "filter/f-inst.c"
 /* Iteration for FI_DIE */
#line 518
case FI_DIE:
#line 518
#define whati (&(what->i_FI_DIE))
#line 518
#undef whati
#line 518
break;
#line 518

#line 544 "filter/f-inst.c"
 /* Iteration for FI_RTA_GET */
#line 544
case FI_RTA_GET:
#line 544
#define whati (&(what->i_FI_RTA_GET))
#line 544
#undef whati
#line 544
break;
#line 544

#line 646 "filter/f-inst.c"
 /* Iteration for FI_RTA_SET */
#line 646
case FI_RTA_SET:
#line 646
#define whati (&(what->i_FI_RTA_SET))
#line 646
#undef whati
#line 646
break;
#line 646

#line 721 "filter/f-inst.c"
 /* Iteration for FI_EA_GET */
#line 721
case FI_EA_GET:
#line 721
#define whati (&(what->i_FI_EA_GET))
#line 721
#undef whati
#line 721
break;
#line 721

#line 785 "filter/f-inst.c"
 /* Iteration for FI_EA_SET */
#line 785
case FI_EA_SET:
#line 785
#define whati (&(what->i_FI_EA_SET))
#line 785
#undef whati
#line 785
break;
#line 785

#line 807 "filter/f-inst.c"
 /* Iteration for FI_EA_UNSET */
#line 807
case FI_EA_UNSET:
#line 807
#define whati (&(what->i_FI_EA_UNSET))
#line 807
#undef whati
#line 807
break;
#line 807

#line 812 "filter/f-inst.c"
 /* Iteration for FI_PREF_GET */
#line 812
case FI_PREF_GET:
#line 812
#define whati (&(what->i_FI_PREF_GET))
#line 812
#undef whati
#line 812
break;
#line 812

#line 821 "filter/f-inst.c"
 /* Iteration for FI_PREF_SET */
#line 821
case FI_PREF_SET:
#line 821
#define whati (&(what->i_FI_PREF_SET))
#line 821
#undef whati
#line 821
break;
#line 821

#line 833 "filter/f-inst.c"
 /* Iteration for FI_LENGTH */
#line 833
case FI_LENGTH:
#line 833
#define whati (&(what->i_FI_LENGTH))
#line 833
#undef whati
#line 833
break;
#line 833

#line 868 "filter/f-inst.c"
 /* Iteration for FI_NET_SRC */
#line 868
case FI_NET_SRC:
#line 868
#define whati (&(what->i_FI_NET_SRC))
#line 868
#undef whati
#line 868
break;
#line 868

#line 903 "filter/f-inst.c"
 /* Iteration for FI_NET_DST */
#line 903
case FI_NET_DST:
#line 903
#define whati (&(what->i_FI_NET_DST))
#line 903
#undef whati
#line 903
break;
#line 903

#line 913 "filter/f-inst.c"
 /* Iteration for FI_ROA_MAXLEN */
#line 913
case FI_ROA_MAXLEN:
#line 913
#define whati (&(what->i_FI_ROA_MAXLEN))
#line 913
#undef whati
#line 913
break;
#line 913

#line 940 "filter/f-inst.c"
 /* Iteration for FI_ASN */
#line 940
case FI_ASN:
#line 940
#define whati (&(what->i_FI_ASN))
#line 940
#undef whati
#line 940
break;
#line 940

#line 945 "filter/f-inst.c"
 /* Iteration for FI_IP */
#line 945
case FI_IP:
#line 945
#define whati (&(what->i_FI_IP))
#line 945
#undef whati
#line 945
break;
#line 945

#line 952 "filter/f-inst.c"
 /* Iteration for FI_ROUTE_DISTINGUISHER */
#line 952
case FI_ROUTE_DISTINGUISHER:
#line 952
#define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 952
#undef whati
#line 952
break;
#line 952

#line 959 "filter/f-inst.c"
 /* Iteration for FI_AS_PATH_FIRST */
#line 959
case FI_AS_PATH_FIRST:
#line 959
#define whati (&(what->i_FI_AS_PATH_FIRST))
#line 959
#undef whati
#line 959
break;
#line 959

#line 966 "filter/f-inst.c"
 /* Iteration for FI_AS_PATH_LAST */
#line 966
case FI_AS_PATH_LAST:
#line 966
#define whati (&(what->i_FI_AS_PATH_LAST))
#line 966
#undef whati
#line 966
break;
#line 966

#line 971 "filter/f-inst.c"
 /* Iteration for FI_AS_PATH_LAST_NAG */
#line 971
case FI_AS_PATH_LAST_NAG:
#line 971
#define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 971
#undef whati
#line 971
break;
#line 971

#line 976 "filter/f-inst.c"
 /* Iteration for FI_PAIR_DATA */
#line 976
case FI_PAIR_DATA:
#line 976
#define whati (&(what->i_FI_PAIR_DATA))
#line 976
#undef whati
#line 976
break;
#line 976

#line 981 "filter/f-inst.c"
 /* Iteration for FI_LC_DATA1 */
#line 981
case FI_LC_DATA1:
#line 981
#define whati (&(what->i_FI_LC_DATA1))
#line 981
#undef whati
#line 981
break;
#line 981

#line 986 "filter/f-inst.c"
 /* Iteration for FI_LC_DATA2 */
#line 986
case FI_LC_DATA2:
#line 986
#define whati (&(what->i_FI_LC_DATA2))
#line 986
#undef whati
#line 986
break;
#line 986

#line 1020 "filter/f-inst.c"
 /* Iteration for FI_MIN */
#line 1020
case FI_MIN:
#line 1020
#define whati (&(what->i_FI_MIN))
#line 1020
#undef whati
#line 1020
break;
#line 1020

#line 1054 "filter/f-inst.c"
 /* Iteration for FI_MAX */
#line 1054
case FI_MAX:
#line 1054
#define whati (&(what->i_FI_MAX))
#line 1054
#undef whati
#line 1054
break;
#line 1054

#line 1080 "filter/f-inst.c"
 /* Iteration for FI_RETURN */
#line 1080
case FI_RETURN:
#line 1080
#define whati (&(what->i_FI_RETURN))
#line 1080
#undef whati
#line 1080
break;
#line 1080

#line 1110 "filter/f-inst.c"
 /* Iteration for FI_CALL */
#line 1110
case FI_CALL:
#line 1110
#define whati (&(what->i_FI_CALL))

#line 1089 "filter/f-inst.c"
      BUFFER_PUSH(fit->lines) = whati->sym->function;

    #line 1110 "filter/f-inst.c"
#undef whati
#line 1110
break;
#line 1110

#line 1115 "filter/f-inst.c"
 /* Iteration for FI_DROP_RESULT */
#line 1115
case FI_DROP_RESULT:
#line 1115
#define whati (&(what->i_FI_DROP_RESULT))
#line 1115
#undef whati
#line 1115
break;
#line 1115

#line 1138 "filter/f-inst.c"
 /* Iteration for FI_SWITCH */
#line 1138
case FI_SWITCH:
#line 1138
#define whati (&(what->i_FI_SWITCH))

#line 1121 "filter/f-inst.c"
      tree_walk(whati->tree, f_add_tree_lines, fit);

    #line 1138 "filter/f-inst.c"
#undef whati
#line 1138
break;
#line 1138

#line 1146 "filter/f-inst.c"
 /* Iteration for FI_IP_MASK */
#line 1146
case FI_IP_MASK:
#line 1146
#define whati (&(what->i_FI_IP_MASK))
#line 1146
#undef whati
#line 1146
break;
#line 1146

#line 1152 "filter/f-inst.c"
 /* Iteration for FI_PATH_PREPEND */
#line 1152
case FI_PATH_PREPEND:
#line 1152
#define whati (&(what->i_FI_PATH_PREPEND))
#line 1152
#undef whati
#line 1152
break;
#line 1152

#line 1209 "filter/f-inst.c"
 /* Iteration for FI_CLIST_ADD */
#line 1209
case FI_CLIST_ADD:
#line 1209
#define whati (&(what->i_FI_CLIST_ADD))
#line 1209
#undef whati
#line 1209
break;
#line 1209

#line 1271 "filter/f-inst.c"
 /* Iteration for FI_CLIST_DEL */
#line 1271
case FI_CLIST_DEL:
#line 1271
#define whati (&(what->i_FI_CLIST_DEL))
#line 1271
#undef whati
#line 1271
break;
#line 1271

#line 1319 "filter/f-inst.c"
 /* Iteration for FI_CLIST_FILTER */
#line 1319
case FI_CLIST_FILTER:
#line 1319
#define whati (&(what->i_FI_CLIST_FILTER))
#line 1319
#undef whati
#line 1319
break;
#line 1319

#line 1349 "filter/f-inst.c"
 /* Iteration for FI_ROA_CHECK_IMPLICIT */
#line 1349
case FI_ROA_CHECK_IMPLICIT:
#line 1349
#define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1349
#undef whati
#line 1349
break;
#line 1349

#line 1371 "filter/f-inst.c"
 /* Iteration for FI_ROA_CHECK_EXPLICIT */
#line 1371
case FI_ROA_CHECK_EXPLICIT:
#line 1371
#define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1371
#undef whati
#line 1371
break;
#line 1371

#line 1376 "filter/f-inst.c"
 /* Iteration for FI_FORMAT */
#line 1376
case FI_FORMAT:
#line 1376
#define whati (&(what->i_FI_FORMAT))
#line 1376
#undef whati
#line 1376
break;
#line 1376

#line 668 "filter/decl.m4"
 /* Iteration for FI_ASSERT */
#line 668
case FI_ASSERT:
#line 668
#define whati (&(what->i_FI_ASSERT))
#line 668
#undef whati
#line 668
break;
#line 668

#line 614 "filter/decl.m4"

  }
}


#if defined(__GNUC__) && __GNUC__ >= 6
#pragma GCC diagnostic pop
#endif

